﻿=begin
 Copyright 2010, Jaime Díaz

 ESTE SOFTWARE SE ENTREGA "TAL CUAL", SIN NINGUNA GARANTÍA EXPRESA O IMPLÍCITA, 
 INCLUYENDO, SIN LIMITACIÓN, LAS GARANTÍAS DE COMERCIALIZACIÓN Y APTITUD 
 PARA UN PROPÓSITO PARTICULAR.
---------------------------------------------------------------------------------------------------
 Nombre        			:   Dibac 1852
 Descripción   			:   Un conjunto de herramientas para crear distribuciones en planta y 3D
 -------------------------------- CLASES ---------------------------------------------------------		  		
 ObservadorApp		:   Llama a ObservadorTools con cada nuevo documento
 ObservadorTools 	:   Sobreescribe la funcion borrar 
 Dibac       					:   Clase Raiz. Contiene procedimientos comunes.
 Borrar       					:   Borrado inteligente de elementos de dibac.
 Muro         				:   Dibuja muros en planta
 Murop        				:   Dibuja muros paralelos a una arista.
 EstiraMuro       		:   Alarga muros y realiza las conexiones con otros
 Carpinteria   				:   Clase raiz de carpinterias, contiene las propiedades comunes
 Puerta        				:	Procedimientos particulares para colocar puertas
 Ventana     				:   Procedimientos particulares para colocar ventanas
 Armario    					:   Procedimientos particulares para colocar armarios
 CotaContinua			:   Acota automaticamente distribuciones interiores y fachadas
 ImprimeDibac			:   Imprime utilizando el gestor de impresion de DibacF
 TresDimensiones		:   Crea un modelo en 3D a partir de la distribucion en planta
 Escalera						:   Dibuja escaleras generadas automaticamente o por recorrido
					
 Fecha        					:   7/08/2018
 Tipo        					:   Conjunto de Herramientas
---------------------------------------------------------------------------------------------------
=end

module Iscarnet_Extensions

module Mac
##
# Cross platform MAC address determination.  Works for:
# * /sbin/ifconfig
# * /bin/ifconfig
# * ifconfig
# * ipconfig /all
#
# To return the first MAC address on the system:
#
#   Mac.address
#
# To return an array of all MAC addresses:
#
#   Mac.address.list

  #VERSION = '1.0.0' 

  #def Mac.version() ::Mac::VERSION end

  class << self

    ##
    # Accessor for the system's first MAC address, requires a call to #address
    # first

    attr_accessor "mac_address"

    ##
    # Discovers and returns the system's MAC addresses.  Returns the first
    # MAC address, and includes an accessor #list for the remaining addresses:
    #
    #   Mac.addr # => first address
    #   Mac.addr.list # => all addresses
	

    def address
      return @mac_address if defined? @mac_address and @mac_address
      re = %r/[^:\-](?:[0-9A-F][0-9A-F][:\-]){5}[0-9A-F][0-9A-F][^:\-]/io
	
      cmds = '/sbin/ifconfig', '/bin/ifconfig', 'ifconfig', 'ipconfig /all'

		null = test(?e, '/dev/null') ? '/dev/null' : 'NUL'
		cmd = 'ipconfig /all' if Mac.win
		cmd = 'ifconfig' if Mac.mac
		regex = Regexp.compile('(..[:-]){5}..')
		lines = nil
      #cmds.each do |cmd|
		#Dir::chdir( RUBY_PLATFORM !~ /darwin/i ? "#{ENV['USERPROFILE']}/Desktop" : "~/Desktop" ){
		temp_path = File.expand_path(ENV['TMPDIR'] || ENV['TMP'] || ENV['TEMP'])
		#Sketchup.send_action "showRubyPanel:"
		#UI.messagebox(temp_path)
		#UI.messagebox(Encoding.locale_charmap)
		tempfile = File.join(temp_path, 'my_pipe')
		IO.popen("#{ cmd } 2> #{ null }>#{ tempfile }") {|fd| fd.readlines}
		#IO.popen("ipconfig/all >temp.txt") {|fd| fd.readlines}
		begin
			begin
				lines = open(tempfile, :encoding => Encoding.locale_charmap).readlines	
			rescue
				#UI.messagebox('VERSION ANTERIOR')
				lines = open(tempfile).readlines
			end	
		rescue
			lines=['00-FF-85-C0-5D-AF']
		end	
		#puts(lines)
		#stdout = %x[#{ cmd } 2> #{ null }]
		#UI.messagebox(stdout)
      #next unless stdout and stdout.size > 0
		#UI.messagebox(lines)
	   #end
      raise "all of #{ cmds.join ' ' } failed" unless lines
      raise "all of comands failed" unless lines
	
	candidates=[]
	#candidates = lines.select{|line| line =~ re}
	candidates = lines.select{|line| re.match(line)}
	#UI.messagebox ('Buscando candidatos')
	  
	#UI.messagebox('candidatos='+candidates.to_s)
   
	begin	
		raise 'no mac address candidates' unless candidates.first
		candidates.map!{|c| c[re].strip}
		maddr = candidates.first
		raise 'no mac address found' unless maddr
	
		maddr.strip!
		maddr.instance_eval{ @list = candidates; def list() @list end }
		@mac_address = maddr
	rescue
		@mac_address = '00-FF-85-C0-5D-AF'
	end
#}
end
    ##
    # Shorter alias for #address

    alias_method "addr", "address"
end
	
	module_function
	def mac; @mac end
	def mac= v; @mac = v end
	def win; @win end
	def win= v; @win = v end

	#Mac.mac =( Object::RUBY_PLATFORM =~ /darwin/i ? true : false ) 
	#Mac.win =((Object::RUBY_PLATFORM =~ /mswin/i || Object::RUBY_PLATFORM =~ /mingw/i) ? true : false ) 
	Mac.mac = Sketchup.platform == :platform_osx
	Mac.win = Sketchup.platform == :platform_win
	
end # del moculo Mac

module Dibac_Extension

require "sketchup" 
require "extensions"
#require @@current_path+'/rubygems/axlsx.rb' MAL __FiLE__

class Dibac_Lenguaje

def initialize
    @strings =Hash.new
    self.ParseLangFile
	#iscarnet_dibac=nil
	#Sketchup.extensions.each{|e| iscarnet_dibac=e if e.name=='Dibac'}
  end

def ParseLangFile
	@strings.clear
	file_rec = Sketchup.find_support_file("Dibac.strings", "plugins//iscarnet_dibac"+"//resources//"+(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2])))
    if file_rec==nil || file_rec.length==0
      return false
    end
    langFile = File.open(file_rec, "r")
    entryString = ""
    inComment = false

    langFile.each do |line|
      #ignore simple comment lines - BIG assumption the whole line is a comment
      if !line.include?("//")
        #also ignore comment blocks
        if line.include?("/*")
          inComment = true
        end

        if inComment==true
          if line.include?("*/")
            inComment=false
          end
        else
          entryString += line
        end
      end

      if entryString.include?(";")
        #parse the string into key and value
        
        #remove the white space
        entryString.strip!

        #pull out the key
        keyvalue = entryString.split("\"=\"")
        
        #strip the leading quotation out
        key = keyvalue[0][(keyvalue[0].index("\"")+1)..(keyvalue[0].length+1)]
		result=keyvalue[1].to_s
 		#pull out the value
		result.gsub!(";", "")
        value = result.gsub("\"", "") 

        #add to @strings
        @strings[key]=value
        entryString = ""
      end
    end
	langFile.close
	Iscarnet_Dibac.description =GetString('Plugin for architectural drawing.')
    return true
  end

def GetString(key)
    #puts "GetString key = " + key.to_s
    retval = @strings[key]
    #puts "GetString retval = " + retval.to_s

    if retval!= nil
         retval.chomp!
    else
        retval = key
    end
    return retval
  end

def unchecked(menu, item) # lo metemos aqui para aprovechar el objeto DibacStrings
	menu.set_validation_proc(item)  {
		MF_UNCHECKED
	}
end

end #de la clase Dibac_Lenguaje

class Dibac_Licencia  
	
def ord(caracter)
	begin
		return caracter.ord
	rescue
		return caracter
	end	
end
	
def sacaclave(texto)	
#---------------------------------------------------------------------------------	
	modulo =129 #modulo para cambiar generacion de numeros
#---------------------------------------------------------------------------------	
	return '' if(texto==nil || texto=='')
	aleatorio1=ord(texto[0]) % modulo
	aleatorio2=ord(texto[texto.length-1]) % modulo
	i=0
	clave=''
	a=(aleatorio2 + modulo).chr
	while i<texto.length do
		a <<(aleatorio1+ord(texto[i]) % modulo).chr
		a <<(aleatorio2 + ord(a[2*i+1]) % modulo).chr
		i +=1
	end
	jj=0
	i=1
	j=(a.length)/11
	if a.length>10
		while i+j<a.length do
			for ii in 0 ... j 
				jj=jj+ord(a[i-1])
				i+=1
			end
			jj=jj % 10
			jj +=39 if jj>9
			clave=clave+(jj+48).chr
		end	
	end 
	return clave
end

def licencia (grabar)
	usuario=nil
	# PRUEBA DE LICENCIAS SKETCHUP
=begin
	ext_id="2f3604f-c33d-424f-a118-92a207765be4"
	if Sketchup.version_number > 15001000
		ext_lic = Sketchup::Licensing.get_extension_license(ext_id)
		if ext_lic.licensed?
			usuario ="Sketchup"
			email=""
			numserie="Sketchup"
		end	
	end
=end
	if !usuario
	#puts "No hay licencia Sketchup"
	usuario		= "Jaime Díaz"
	email		= "jaimedíaz@dibac.com"
	numserie	= "18572"
	clave		= "1"
	defaultkey	= "18572"
	defaultkeyid	= "1"
	num1="18572"
	num2="18572"
=begin	
	begin
		user_path = File.expand_path(ENV['APPDATA'] || ENV['APP'] || ENV['APLICATIONDATA'])
	rescue
		user_path = '~/Library/Application Support'
	end	
	Dir.mkdir(user_path+'/dibac') unless File.exists?(user_path+'/dibac')
	user_path=File.join(user_path,'dibac')
	if !File.exists?(File.join(user_path,'dibac_cotal.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_DOOR.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_door.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_WINDOW.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_window.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_WARDROBE.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_wardrobe.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_TABLE.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_table.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_DOOR_OPENING.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_door_opening.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_WINDOW_OPENING.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_window_opening.skp'))
		definicion=Sketchup.active_model.definitions.load (Sketchup.find_support_file("DIBAC_COTAL.skp","Plugins/iscarnet_dibac"))
		definicion.save_as(File.join(user_path, 'dibac_cotal.skp'))
		if ((num1 == numserie) && (num2 == defaultkey)) #Hay licencia
			definicion.set_attribute('dibac','user',usuario)
			definicion.set_attribute('dibac','email',email)
			definicion. ,'serial',numserie)
			definicion.set_attribute('dibac','key',clave)
			definicion.save_as(File.join(user_path, 'dibac_cotal.skp'))
		end
	end
	if((num1 != numserie) || (num2 != defaultkey))
		definicion=Sketchup.active_model.definitions.load(File.join(user_path, 'dibac_cotal.skp'))
		usuario=definicion.get_attribute('dibac','user','')
		email=definicion.get_attribute('dibac','email','')
		numserie=definicion.get_attribute('dibac','serial','')
		clave=definicion.get_attribute('dibac','key','')
		num1=sacaclave(email+DibacMac)
		num2=sacaclave(num1)
		if ((num1 == numserie) && (num2 == defaultkey)) #recupera la licencia
			Sketchup.write_default("Dibac","User",usuario)
			Sketchup.write_default("Dibac","Email",email)
			Sketchup.write_default("Dibac","Serial",numserie)
			Sketchup.write_default("Dibac","Key",clave)
		end	
	end
	end
=end	
	#return [usuario,email,numserie,clave,defaultkeyid] #quitada proteccion
	if((num1 != numserie) || (num2 != defaultkey))
		if numserie != ""
			usuario		= ""
			#Sketchup.write_default("Dibac","User","")
			email		= ""
			#Sketchup.write_default("Dibac","Email","")
			numserie	= ""
			#Sketchup.write_default("Dibac","Serial","")
			clave=""
			#Sketchup.write_default("Dibac","Key","")
			defaultkey=""
			num1=sacaclave(email+DibacMac)
			num2=sacaclave(num1)
		end
		if (defaultkeyid.to_i-num2.to_i).abs > 57600 || defaultkeyid.to_i-num2.to_i < 0
			defaultkeyid = num2
			grabar=true
		end	 
		tiempo_uso = (Time.now - DibacHoraInicio).to_i
		tiempo_tope = (num2.to_i  + 57600) #16 horas
		tiempo_actual = defaultkeyid.to_i
		if tiempo_actual < tiempo_tope
			acumulado= tiempo_actual+tiempo_uso
			acumulado= tiempo_tope if acumulado > tiempo_tope
			Sketchup.write_default("PrefsOpt","ValidDefaultKeyId", acumulado.to_s) if grabar
			numserie='promo' 
			diff = (tiempo_tope-acumulado)
			seconds = diff % 60
			minutes = (diff / 60) % 60
			hours = diff / 3600
			defaultkeyid= hours.to_s+':'+minutes.to_s+':'+seconds.to_s	
		else
			numserie = ""
			defaultkey=""
		end
	end
	end#prueba de licencia Sketchup
	return [usuario,email,numserie,clave,defaultkeyid]
end

def informacion(datoslicencia)
	usuario=datoslicencia[0]
	email=datoslicencia[1]
	numserie=datoslicencia[2]
	clave=datoslicencia[3]
	defaultkeyid=datoslicencia[4]
	texto=DibacStrings.GetString('Dibac for Sketchup')+"\n" + Iscarnet_Dibac.description + "\n"
	if numserie == 'promo'
		texto=texto + DibacStrings.GetString("Promotional license")+"  ("+defaultkeyid+")"
	elsif clave != '' 
		texto = texto + DibacStrings.GetString('User') + ": " + usuario + " - " + email + "\n"
		texto=texto + DibacStrings.GetString('Serial number') + ": " + numserie
	else
		texto=texto+DibacStrings.GetString("Sorry. Your promotional license has expired.")+"\n"
		texto=texto+DibacStrings.GetString("Please contact your dealer.")+"\n"+"www.dibac.com"
	end	
	UI.messagebox(texto)
end

end #de la clase Dibac_Licencia

class Dibac_ObservadorDefiniciones < Sketchup::DefinitionsObserver

def onComponentRemoved(definitions, definition)
   #UI.messagebox("Borrado: " + definition.name + '('+definition.entities.count.to_s+')'+definitions.count.to_s)
 end

end # de la clase ObservadorDefiniciones

class Dibac_ObservadorModel < Sketchup::ModelObserver

def recupera_bloques
	defs=[]
	undo=true
	Sketchup.active_model.definitions.each do |d|
		atributo=nil
		esta=d.get_attribute 'dibac','2d'
		atributo='2d' if esta
		if !esta
			esta=d.get_attribute 'dibac','3d'
			atributo='3d' if esta
		end
		defs.push(esta[0])if atributo
	end	
	defs.uniq!
	defs.each do |d|
		if File.exist?(d)
			Sketchup.active_model.start_operation('Recuperando', true, true, true) if undo #arreglado bug splat
			undo=false
			Sketchup.active_model.definitions.load(d) 
		else
			current_path = File.dirname(__FILE__)
				if current_path.respond_to?(:force_encoding)
					current_path.force_encoding("UTF-8")
				end
			Sketchup.active_model.start_operation('Recuperando', true, true, true) if undo  #arreglado bug splat
			undo=false
			Sketchup.active_model.definitions.load(current_path+'/model/'+File.basename(d))
		end
	end
end

def onActivePathChanged(model)
	#SeccionSolida.cambio(SS_Extension.seccion) if SS_Extension.seccion
	#SeccionSolida.borrar(SS_Extension.borrar) if SS_Extension.borrar
	return if Dibac_Extension.paths.include?(model.active_entities)
	Dibac_Extension.paths= model.active_entities #añade el entities al path
	model.active_entities.add_observer(Dibac_ObservadorEntities.new)
	SeccionSolida.iniciosecciones
end

def onPreSaveModel(model)
	recupera_bloques
 end

end # de la clase ObservadorModel

class Dibac_ObservadorEntities < Sketchup::EntitiesObserver

def modificado(entity, trinicial) #recursivo
	return if entity.deleted?
	entidades=entity.entities if entity.is_a?(Sketchup::Group)
	entidades=entity.definition.entities if entity.is_a?(Sketchup::ComponentInstance)
	return if !entidades
	entidades.each{|e| modificado(e,e.transformation*trinicial.inverse) if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)}
	scalex=entity.definition.get_attribute('dynamic_attributes','dibacscalex') if entity.is_a?(Sketchup::ComponentInstance)
	return if !scalex
	tr=entity.transformation
	sx=(tr.to_a[0]**2+tr.to_a[1]**2+tr.to_a[2]**2)**0.5
	sy=(tr.to_a[4]**2+tr.to_a[5]**2+tr.to_a[6]**2)**0.5
	sz=(tr.to_a[8]**2+tr.to_a[9]**2+tr.to_a[10]**2)**0.5
	vector=trinicial.xaxis.transform(Geom::Transformation.rotation([0,0,0], trinicial.zaxis, Math::PI/2))
	trans=Geom::Transformation.scaling(-1/sx ,1/sy,1/sz) if vector != trinicial.yaxis
	entity.transformation=tr*trans if trans
end

def onElementAdded(entities, entity)
	#UI.start_timer(0.01,false) {modificado(entity, entity.transformation) if !entity.deleted? && (entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group))}
	if !entity.deleted? 
		if entity.is_a?(Sketchup::SectionPlane)
			entity.add_observer(Dibac_ObservadorSeccion.new)
			UI.start_timer(0.01,false){SeccionSolida.face(nil, entity, false)} if SeccionSolida.activar(false)# if DibacLicencia.licencia(false)[2] != "" if !SeccionSolida.buscaseccion(entity)}
		end
		modificado(entity, entity.transformation) if (entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group))
	end	
end

def onActiveSectionPlaneChanged(entities)
	sp=entities.active_section_plane
	SeccionSolida.cambio_seccion(sp) 
end

def onElementModified(entities, entity)
	#UI.start_timer(0.01,false) {modificado(entity, entity.transformation) if !entity.deleted? && (entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group))}
	modificado(entity, entity.transformation) if !entity.deleted? && (entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group))
end

end #de la clase ObservadorEntities

class Dibac_ObservadorView < Sketchup::ViewObserver
	def onViewChanged(view)
		Dibac_Extension.cambio_view= true
    end
end

class Dibac_ObservadorApp < Sketchup::AppObserver

def onNewModel(model)
	model.definitions.add_observer(Dibac_ObservadorDefiniciones.new)
	model.tools.add_observer(Dibac_ObservadorTools.new)
	model.tools.add_observer(Dibac_ObservadorDefiniciones.new)
	model.active_view.add_observer(Dibac_ObservadorView.new)
	#model.active_entities.add_observer(Dibac_ObservadorEntities.new) ¿¿¿¿?????
	model.add_observer(Dibac_ObservadorModel.new)
	Dibac_Extension.paths!
	model.entities.add_observer(Dibac_ObservadorEntities.new)
	SeccionSolida.iniciosecciones
	#borramos todos los archivos del directorio model.
	current_path = File.dirname(__FILE__)
	if current_path.respond_to?(:force_encoding)
		current_path.force_encoding("UTF-8")
	end
	Dir.foreach(current_path+"/model") {|f| File.delete(current_path+"/model/"+f) if f != '.' && f != '..'}
	Dibac_Inicio.salva_bloques(nil, current_path+'/model/')
	#Dibac_Extension.esquema!
end

def onOpenModel(model)
	model.tools.add_observer(Dibac_ObservadorTools.new)
	model.tools.add_observer(Dibac_ObservadorDefiniciones.new)
	model.add_observer(Dibac_ObservadorModel.new)
	SeccionSolida.iniciosecciones
	model.active_view.add_observer(Dibac_ObservadorView.new)
	Dibac_Extension.paths!
	model.entities.add_observer(Dibac_ObservadorEntities.new)
	#borramos todos los archivos del directorio model.
	current_path = File.dirname(__FILE__)
	if current_path.respond_to?(:force_encoding)
		current_path.force_encoding("UTF-8")
	end
	Dir.foreach(current_path+"/model") {|f| File.delete(current_path+"/model/"+f) if f != '.' && f != '..'}	
	UI.start_timer(0.0001,false){Dibac_Inicio.salva_bloques(nil, current_path+'/model/')}
	#Dibac_Extension.esquema!
	#Dibac_Extension.esquema.show
end

def onQuit()
	DibacLicencia.licencia(true)
end


end # de la clase Dibac_ObservadorApp
 
class Dibac_ObservadorTools < Sketchup::ToolsObserver

def onActiveToolChanged(tools, tool_name, tool_id)
	# Aqui metemos la licencia por horas
	Sketchup.active_model.select_tool Dibac_Borrar.new if tool_id == 21019
end

end # de la clase Dibac_ObservadorTools

class Dibac_ObservadorSeccion < Sketchup::EntityObserver

def onChangeEntity(entity)
	#Sketchup.active_model.select_tool SeccionSolida.cambio(entity)
	#SS_Extension.seccion=entity
	UI.start_timer(0.001,false) {SeccionSolida.cambio(entity)}	
	#SeccionSolida.cambio(entity)	
end	
	
def onEraseEntity(entity) 
	#SS_Extension.borrar=entity
	UI.start_timer(0.001,false) {SeccionSolida.borrar(entity)}	
end	
end # de la clase ObservadorSeccion

class Dibac_ObservadorDefiniciones< Sketchup::DefinitionsObserver

def onComponentAdded(definitions, definition)
   #puts("Añadido: " + definition.name) if !definition.deleted?
end

def onComponentPropertiesChanged(definitions, definition)
   #UI.messagebox("Cambiado: " + definition.name) if !definition.deleted?
end

end # de la clase Dibac_ObservadorDefiniciones

class Dibac_Inicio  #Aqui inicializamos las variables de clase

def conexion_valida
	return false
	return true if Sketchup.is_online
	UI.messagebox(DibacStrings.GetString("No Internet connection"))
	return false	
end

def datos_licencia(grabar)
	datoslicencia=DibacLicencia.licencia(grabar) 
	begin
		@@usuario=datoslicencia[0].force_encoding("UTF-8")
	rescue
		@@usuario=datoslicencia[0]
	end	
	@@email=datoslicencia[1]
	@@numserie=datoslicencia[2]
	@@clave=datoslicencia[3]
	@@defaultkey=datoslicencia[4]
	@@datoslicencia=[@@usuario,@@email,@@numserie,@@clave,@@defaultkey]
end

def licencia_autorizar
	return false if !conexion_valida
	prompts = 	[	DibacStrings.GetString("User")+":",
							DibacStrings.GetString("E_mail")+":",
							#DibacStrings.GetString("Serial number")+":",
							DibacStrings.GetString("Authorization number")+":     "
						]
						
	defaults = 	[Sketchup.read_default("Dibac","User",""),
							 Sketchup.read_default("Dibac","Email",""),
							#"",
							 Sketchup.read_default("Dibac","Key","")
						]
						
	list = 			[	"",
							"",
							#"",
							""
						]
	input = UI.inputbox prompts, defaults, list,DibacStrings.GetString("Dibac for Sketchup")+": "+DibacStrings.GetString("User License")
	if input
		usuario=input[0].to_s
		email=input[1].to_s
		numserie=DibacLicencia.sacaclave(input[1].to_s+DibacMac)
		defaultkey=DibacLicencia.sacaclave(numserie)
		clave=input[2].to_s
		wd=UI::WebDialog.new(DibacStrings.GetString("Authorize")+'...')
		param='request=activation'
		param=param+'&email='+email
		param=param+'&licence_key='+clave
		param=param+'&product_id=2015DIBAC'
		param=param+'&instance='+numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-2015dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			#UI.messagebox('Respuesta del servidor: '+mensaje)
			if mensaje[10..20].index('true')
				texto=DibacStrings.GetString("Your license has been activated successfully. Thank you.")
				Sketchup.write_default("Dibac","User",usuario)
				Sketchup.write_default("Dibac","Email",email)
				Sketchup.write_default("Dibac","Serial",numserie)
				Sketchup.write_default("Dibac","Key",clave)
				Sketchup.write_default("PrefsOpt","ValidDefaultKey",defaultkey)
=begin
				user_path = File.expand_path(ENV['APPDATA'] || ENV['APP'] || ENV['APLICATIONDATA'])
				user_path=File.join(user_path,'dibac')
				definicion=Sketchup.active_model.definitions.load(File.join(user_path, 'dibac_cotal.skp'))
				definicion.set_attribute('dibac','user',usuario)
				definicion.set_attribute('dibac','email',email)
				definicion.set_attribute('dibac','serial',numserie)
				definicion.set_attribute('dibac','key',clave)
				definicion.save_as(File.join(user_path, 'dibac_cotal.skp'))
=end
				datos_licencia(false)
			elsif  mensaje[8..20].index('Exceeded')
				texto=DibacStrings.GetString("Unable to activate license: no more activations available.")
			else
				texto=DibacStrings.GetString("Invalid license. Please check the email and auth number and try again.")
				texto=texto+13.chr+13.chr+mensaje
			end	
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}
	end
end	

def licencia_desautorizar
	return false if !conexion_valida
	texto = DibacStrings.GetString("You are about to remove the authorization to use")+' '+DibacStrings.GetString('Dibac for Sketchup')
	texto=texto+'. '+DibacStrings.GetString("You can not run again if the product does not authorize a valid license.")+"\n"
	texto=texto+' '+DibacStrings.GetString("Are you sure you want to continue?")
	if UI.messagebox(texto, MB_YESNO) == 6 then
		wd=UI::WebDialog.new(DibacStrings.GetString("Unathorize")+'...')
		param='request=deactivation'
		param=param+'&email='+@@email
		param=param+'&licence_key='+@@clave
		param=param+'&product_id=2015DIBAC'
		param=param+'&instance='+@@numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-2015dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			if mensaje[7..15].index('true')
				texto=DibacStrings.GetString("Your license has been de-activated successfully.")
				#Sketchup.write_default("Dibac","User","")
				#Sketchup.write_default("Dibac","Email","")
				#Sketchup.write_default("Dibac","Serial","")
				#Sketchup.write_default("Dibac","Key","")
				Sketchup.write_default("PrefsOpt","ValidDefaultKey","03"+@@numserie+"236")
				#DibacHoraInicio = Time.now
=begin
				user_path = File.expand_path(ENV['APPDATA'] || ENV['APP'] || ENV['APLICATIONDATA'])
				user_path=File.join(user_path,'dibac')
				definicion=Sketchup.active_model.definitions.load(File.join(user_path, 'dibac_cotal.skp'))
				definicion.set_attribute('dibac','user','')
				definicion.set_attribute('dibac','email','')
				definicion.set_attribute('dibac','serial','')
				definicion.set_attribute('dibac','key','')
				definicion.save_as(File.join(user_path, 'dibac_cotal.skp'))
=end
				datos_licencia(true)
			else
				texto=DibacStrings.GetString("Error deactivating your license.")
				texto=texto+13.chr+13.chr+mensaje
			end
			
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}	
	end	
end	

def video_tutoriales
	wd=UI::WebDialog.new(DibacStrings.GetString("dibac.com"))
	wd.set_url("http://www.dibac.com/video-tutorials")
	wd.set_size(800,600)
	wd.set_position(50,50)
	wd.show
end	

def manual_usuario
	wd=UI::WebDialog.new(DibacStrings.GetString("dibac.com"))
	wd.set_url("http://www.dibac.com/user-manual")
	wd.set_size(800,600)
	wd.set_position(50,50)
	wd.show
end	

def self.salva_bloques(defs,dir)
	tiempo=Time.now
	if !defs
		defs=[]
		Sketchup.active_model.definitions.grep(Sketchup::ComponentDefinition).each do |d|
			if d.is_a?(Sketchup::ComponentDefinition) && !d.group? #solo los componentes
				atributo=nil
				esta=d.get_attribute 'dibac','2d'
				atributo='2d' if esta
				if !esta
					esta=d.get_attribute 'dibac','3d'
					atributo='3d' if esta
				end
				defs.push(File.basename(esta[0],'.skp'))if atributo #&&  !File.exist?(esta[0])
			end
		end	
	end	
	defs.uniq!
	#salvamos todos los bloques en temp
	if defs !=[]	
		eye=Sketchup.active_model.active_view.camera.eye
		target=Sketchup.active_model.active_view.camera.target
		up=Sketchup.active_model.active_view.camera.up
		perspective=Sketchup.active_model.active_view.camera.perspective?
		eye1=Geom::Point3d.new(-1,1,0.5)
		target1=Geom::Point3d.new(0,0,0)
		up1=Geom::Vector3d.new(1,-1,1)
		Sketchup.active_model.active_view.camera.set(eye1,target1,up1)	
		Sketchup.active_model.active_view.camera.perspective=true
		texto=DibacStrings.GetString('Backing up Dibac components.')+'>'
		resto=defs.size
		i=0
		archivo=nil
		archivo = defs[0][1] if defs.size==1 && defs.flatten.size==2 #viene el bloque y el archivo para grabar
		Sketchup.active_model.definitions.each do |d|
			if d.is_a?(Sketchup::ComponentDefinition) && defs.flatten.include?(d.name)
				archivo=d.name if !archivo
				i+=1
				resto+=-1
				Sketchup::set_status_text  texto+	'+'*i+" -"*resto	+'<'
				d.save_as(dir+archivo+'.skp')
				archivo=nil	
			end	
		end	
		Sketchup.active_model.active_view.camera.set(eye,target,up)	
		Sketchup.active_model.active_view.camera.perspective=perspective	
	end	
	#puts('Tiempo='+(Time.now-tiempo).to_s)
end

def tipo_bloque(carp)
	return 'conjunto' if (carp.definition.get_attribute('dynamic_attributes', 'dibacset'))
	return false if (!carp.definition.get_attribute('dibac','2d') || !es_plano(carp))
	return 'mobiliario' if (carp.definition.get_attribute('dibac','mocheta').to_f == 0)
	return 'carpinteria'
end

def tipo_bloque_3d(carp)
	return false if !carp.definition.get_attribute('dibac','3d')
	return 'conjunto' if (carp.definition.get_attribute('dynamic_attributes', 'dibacset'))
	return 'mobiliario' if (carp.definition.get_attribute('dibac','mocheta').to_f == 0)
	return 'carpinteria'
end

def es_plano(entidad)
	return false if entidad.bounds.min.z != entidad.bounds.max.z
	return true
end	

def initialize
	if !file_loaded?("dibac_cmd.rbs")
		@@contador=0
		#Creamos directorio temporal si no existe
		@@current_path = File.dirname(__FILE__)
		if @@current_path.respond_to?(:force_encoding)
			@@current_path.force_encoding("UTF-8")
		end
		Dir.mkdir(@@current_path+'/model') if !File.exists?(@@current_path+'/model')
		#borramos todos los archivos del directorio.
		Dir.foreach(@@current_path+"/model") {|f| File.delete(@@current_path+"/model/"+f) if f != '.' && f != '..'}
		#salva bloques
		Dibac_Inicio.salva_bloques(nil, @@current_path+'/model/') 
		@@usuario=''
		datos_licencia(true)
		#buscamos signo decimal
		@@coma=Sketchup::RegionalSettings.decimal_separator
		@@separador_listas=Sketchup::RegionalSettings.list_separator
		#Observadores
		Sketchup.add_observer(Dibac_ObservadorApp.new)
		Sketchup.active_model.active_view.add_observer(Dibac_ObservadorView.new)
		Sketchup.active_model.add_observer(Dibac_ObservadorModel.new)
		Sketchup.active_model.tools.add_observer(Dibac_ObservadorTools.new)
		Sketchup.active_model.definitions.add_observer(Dibac_ObservadorDefiniciones.new)
		Sketchup.active_model.active_entities.add_observer(Dibac_ObservadorEntities.new)
		@@secciones=Hash.new #Almacenamos la seccion para poder borrarla
		SeccionSolida.iniciosecciones
		UI.add_context_menu_handler do | menu |
			section = SeccionSolida.valida
			if section
				menu.add_separator
				opcionmenu = menu.add_item(DibacStrings.GetString("Dibac Solid Section")) {SeccionSolida.fija_gruposeccion(nil, section, false)}
				menu.add_item(DibacStrings.GetString("Create group Dibac Solid Section")) {SeccionSolida.fija_gruposeccion(DibacStrings.GetString("Create group Solid Section"), section, false)}
				#menu.add_item(DibacStrings.GetString("Create group Dibac Plan"))  {SeccionSolida.fija_gruposeccion(DibacStrings.GetString("Create group Dibac Plan"), section, true)} if (section.get_plane[2].abs == 1 && DibacLicencia)
				menu.set_validation_proc(opcionmenu) {
					if 	SeccionSolida.buscaseccion(section)	
						MF_CHECKED
					else
						MF_UNCHECKED
					end	
				}
			end 
		end
		#Hoja de Calculo 
		@@hojacalculocmd = UI::Command.new("Hoja de ccalculo") { Sketchup.active_model.select_tool Dibac_Hojacalculo.new }
		@@hojacalculocmd.small_icon =Sketchup.find_support_file "hojacalculo.png","plugins/iscarnet_dibac"
		@@hojacalculocmd.large_icon =Sketchup.find_support_file "hojacalculo.png","plugins/iscarnet_dibac"
		@@hojacalculocmd.tooltip = DibacStrings.GetString("Report")  
		@@hojacalculocmd.status_bar_text =DibacStrings.GetString("Make a xlsx file report.")
		#Cuentagotas
		@@cuentagotascmd = UI::Command.new("Cuentagotas") { Sketchup.active_model.select_tool Dibac_Cuentagotas.new }
		@@cuentagotascmd.small_icon =Sketchup.find_support_file "cuentagotas.png","plugins/iscarnet_dibac"
		@@cuentagotascmd.large_icon =Sketchup.find_support_file "cuentagotas.png","plugins/iscarnet_dibac"
		@@cuentagotascmd.tooltip = DibacStrings.GetString("Capture Dibac")  
		@@cuentagotascmd.status_bar_text =DibacStrings.GetString("Get wall, joinery or component from model.")
		#Muro
		@@murocmd = UI::Command.new("Muro") { Sketchup.active_model.select_tool Dibac_Muro.new }
		@@murocmd.small_icon =Sketchup.find_support_file "muro.png","plugins/iscarnet_dibac"
		@@murocmd.large_icon =Sketchup.find_support_file "muro.png","plugins/iscarnet_dibac"
		@@murocmd.tooltip = DibacStrings.GetString("Wall")  
		@@murocmd.status_bar_text =DibacStrings.GetString("Draw walls from point to point.")
		#Muro Interior
		@@murointcmd = UI::Command.new("MuroInt") { Sketchup.active_model.select_tool Dibac_Muro_Inner.new }
		@@murointcmd.small_icon =Sketchup.find_support_file "muroint.png","plugins/iscarnet_dibac"
		@@murointcmd.large_icon =Sketchup.find_support_file "muroint.png","plugins/iscarnet_dibac"
		@@murointcmd.tooltip = DibacStrings.GetString("Inner wall")  
		@@murointcmd.status_bar_text =DibacStrings.GetString("Draw inner walls from point to point.")
		#Muro Exterior
		@@muroextcmd = UI::Command.new("MuroInt") { Sketchup.active_model.select_tool Dibac_Muro_Outer.new }
		@@muroextcmd.small_icon =Sketchup.find_support_file "muroext.png","plugins/iscarnet_dibac"
		@@muroextcmd.large_icon =Sketchup.find_support_file "muroext.png","plugins/iscarnet_dibac"
		@@muroextcmd.tooltip = DibacStrings.GetString("Outer wall")  
		@@muroextcmd.status_bar_text =DibacStrings.GetString("Draw Outer walls from point to point.")
		#Muro paralelo
		@@muropcmd = UI::Command.new("Muro paralelo") { Sketchup.active_model.select_tool Dibac_Murop.new }
		@@muropcmd.small_icon =Sketchup.find_support_file("murop.png","plugins/iscarnet_dibac")
		@@muropcmd.large_icon = Sketchup.find_support_file("murop.png","plugins/iscarnet_dibac")
		@@muropcmd.tooltip = DibacStrings.GetString("Parallel wall")
		@@muropcmd.status_bar_text = DibacStrings.GetString("Draw walls parallel to a edge.")
		#Estirar muros
		@@Estiramurocmd = UI::Command.new("Prolongar muro") { Sketchup.active_model.select_tool Dibac_Estiramuro.new }
		@@Estiramurocmd.small_icon = Sketchup.find_support_file("estirarmuro.png","plugins/iscarnet_dibac")
		@@Estiramurocmd.large_icon = Sketchup.find_support_file("estirarmuro.png","plugins/iscarnet_dibac")
		@@Estiramurocmd.tooltip = DibacStrings.GetString("Extend wall")
		@@Estiramurocmd.status_bar_text = DibacStrings.GetString("Extend / shorten walls.")
		#Puertas
		@@puertacmd = UI::Command.new("Puerta") { Sketchup.active_model.select_tool Dibac_Puerta.new }
		@@puertacmd.small_icon = Sketchup.find_support_file("puerta.png","plugins/iscarnet_dibac")
		@@puertacmd.large_icon = Sketchup.find_support_file("puerta.png","plugins/iscarnet_dibac")
		@@puertacmd.tooltip = DibacStrings.GetString("Door")
		@@puertacmd.status_bar_text = DibacStrings.GetString("Place doors in walls.")
		#Ventanas
		@@ventanacmd = UI::Command.new("Ventana") { Sketchup.active_model.select_tool Dibac_Ventana.new }
		@@ventanacmd.small_icon = Sketchup.find_support_file("ventana.png","plugins/iscarnet_dibac")
		@@ventanacmd.large_icon = Sketchup.find_support_file("ventana.png","plugins/iscarnet_dibac")
		@@ventanacmd.tooltip = DibacStrings.GetString("Window")
		@@ventanacmd.status_bar_text = DibacStrings.GetString("Place windows in walls.")
		#Armarios
		@@armariocmd = UI::Command.new("Armario") { Sketchup.active_model.select_tool Dibac_Armario.new }
		@@armariocmd.small_icon = Sketchup.find_support_file("armario.png","plugins/iscarnet_dibac")
		@@armariocmd.large_icon = Sketchup.find_support_file("armario.png","plugins/iscarnet_dibac")
		@@armariocmd.tooltip = DibacStrings.GetString("Wardrobe")
		@@armariocmd.status_bar_text = DibacStrings.GetString("Place wardrobes in walls.")
		#Elegir
		@@elegircmd = UI::Command.new("Elegir") { Sketchup.active_model.select_tool Dibac_Elegir.new }
		@@elegircmd.small_icon = Sketchup.find_support_file("elegir.png","plugins/iscarnet_dibac")
		@@elegircmd.large_icon = Sketchup.find_support_file("elegir.png","plugins/iscarnet_dibac")
		@@elegircmd.tooltip = DibacStrings.GetString("Choose joinery")
		@@elegircmd.status_bar_text = DibacStrings.GetString("Place select joinery in walls.")
		#Mobiliario
		@@mobiliariocmd = UI::Command.new("Mobiliario") { Sketchup.active_model.select_tool Dibac_Mobiliario.new }
		@@mobiliariocmd.small_icon = Sketchup.find_support_file("mesa.png","plugins/iscarnet_dibac")
		@@mobiliariocmd.large_icon = Sketchup.find_support_file("mesa.png","plugins/iscarnet_dibac")
		@@mobiliariocmd.tooltip = DibacStrings.GetString("Component")
		@@mobiliariocmd.status_bar_text = DibacStrings.GetString("Place components.")
		#borrarcmd = UI::Command.new("Borrar") { Sketchup.active_model.select_tool Borrar.new }
		#path_comando = Sketchup.find_support_file "Borrar.png", "Plugins//iscarnet_dibac"
		#borrarcmd.small_icon = path_comando if path_comando
		#borrarcmd.large_icon = path_comando if path_comando
		#Escaleras
		@@escaleracmd = UI::Command.new("Escalera") { Sketchup.active_model.select_tool Dibac_Escalera.new }
		@@escaleracmd.small_icon = Sketchup.find_support_file("escalera.png","plugins/iscarnet_dibac")
		@@escaleracmd.large_icon = Sketchup.find_support_file("escalera.png","plugins/iscarnet_dibac")
		@@escaleracmd.tooltip = DibacStrings.GetString("Stair")
		@@escaleracmd.status_bar_text = DibacStrings.GetString("Draw stairs from point to point or by path.")
		#Acotado continuo
		@@cotacontinuacmd = UI::Command.new("Acotado continuo") { Sketchup.active_model.select_tool Dibac_CotaContinua.new }
		@@cotacontinuacmd.small_icon =  Sketchup.find_support_file("cotacontinua.png","plugins/iscarnet_dibac")
		@@cotacontinuacmd.large_icon = Sketchup.find_support_file("cotacontinua.png","plugins/iscarnet_dibac")
		@@cotacontinuacmd.tooltip = DibacStrings.GetString("Continuous dimension")
		@@cotacontinuacmd.status_bar_text = DibacStrings.GetString("Continuous interior dimensions between two points.")
		#Licencia
		licenciacmd = UI::Command.new("Informacion de licencia") { Sketchup.active_model.select_tool Licencia.new }
		path_comando = Sketchup.find_support_file "Usuario.png", "Plugins//iscarnet_dibac"
		licenciacmd.small_icon = path_comando if path_comando
		licenciacmd.large_icon = path_comando if path_comando
		licenciacmd.tooltip = DibacStrings.GetString("User License")
		#Preferencias
		@@preferenciascmd = UI::Command.new("Preferencias") { Sketchup.active_model.select_tool Dibac_Preferencias.new }
		@@preferenciascmd.small_icon = Sketchup.find_support_file("preferencias.png","plugins/iscarnet_dibac")
		@@preferenciascmd.large_icon = Sketchup.find_support_file("preferencias.png","plugins/iscarnet_dibac")
		@@preferenciascmd.tooltip = DibacStrings.GetString("Options")
		@@preferenciascmd.status_bar_text = DibacStrings.GetString("Select language")	
		#Impresion Dibac
		#imprimedibaccmd = UI::Command.new("Impresión Dibac") { Sketchup.active_model.select_tool ImprimeDibac.new }
		#path_comando = Sketchup.find_support_file "Impresora.png", "Plugins//iscarnet_dibac"
		#imprimedibaccmd.small_icon = path_comando if path_comando
		#imprimedibaccmd.large_icon = path_comando if path_comando
		#imprimedibaccmd.tooltip = DibacStrings.GetString("Print Dibac")
		@@tresdcmd = UI::Command.new("Convertir en 3D") { Sketchup.active_model.select_tool Dibac_TresDimensiones.new }
		@@tresdcmd.small_icon = Sketchup.find_support_file("3dToogle.png","plugins/iscarnet_dibac")
		@@tresdcmd.large_icon = Sketchup.find_support_file("3dToogle.png","plugins/iscarnet_dibac")
		@@tresdcmd.tooltip = DibacStrings.GetString("Convert to 2D/3D")	
		@@tresdcmd.status_bar_text = DibacStrings.GetString("Transform model between 2D and 3D.")
		#colorescmd = UI::Command.new("Color de lineas") { Sketchup.active_model.select_tool Colores.new }
		#path_comando = Sketchup.find_support_file "colores.png", "Plugins//iscarnet_dibac"
		#colorescmd.small_icon = path_comando if path_comando
		#colorescmd.large_icon = path_comando if path_comando
		barradibac = UI::Toolbar.new "Dibac"
		@@cuentagotascursor_id = nil
		@@murocursor_id = nil
		@@muropcursor_id = nil
		@@estiramurocursor_id = nil
		@@medircursor_id = nil
		cuentagotascursor_path = Sketchup.find_support_file("cursorcuentagotas.png", "Plugins/iscarnet_dibac")
		murocursor_path = Sketchup.find_support_file("cursormuro.png", "Plugins/iscarnet_dibac")
		muropcursor_path = Sketchup.find_support_file("cursormurop.png", "Plugins/iscarnet_dibac")
		estiramurocursor_path = Sketchup.find_support_file("cursorestirarmuro.png", "Plugins/iscarnet_dibac")
		medircursor_path = Sketchup.find_support_file("cursormedir.png", "Plugins/iscarnet_dibac")
		escaleracursor_path = Sketchup.find_support_file("cursorescalera.png", "Plugins/iscarnet_dibac")
		if Sketchup.version_number <=8000999
			borrarcursor_path = Sketchup.find_support_file("cursorborrar.png", "Plugins/iscarnet_dibac")
			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 5,21) if borrarcursor_path 
		else
			borrarcursor_path = Sketchup.find_support_file("cursorborrar2013.png", "Plugins/iscarnet_dibac")
			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 7,23) if borrarcursor_path 
		end
		borrarcursordibac_path = Sketchup.find_support_file("cursorborrardibac.png", "Plugins/iscarnet_dibac")
		@@cuentagotascursor_id = UI.create_cursor(cuentagotascursor_path,2,22) if cuentagotascursor_path 
		@@murocursor_id = UI.create_cursor(murocursor_path, 4,28) if murocursor_path 
		@@muropcursor_id = UI.create_cursor(muropcursor_path, 6,27) if muropcursor_path 
		@@estiramurocursor_id = UI.create_cursor(estiramurocursor_path, 4,28) if estiramurocursor_path 
		@@medircursor_id = UI.create_cursor(medircursor_path, 4,28) if medircursor_path 
		@@escaleracursor_id = UI.create_cursor(escaleracursor_path, 4,28) if escaleracursor_path 
		@@borrarcursordibac_id = UI.create_cursor(borrarcursordibac_path, 5,21) if borrarcursordibac_path 
		barradibac = barradibac.add_item @@murocmd
		barradibac = barradibac.add_item @@murointcmd if RITKONSULT
		barradibac = barradibac.add_item @@muroextcmd if RITKONSULT
		barradibac = barradibac.add_item @@muropcmd
		barradibac = barradibac.add_item @@Estiramurocmd
		barradibac = barradibac.add_item @@puertacmd
		barradibac = barradibac.add_item @@ventanacmd
		barradibac = barradibac.add_item @@armariocmd
		barradibac = barradibac.add_item @@elegircmd
		barradibac = barradibac.add_item @@mobiliariocmd
		barradibac = barradibac.add_item @@escaleracmd
		#barradibac = barradibac.add_item borrarcmd
		barradibac = barradibac.add_item @@cotacontinuacmd
		#barradibac = barradibac.add_item imprimedibaccmd
		barradibac = barradibac.add_item @@tresdcmd
		barradibac = barradibac.add_item @@cuentagotascmd
		#barradibac = barradibac.add_item @@hojacalculocmd
		#barradibac = barradibac.add_item @@preferenciascmd
		#barradibac = barradibac.add_item colorescmd
		barradibac.show
		add_separator_to_menu("Draw")
		menu = UI.menu("Draw").add_submenu("Dibac")
		item=menu.add_item(DibacStrings.GetString("Wall")) {Sketchup.active_model.select_tool Dibac_Muro.new}
		DibacStrings.unchecked(menu,item)
		if RITKONSULT
			item=menu.add_item(DibacStrings.GetString("Inner wall")) {Sketchup.active_model.select_tool Dibac_Muro_Inner.new} 
			DibacStrings.unchecked(menu,item)
			item=menu.add_item(DibacStrings.GetString("Outer wall")) {Sketchup.active_model.select_tool Dibac_Muro_Outer.new} 
			DibacStrings.unchecked(menu,item)
		end
		item=menu.add_item(DibacStrings.GetString("Parallel wall")) {Sketchup.active_model.select_tool Dibac_Murop.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Extend wall")) {Sketchup.active_model.select_tool Dibac_Estiramuro.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Door")) {Sketchup.active_model.select_tool Dibac_Puerta.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Window")) {Sketchup.active_model.select_tool Dibac_Ventana.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Wardrobe")) {Sketchup.active_model.select_tool Dibac_Armario.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Choose joinery")) {Sketchup.active_model.select_tool Dibac_Elegir.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Component")) {Sketchup.active_model.select_tool Dibac_Mobiliario.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Stair")) {Sketchup.active_model.select_tool Dibac_Escalera.new}
		DibacStrings.unchecked(menu,item)
		#submenu.add_item("Borrar elentos Dibac") {Sketchup.active_model.select_tool Borrar.new}
		item=menu.add_item(DibacStrings.GetString("Continuous dimension")) {Sketchup.active_model.select_tool Dibac_CotaContinua.new}
		DibacStrings.unchecked(menu,item)
		#submenu.add_item("Impresion Dibac") {Sketchup.active_model.select_tool ImprimeDibac.new}
		item=menu.add_item(DibacStrings.GetString("Convert to 2D/3D")) {Sketchup.active_model.select_tool Dibac_TresDimensiones.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item(DibacStrings.GetString("Get Dibac")) {Sketchup.active_model.select_tool Dibac_Cuentagotas.new}
		DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Report Dibac")) {Sketchup.active_model.select_tool Dibac_Hojacalculo.new}
		#DibacStrings.unchecked(menu,item)
		#submenu.add_item("Color de linea") {Sketchup.active_model.select_tool Colores.new}
		menu = UI.menu("Plugins").add_submenu("Dibac")
		menu2 = menu.add_submenu(DibacStrings.GetString("Settings"))
		item=menu2.add_item(DibacStrings.GetString("Select language")) { Sketchup.active_model.select_tool Dibac_Preferencias.new }
		DibacStrings.unchecked(menu,item)
		item=menu2.add_item(DibacStrings.GetString("Define")+' '+DibacStrings.GetString("Door")+' ...'){
			carp = Sketchup.read_default('Dibac', 'Door', Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac")).split('#')
			carp = './dibac_door.skp' if carp.size == 0
			archivo = UI.openpanel(DibacStrings.GetString("Choose")+' '+DibacStrings.GetString("Door")+' ...', File.dirname(carp[0]) ,"Sketchup files|*.skp||") 
			Sketchup.write_default('Dibac','Door', archivo.gsub('\\','/')) if (archivo != carp[0]) && archivo
		}
		item=menu2.add_item(DibacStrings.GetString("Define")+' '+DibacStrings.GetString("Window")+' ...'){
			carp = Sketchup.read_default('Dibac', 'Window', Sketchup.find_support_file("dibac_window.skp","plugins/iscarnet_dibac")).split('#')
			carp = './dibac_window.skp' if carp.size == 0
			archivo = UI.openpanel(DibacStrings.GetString("Choose")+' '+DibacStrings.GetString("Window")+' ...', File.dirname(carp[0]) ,"Sketchup files|*.skp||") 
			Sketchup.write_default('Dibac','Window', archivo.gsub('\\','/')) if (archivo != carp[0]) && archivo
		}
		item=menu2.add_item(DibacStrings.GetString("Define")+' '+DibacStrings.GetString("Wardrobe")+' ...'){
			carp = Sketchup.read_default('Dibac', 'Wardrobe', Sketchup.find_support_file("dibac_wardrobe.skp","plugins/iscarnet_dibac")).split('#')
			carp = './dibac_wardrobe.skp'if carp.size == 0
			archivo = UI.openpanel(DibacStrings.GetString("Choose")+' '+DibacStrings.GetString("Wardrobe")+' ...', File.dirname(carp[0]), "Sketchup files|*.skp||") 
			Sketchup.write_default('Dibac','Wardrobe', archivo.gsub('\\','/')) if (archivo != carp[0]) && archivo
		}
		menu2.add_separator
		item=menu2.add_item(DibacStrings.GetString("Reset")){
			Sketchup.write_default('Dibac','Door',Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac"))
			Sketchup.write_default('Dibac','Window', Sketchup.find_support_file("dibac_window.skp","plugins/iscarnet_dibac"))
			Sketchup.write_default('Dibac','Wardrobe',Sketchup.find_support_file("dibac_wardrobe.skp","plugins/iscarnet_dibac"))
			Sketchup.write_default('Dibac','Choose', Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac"))
			Sketchup.write_default('Dibac','Component', Sketchup.find_support_file("dibac_table.skp","plugins/iscarnet_dibac"))
			UI.messagebox(DibacStrings.GetString("The components have been initialized"))
		}

		
		
		
		
		menu2 = menu.add_submenu(DibacStrings.GetString("Dibac License"))
		item=menu2.add_item(DibacStrings.GetString("License Information")) {datos_licencia(false)
																																							DibacLicencia.informacion(@@datoslicencia)}
		DibacStrings.unchecked(menu2,item)	
		item=menu2.add_item(DibacStrings.GetString("Authorize")+'...'){licencia_autorizar}
		menu2.set_validation_proc(item){
			MF_UNCHECKED
			if @@numserie != '' && @@numserie != 'promo'
				MF_GRAYED
			else
				MF_ENABLED
			end	
		}
		item = menu2.add_item(DibacStrings.GetString("Unauthorize")){licencia_desautorizar}
		menu2.set_validation_proc(item){
			MF_UNCHECKED
			if @@numserie == '' or @@numserie == 'promo'
				MF_GRAYED
			else
				MF_ENABLED
			end	
		}
		menu.add_separator
		item=menu.add_item(DibacStrings.GetString("Dibac Solid Section")){SeccionSolida.activar(true)}
		menu.set_validation_proc(item){
		if @@solidsection
			MF_CHECKED
		else	
			MF_UNCHECKED
		end
		 }
		
		menu.add_item(DibacStrings.GetString('Save all Dibac Components')){
		dir=File.dirname(UI.savepanel(DibacStrings.GetString("Save all Dibac components"),nil,'all dibac components,*.skp'))+'/'
		Dibac_Inicio.salva_bloques(nil,dir) if dir	
		}
		menu.add_separator
		item = menu.add_item(DibacStrings.GetString("Video Tutorials")){video_tutoriales}
		item = menu.add_item(DibacStrings.GetString("User manual")){manual_usuario}
		
		
		
		UI.add_context_menu_handler do | menu |
			selec=Sketchup.active_model.selection
			elemento=Sketchup.active_model.selection[0]
			carpinteria=nil
			if elemento && selec.size == 1
				if elemento.is_a?(Sketchup::ComponentInstance)
					carpinteria=tipo_bloque(elemento)
					carpinteria=tipo_bloque_3d(elemento) if !carpinteria
					elemento=elemento.definition
				elsif elemento.is_a?(Sketchup::Group)
					elemento=elemento.parent
				end
				if carpinteria
					diccionario=elemento.attribute_dictionary('dibac')
					archivo=elemento.get_attribute('dibac','2d')
					archivo=elemento.get_attribute('dibac','3d') if !archivo
					if archivo
						menu.add_item(DibacStrings.GetString('Save Dibac component')){
						fichero=UI.savepanel(DibacStrings.GetString('Save Dibac component'),nil,File.basename(archivo[0]))
						Dibac_Inicio.salva_bloques([[File.basename(archivo[0],'.skp'),File.basename(fichero,'.skp')]],File.dirname(fichero)+'/')
						}	
						if carpinteria=='carpinteria'
							menu.add_item(DibacStrings.GetString('Assign to default door')){Sketchup.write_default('Dibac','Door', archivo[0])}
							menu.add_item(DibacStrings.GetString('Assign to default window')){Sketchup.write_default('Dibac','Window', archivo[0])}
							menu.add_item(DibacStrings.GetString('Assign to default wardrobe')){Sketchup.write_default('Dibac','Wardrobe', archivo[0])}
						end	
					end	
				end			
				diccionario=elemento.attribute_dictionary('dynamic_attributes')
				urls=[]
				diccionario.each{|key, value| urls.push(key) if key[0,9]=='dibac_url'} if diccionario
				if urls.size>0
					menu.add_separator
					urls.each do |key|
						texto=DibacStrings.GetString(elemento.get_attribute('dynamic_attributes', '_'+key+'_formlabel'))
						menu.add_item (texto){
							wd=UI::WebDialog.new(texto)
							wd.set_url(elemento.get_attribute('dynamic_attributes', key))
							wd.set_size(1024,800)
							wd.set_position(100,100)
							begin
								wd.show
							rescue
							end
						}	
					end	
				end		
			end 
		end 
		@@solidsection=Sketchup.read_default("Dibac","SolidSection",true)
		@@protected = ["GSU_ContributorsInfo"] #Diccionarios protegidos que no se pueden alterar
		@@cuentagotas = nil
		@@transf_nula=Geom::Transformation.new #transformacion inicial
		@@ip = Sketchup::InputPoint.new
		@@ip1 = Sketchup::InputPoint.new
		@@hv = [1,0]
		@@muro_width=Sketchup.read_default("Dibac","Wall",0.25.m).to_f
		if @@muro_width==0
			@@muro_width=0.25.m.to_f
			Sketchup.write_default("Dibac","Wall",@@muro_width)
		end	
		@@muro_inner=Sketchup.read_default("Dibac","InnerWall",0.12.m)
		if @@muro_inner==0
			@@muro_inner=0.12.m.to_f
			Sketchup.write_default("Dibac","InnerWall",@@muro_inner)
		end	
		@@muro_outer=Sketchup.read_default("Dibac","OuterWall",0.20.m)
		if @@muro_outer==0
			@@muro_outer=0.20.m.to_f
			Sketchup.write_default("Dibac","OuterWall",@@muro_outer)
		end	
		@@muro_gruesos = [0.07,0.10,0.15,0.25,0.40,0.50]
		@@muro_cara = 0
		@@muro_inc = true
		#@@forzar_carpinteria=false
		@@puerta_ancho_marco = 0.04.m
		@@puerta_hueco = 0
		@@ventana_hueco = 0
		@@armario_hueco = 0
		@@elegir_hueco=0
		@@escalera_width = 1.0.m
		@@escalera_height = 3.3.m
		@@escalera_cara = 0
		@@escalera_inc = true
		@@escalera_huella = 0.30.m
		@@escalera_huellamin = 0.27.m
		@@escalera_tabica = 0.18.m
		@@escalera_tabicamax= 0.20.m
		@@escalera_slope= 0.63.m
		@@cota_minima = 0.25.m
		@@alturas_planta = Sketchup.read_default("Dibac","FloorHeight","118.110#0").to_s.split("#")
		if @@alturas_planta == []
			@@alturas_planta=[118.110,0]
		end
		@@alturas_planta.push(0) if  @@alturas_planta.size == 1 
		@@crear_grupo = false #Poner a true para conservar 2D por defecto
		@@color_lineas =  "<Ninguno>"
		@@color_superficies =  "<Ninguno>"
		@@color_seleccion =  "<Ninguno>"
		@@veces_que_entra = -1 #para que saque el letrero a la primera
		@@penultima_dist=nil
		
		UI.add_context_menu_handler do | menu |
			section = false#para que no salga
			if section
				menu.add_separator
				opcionmenu = menu.add_item("Proyecto ..."){
					wd=UI::WebDialog.new(DibacStrings.GetString("Proyecto"))
					wd.set_url('C:\Proyectos\CONIL\C_ALTA_11\Proyecto\Pdf\PROYECTOBARCALLEALTA.pdf')
					wd.set_size(800,800)
					wd.set_position(100,100)
					begin
						wd.show
					rescue
					end
					}
				menu.add_item("Foto ..."){
					wd=UI::WebDialog.new(DibacStrings.GetString("Fotografia"))
					wd.set_url('C:\Proyectos\CONIL\PLAZA_ESPAÑA\ADECUACION\ADECUACION DE UNA VIVINEDA\CGP\Foto1.jpg')
					wd.set_size(800,800)
					wd.set_position(300,300)
					begin
						wd.show
					rescue
					end
					}
				menu.add_item("Pliego ..."){
					wd=UI::WebDialog.new(DibacStrings.GetString("Pliego de Condiciones"))
					wd.set_file('C:\Proyectos\CONIL\PLAZA_ESPAÑA\ADECUACION\DOCUMENTACION\Pliego.doc#Director_de_la_obra')
					#wd.set_file('C:\Proyectos\CONIL\C_ALTA_11\Volumetria.skp')
					wd.set_size(800,800)
					wd.set_position(300,300)
					begin
						wd.show
					rescue
					end
					}
			end 
		end 
		#Dibac_Extension.esquema!
		#Dibac_Extension.esquema.show
		file_loaded("dibac_cmd.rbs")
	end	
end

end #de la clase Dibac_Inicio

class Dibac_Base < Dibac_Inicio
=begin
 Clase	        		:	DibacBase
 Desciende de		:	
 Descripción   		:	Contiene funciones comunes a todos los descendientes
 Item de Menu  	:	
 Menú contextual	:	NO
 Uso         			:	
 Fecha        			:	14/11/2010
=end

def dc_redraw(ent, pbar_visible=true, undo=false)
    begin
        ldc=$dc_observers.get_latest_class()
        if undo
            ldc.method(:redraw_with_undo).call(ent, pbar_visible)
        else
            ldc.determine_movetool_behaviors(ent)
            DCProgressBar::clear()
            ldc.method(:redraw).call(ent, pbar_visible)
            DCProgressBar::clear()
            ldc.refresh_dialogs()
        end
    rescue TypeError => e
        p e
    end
    # suppresses nil to float conversion error that happens
    # when redraw is called directly with true 2nd arg ?
    ###
    #@view.refresh
    return true ### to slow nested commit_operation etc
end#def

def arregla_carp (carp_ant)
	# unimos en @carp[0] hasta .skp
	carp=[carp_ant[0]]
	i=1
	while File.extname(carp[0]) != '.skp' 
		carp[0]=carp[0]+'#'+carp_ant[i]
		i+=1
	end
	if i>1
		for j in i...carp_ant.size
			carp << carp_ant[i]
		end 
		return carp
	end	
	return carp_ant
end

def a_longitud(valor)
	valor=con_coma(valor.to_s,nil)
	begin
		numero=valor.to_l.to_f
	rescue	
		numero = 0
	end
	return(numero)
end	

def a_float
	valor = con_punto(valor.to_s)
	begin
		numero=valor.to_f
	rescue
		numero=0
	end
	return(numero)
end	

def activate
	nolicencia(false)
	menu
end	

def ancho_carpinteria(carp)
	if carp.definition.name[0,12].upcase == "DIBAC_PUERTA"
		#carp.definition.attribute_dictionaries.each {|a| puts(a.name)}
		#attrdict=carp.definition.attribute_dictionary 'dynamic_attributes'
		#attrdict.each { | key, value |
		#puts key.to_s + '=' + value.to_s
		#					}		
		ancho =(carp.get_attribute "dynamic_attributes", "a01hoja1",(carp.definition.get_attribute "dynamic_attributes", "a01hoja1", 0)).to_f.to_l+
				(carp.get_attribute "dynamic_attributes", "a01hoja2",(carp.definition.get_attribute "dynamic_attributes", "a01hoja2", 0)).to_f.to_l+	
				2*(carp.get_attribute "dynamic_attributes", "anchomarco",(carp.definition.get_attribute "dynamic_attributes", "anchomarco", 0)).to_f.to_l
	else
		ancho =(carp.get_attribute "dynamic_attributes", "a01ancho",(carp.definition.get_attribute "dynamic_attributes", "a01ancho", 0)).to_f.to_l
	end
	return ancho
end	

def angulo_recta(p1,p2)
	# devuelve el angulo con la horizontal de una recta dada por los extremos p1 y p2
	return nil if p1==p2
	if p1[0] == p2[0] #iguales x
		if p1[1] < p2[1]
			return Math::PI/2
		else
			return Math::PI*3/2
		end	
	elsif p1[1] == p2[1]
		if p1[0] < p2[0]
			return 0.0
		else	
			return Math::PI
		end	
	else
		result = Math::atan((p2[1]-p1[1])/(p2[0]-p1[0]))
		result += Math::PI if p1[0] > p2[0] 
		result += Math::PI*2 if result < 0.0 
		return result
	end	
end

def aspectox(definicion) #comprueba si en un componente hay elementos que deben mantener una orientacion en X
	return true if definicion.get_attribute('dynamic_attributes','dibacscalex')
	definicion.entities.each do |e| 
		if e.is_a?(Sketchup::ComponentInstance)
			encontrado=aspectox(e.definition) 
			return e if encontrado
		end	
	end
	return nil
end

def borra_auxiliares
	if !@cl1.deleted?
		Sketchup.active_model.active_entities.erase_entities [@cl1, @cl2]
	end if @cl1	
end

def borra_carpinteria(carp, entities)
	return false if tipo_bloque(carp) != 'carpinteria'
	entities=Sketchup.active_model.active_entities if !entities
	if !(carp.get_attribute('dibac','mocheta').to_f < 0) #no esta superpuesta
		ambos=muro_carpinteria(carp)
		ptos = ambos[0]
		p_t = ambos[1]
		#carp.set_attribute('dibac', 'trim', p)
		#UI.messagebox(carp.get_attribute('dibac', 'trim'))
		transform=carp.transformation
		#UI.messagebox(carp.definition.get_attribute('dibac','mocheta').to_l)
		lineasmuro=[]
		# hacemos el muro por los lados de la mocheta
		0.step(p_t.size-1, 2) do |i|
			lineasmuro.push(entities.add_line(p_t[i].transform(transform),  p_t[i+1].transform(transform)))	
		end
		entities.add_line(ptos[0], ptos[3])
		entities.add_line(ptos[1], ptos[2])
		lineasmuro[0].find_faces
		#lineasmuro.each{|l| l.find_faces}
		#face = entities.add_face(lineasmuro)
		#face = entities.add_face(ptos[0],ptos[1],ptos[2],ptos[3] )
		# borramos lineas sobrantes
		borra_coplanarias(entities.grep(Sketchup::Edge), entities)
	end
	entities.erase_entities carp if carp && !carp.deleted?
	# para que no borre el muro inmediatamente despues de la ventana
	#@borrando = false
end

def borra_coplanarias(caras, entities)#edges
	selborrar = []
	caras.each do |e|
		if !e.deleted? 
			if(e.faces.size == 2) 
				selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.999999) 
			end
		end	
	end
	if 	selborrar != []
		entities.erase_entities selborrar
	end	
end 

def borra_muro(x, y, view, modoundo) # noundo indica si entra en revoca y si arregla los dos extremos
	cara1 = busca_cara(x, y, view)
#	Sketchup.active_model.active_entities.add_cpoint((view.inputpoint x,y).position)
	if cara1
		cara2 = otra_cara_perp(cara1,(view.inputpoint x,y).position)
		if cara2
			# Quitamos las caras de la seleccion 
			Sketchup.active_model.selection.remove(cara1, cara2)
			ptos = tramo_comun(edge_extremos(cara1,(view.inputpoint x,y).position), edge_extremos(cara2,(view.inputpoint x,y).position))
			pt1 = ptos[0]
			pt2 = pt1.project_to_line(cara2.line)
			pt3 = ptos[1]
			pt4 = pt3.project_to_line(cara2.line) 
			lado =pt1.distance(view.inputpoint(x,y).position) - pt3.distance(view.inputpoint(x,y).position)	
			#inicioundo("borrar muro") if modoundo
			# cerramos el segmento de muro a borrar
			extremos =[]
			extremos.push(Sketchup.active_model.active_entities.add_line(pt1, pt2))
			extremos.push(Sketchup.active_model.active_entities.add_line(pt3, pt4))
			# borramos las caras
			borrar = Sketchup.active_model.active_entities.add_line(pt1, pt3)
			Sketchup.active_model.active_entities.erase_entities(borrar)
			borrar = Sketchup.active_model.active_entities.add_line(pt2, pt4)
			Sketchup.active_model.active_entities.erase_entities(borrar)
			# preparamos contenedor para puntos de resultado
			result = [pt1, pt2, pt3, pt4] 
			# comprobamos si los extremos pertenecen a un muro
			extremo1=false # controlamos cada extremo
			extremos.each do |e|
				# si no estan borrados es que estan sueltos o en un resto triangular 
				if !e.deleted?
					if e.faces.size == 0
						# si no tiene caras borramos 
						Sketchup.active_model.active_entities.erase_entities(e)
					else	
						# las dos caras en los extremos
						pt = ptt = linea1 = linea2 = vert1 = vert2 = vert3 = linea3 = nil
						e.vertices.each do |vert|
							vert.edges.each do |lin|
								# tiene que ser un muro
								if lin != e  && lin.faces.size == 1
									if e.faces.first == lin.faces.first
										# ponemos linea1 como perpendicular
										if(perpendicular(e,lin) && !linea1) || linea2
											linea1 = lin
											vert1 = vert.position
											vert3 = lin.other_vertex vert
											vert3.edges.each do |lin2|
												if lin2.faces.size == 1
													linea3 = lin2 if lin2 != lin
												end
											end
										else
											linea2 = lin
											vert2 = vert.position
										end
									end	
								end
							end
						end
						# el muro esta interrumpido en el medio por una linea	
						if !perpendicular(e,linea2)
							if otra_cara_perp(linea2,vert2) == linea3 # hay solo dos muros
								if extremo1
									result[2] = vert2
									result[3] = vert3.position
								else
									result[0] = vert2
									result[1] = vert3.position
								end				
								# ponemos el extremo ortogonal al muro	
								if !modoundo &&((lado <= 0 && extremo1) ||(lado > 0 && !extremo1))
									Sketchup.active_model.active_entities.add_line(vert2, vert3)
									Sketchup.active_model.active_entities.erase_entities(linea1, e)
								else
									pon_color((Sketchup.active_model.active_entities.add_line(vert2, @ptperp)),linea1.material)
									linea3 = Sketchup.active_model.active_entities.add_line(vert3, @ptperp)
									pon_color(linea3, linea1.material)
									Sketchup.active_model.active_entities.erase_entities(linea1, e)
									Sketchup.active_model.active_entities.erase_entities(linea3) if linea3 #puede que sea nula
								end
							else
								ptt = Geom.intersect_line_line(linea3.line, linea2.line) if linea2 && linea3
								pt = Geom.intersect_line_line(linea1.line, linea2.line) if !ptt && linea1 && linea2 #1.1.08 para pequeños errores de precision
								if pt # no son paralelas
									if extremo1
										result[2] = vert2
										result[3] = pt
									else
										result[0] = vert2
										result[1] = pt
									end	
									if ptt && ptt.distance(vert2) < pt.distance(vert2)
										face = Sketchup.active_model.active_entities.add_face ptt, vert3.position, vert1, vert2
									else	
										face = Sketchup.active_model.active_entities.add_face pt, vert1, vert2
									end
									caras = face.edges
									Sketchup.active_model.active_entities.erase_entities(e)
									caras.each do |l|
										if !l.deleted?
											Sketchup.active_model.active_entities.erase_entities l if l.faces.size != 1
										end	
									end if caras
								end	
							end
						end
					end	
				end
				extremo1 = true if !extremo1	
			end	
			view.invalidate
			@borrando = false
			if !(result[0]-result[2]).parallel?(result[1]-result[3]) 
				paso = result[2]
				result[2] = result[3]
				result[3] = paso
			end
			return result
		end
	end
	return false
end

def busca_cara(x, y, view) #devuelve linea si esta en el mismo modelo, grupo o componente
	ph = view.pick_helper
	ph.do_pick x, y
	cara=nil
	ph.all_picked.each{|e| cara=e if e.is_a?(Sketchup::Edge) && e.parent.entities == Sketchup.active_model.active_entities}
	return cara
end

def busca_instancia(x, y, view) #devuelve linea si esta en el mismo modelo, grupo o componente
	ph = view.pick_helper
	ph.do_pick x, y
	elemento=ph.best_picked
	if elemento.is_a?(Sketchup::ComponentInstance)
		return elemento if elemento.parent.entities == Sketchup.active_model.active_entities
	end if elemento	
	return nil
end

def reset #por si no lo hay
 end
 
def CambiaIdioma(key)
    return DibacStrings.GetString(key)
end

def carpinterias_2d3d(definicion)
	return definicion, definicion if definicion.get_attribute('dynamic_attributes','dibacset') #si es un conjunto
	defbloque=definicion
	bloque2d=bloque3d=nil
	vueltas=0
	while vueltas<2 do #buscamos dos veces con un definicion distinto
		vueltas += 1
		if definicion.entities.count == 2 #las carpinterias dibac llevan dentro dos instances
			definicion.entities.each do |e| 
				if es_plano(e) 
					if e.is_a?(Sketchup::ComponentInstance)
						bloque2d=e.definition #buscamos componente plano dentro de la carpinteria
					elsif	e.is_a?(Sketchup::Group)
						bloque2d=e.parent
					end	
					#bl2d=e
				else
					if e.is_a?(Sketchup::ComponentInstance)
						bloque3d=e.definition #buscamos componente plano dentro de la carpinteria
					elsif	e.is_a?(Sketchup::Group)
						bloque3d=e.parent
					end	
					#bl3d=e
				end if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			end 
		end 
		 if bloque2d && bloque3d
			vueltas += 1
		else
			Sketchup.active_model.definitions.each{|d| definicion=d if d.name == 'Dibac_'+@carp_name}
			if	definicion.name != 'Dibac_'+@carp_name
				definicion = Sketchup.active_model.definitions.add('Dibac_'+@carp_name)
				vueltas +=1
			end
		end	
	end	
	
	bloque2d=bloque3d=nil if (!bloque2d || !bloque3d) # el bloque completo es el componente
	
	hecho=bloque2d
	
	bloque3d=defbloque if !bloque3d
	
	if !bloque2d #fabricamos la representacion 2d del bloque proyectandolo sobre el suelo
		Sketchup.active_model.definitions.each{|d| bloque2d=d if d.name == '2d_'+@carp_name}
		if !bloque2d
			bloque2d=Sketchup.active_model.definitions.add('2d_'+@carp_name)	
			grupotrim3d=bloque2d.entities.add_group
			grupotrim3d.entities.add_instance(defbloque, @@transf_nula).explode
			caja=defbloque.bounds
			p1=[caja.min.x, caja.min.y,caja.center.z]
			p2=[caja.max.x, caja.min.y, caja.center.z]
			p3=[caja.max.x, caja.max.y, caja.center.z]
			p4=[caja.min.x, caja.max.y, caja.center.z]
			grupo=bloque2d.entities.add_group
			grupo_mover=bloque2d.entities.add_group
			grupo.entities.add_face(p1, p2, p3, p4)
			trim=busca_trim(grupotrim3d)
			if trim
				trans=trim.transformation
				trimdef=trim
				trimdef=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
				grupo_trim=grupo_mover.entities.add_group
				trimdef.entities.intersect_with true, trans, grupo_trim, @@transf_nula, true, grupo
				ymin=grupo_trim.bounds.min.y
				ymax=grupo_trim.bounds.max.y
				borrar=[]
				grupo_trim.entities.each do |e| 
					if e.start.position.y==ymin || e.start.position.y==ymax
						borrar.push(e)
					end	if e.start.position.y== e.end.position.y
				end	
				grupo_trim.entities.erase_entities(borrar)
				grupo_trim.name='DIBAC_TRIM'
				grupotrim3d.entities.erase_entities(trim)
			end
			#instancia=bloque2d.entities.add_instance(definicion, transf_nula)			
			#hacemos la seccion por el centro
			bordes=perimetro_concavo(defbloque, false)
			cara=bloque2d.entities.add_face(bordes)
			bloque2d.entities.erase_entities(cara) if cara
			bloque2d.entities.intersect_with true, @@transf_nula, grupo_mover, @@transf_nula, true, grupo
			bloque2d.entities.erase_entities(grupotrim3d, grupo)
			tpoint=Geom::Point3d.new(0,0,-p1.z)
			transf = Geom::Transformation.new tpoint
			grupo_mover.move! transf
			grupo_mover.explode
		end
	end	
begin
	if !hecho #|| @comando_en_curso == 'Convert to 2D/3D' 
		definicion.entities.clear!
		diccionario=definicion.attribute_dictionary('dynamic_attributes')
		diccionario.each{|key, value| bloque2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		Sketchup.active_model.start_operation('Leyendo componente',true,true,true) #va como una moto auque este en estadisticas 
		bl2d=definicion.entities.add_instance(bloque2d, @@transf_nula)
		bl3d=definicion.entities.add_instance(bloque3d, @@transf_nula)
		@carp[0]=@@current_path+'/model/'+definicion.name+'.skp' #si no existe el bloque en el ordenador ??? lo cambia para siempre
	end
end	
	ruta=@@current_path+'/model/'+definicion.name+'.skp'
	Dibac_Inicio.salva_bloques([definicion.name],@@current_path+'/model/')  if !File.exist?(ruta) 
	return bloque2d, bloque3d#, bl2d, bl3d
end

def crea_auxiliares(pt)
	return #no hay auxiliares
	return if pt==[]
	@cl1 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl2 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl1.direction = [@@hv[0], @@hv[1]]
	@cl2.direction = [-@@hv[1], @@hv[0]]
	@cl1.stipple = @cl2.stipple = "."
	@cl1.start = @cl1.end = @cl2.start = @cl2.end = nil
end

def con_coma(text,sep) #pone coma o punto en funcion del separador de listas o fijo el caracter que se mande para convertir a float
	return text #hemos quitado todo lo que sigue porque ya no hace falta
	if !sep
		sep='.'
		sep=',' if @@separador_listas==';'
	end	
	texto=''
	for i in 0 .. text.length-1
		if text[i].chr=='.' || text[i].chr==','
			texto=texto+sep
		else
			texto=texto+text[i].chr
		end	
	end
	return texto
end

def draw(view)
	textoevaluacion(view)
end	

def nolicencia(inhabilitar)
	#return false #licencia quitada
	return false if @@numserie !=""
	@@veces_que_entra +=1
	@@veces_que_entra = 0 if inhabilitar
	DibacLicencia.informacion(@@datoslicencia) if (@@veces_que_entra % 5 == 0)
	Sketchup.active_model.select_tool nil if inhabilitar	
	return true
end	

def saca_bloque_2d
 	@iguales=false
	@cambiar=nil
	definicion=nil
	#inicioundo(CambiaIdioma(@comando_en_curso))
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == @carp_name} #el bloque completo no lo tengo que repetir
	
	#####CUARENTENA, CREO QUE EL BLOQUE SIEMPRE ESTA
	#if !definicion
	#	Sketchup.active_model.start_operation('Bloque2d', true,true, true) #CAMBIADA
	#	definicion=Sketchup.active_model.definitions.load(@carp[0])
	#end
	
	bloque2d=carpinterias_2d3d(definicion)[0] #El bloque dentro del componente
	Sketchup.active_model.definitions.each do |d| #buscamos una variacion con el mismo nombre base
		if !d.deleted?	
			#por si no hay instancias pero si una definicion válida
			#UI.messagebox(d.name + ' - ' + bloque2d.name.to_s+' - ' + d.get_attribute('dibac','2d').to_s) if d.name.split('#')[0] == bloque2d.name.split('#')[0]
			if d.name.split('#')[0] == bloque2d.name.split('#')[0] #&& d.get_attribute('dibac','2d') #&& d.name.split('#').size > 1
				@iguales=true 
				@carp_attributes.each do |a|
					@iguales= false if d.get_attribute('dynamic_attributes', a).to_s != @carp_defaults[a].to_s
					#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', a).to_s+' - '+@carp_defaults[a].to_s)
				end
				#UI.messagebox(d.name+' - '+@iguales.to_s)
				@iguales=false if !@mobiliario && d.get_attribute('dibac', 'mocheta').to_f.to_l != @mocheta.to_f.to_l 
				#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+ancho_trim(d).to_f.to_l.to_s+' - '+@mocheta.to_f.to_l.to_s)
				if @maximo_hueco && @dibaclenx
					@iguales=false if d.get_attribute('dynamic_attributes', 'dibaclenx').to_f.to_l != @dibacmax.to_f.to_l
				else
					@iguales=false if d.get_attribute('dynamic_attributes', 'dibaclenx').to_f.to_l != @dibaclenx.to_f.to_l
					@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l != @dibacmax.to_f.to_l
				end
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacone').to_i != @dibacone.to_i
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmaxy').to_f.to_l != @dibacmaxy.to_f.to_l
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacleny').to_f.to_l != @dibacleny.to_f.to_l
				#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l.to_s+' - '+@dibacmax.to_f.to_l.to_s)
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacfit').to_f.to_l != @dibacfit.to_f.to_l
				#ahora comproblamos si hay simetria para algun lado
				@cambiar=aspectox(d) if @mobiliario
				if @transform && @cambiar
					vector=@transform.xaxis.transform(Geom::Transformation.rotation([0,0,0], @transform.zaxis, Math::PI/2))
					vector2=@cambiar.transformation.xaxis.transform(Geom::Transformation.rotation([0,0,0],@cambiar.transformation.zaxis, Math::PI/2))
					if !(vector == @transform.yaxis) #buscamos uno que tenga la simetria
						@iguales=false if vector2 == @cambiar.transformation.yaxis		
					else
						@iguales=false if !(vector2 == @cambiar.transformation.yaxis) 
						#@cambiar=false	
					end
				end if @iguales 
				return d if @iguales
			end	
		end	
	end	
	# no son iguales
	return bloque2d
	#return Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque2d.name))
	bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(definicion.name))
	bloque2d.attribute_dictionaries.each do |d|
			d.each{|key, value| bloquenuevo.set_attribute(d.name, key, value)}
	end
	bloquenuevo.entities.add_instance(bloque2d, @@transf_nula).explode
	return bloquenuevo
end

def saca_bloque_3d
	@iguales=false
	@cambiar=nil
	definicion=nil
	#inicioundo(CambiaIdioma(@comando_en_curso))
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == @carp_name} #el bloque completo no lo tengo que repetir

########CUARENTENA	 30/8/2016
	
#	if !definicion
		#Sketchup.active_model.start_operation('Bloque3d', true, false, true) #CAMBIADA t,t,t
		#definicion=Sketchup.active_model.definitions.load(@@current_path+'/model/'+File.basename(@carp[0]+'.skp'))
#	end


	bloque3d=carpinterias_2d3d(definicion)[1]
	#bloque3d.delete_attribute('dibac','3d') #por si esta en el bloque
	#@@carp_1_attributes.each{|key| bloque2d.set_attribute('dynamic_attributes', key, @@carp_1_defaults[key])}
	#	ahora buscamos en definiciones de nuevo y si esta tiene trim y todo lo demas
	Sketchup.active_model.definitions.each do |d|
		if !d.deleted?	
			#por si no hay instancias pero si una definicion válida
			#UI.messagebox(d.name + ' - ' + bloque2d.name.to_s+' - ' + d.get_attribute('dibac','2d').to_s) if d.name.split('#')[0] == bloque2d.name.split('#')[0]
			if d.name.split('#')[0] == bloque3d.name.split('#')[0] #&& d.get_attribute('dibac','2d') #&& d.name.split('#').size > 1
				@iguales=true
				@carp_attributes.each do |a|
					@iguales= false if d.get_attribute('dynamic_attributes', a).to_s != @carp_defaults[a].to_s
					#puts(a.to_s+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', a).to_s+' - '+@carp_defaults[a].to_s)
				end
				#UI.messagebox(d.name+' - '+@iguales.to_s)
				@iguales=false if !@mobiliario && d.get_attribute('dibac', 'mocheta').to_f.to_l != @mocheta.to_f.to_l 
				#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+ancho_trim(d).to_f.to_l.to_s+' - '+@mocheta.to_f.to_l.to_s)
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l != @dibacmax.to_f.to_l
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmaxy').to_f.to_l != @dibacmaxy.to_f.to_l
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibaclenx').to_f.to_l != @dibaclenx.to_f.to_l
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacone').to_i != @dibacone.to_i
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacleny').to_f.to_l != @dibacleny.to_f.to_l
				#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l.to_s+' - '+@dibacmax.to_f.to_l.to_s)
				@iguales=false if d.get_attribute('dynamic_attributes', 'dibacfit').to_f.to_l != @dibacfit.to_f.to_l
				#ahora comproblamos si hay simetria para algun lado
				@cambiar=aspectox(d) if @mobiliario
				if @transform && @cambiar
					vector=@transform.xaxis.transform(Geom::Transformation.rotation([0,0,0], @transform.zaxis, Math::PI/2))
					vector2=@cambiar.transformation.xaxis.transform(Geom::Transformation.rotation([0,0,0],@cambiar.transformation.zaxis, Math::PI/2))
					if !(vector == @transform.yaxis) #buscamos uno que tenga la simetria
						@iguales=false if vector2 == @cambiar.transformation.yaxis		
					else
						@iguales=false if !(vector2 == @cambiar.transformation.yaxis) 
						#@cambiar=false	
					end
				end if @iguales			
				if @iguales && !@mobiliario
					trim=busca_trim_3d(d)
					if trim
						@trim=trim.entities[0]
						if @trim.is_a?(Sketchup::Group)
							@trim_definition=@trim.entities[0].parent
						else
							@trim_definition=@trim.definition
						end	
					else	
						@iguales=false
					end	
				end
				return d if @iguales
			end	
		end	
	end
	return bloque3d 
end

def textoevaluacion(view)
	return if @@numserie == '' #comentar despues del return para quitar para proteccion
	datos_licencia(false) if @@numserie=='promo'
	texto="Dibac: "+ Iscarnet_Dibac.description + ' '
	if @@numserie =='promo' # No tiene licencia
		texto=texto+ CambiaIdioma("Promotional license")+" ("+@@defaultkey+")" 
		x=view.corner(0)[0]
		y=view.corner(0)[1]
	else
		texto=texto+ CambiaIdioma("User")+': ' + @@usuario +" ("+@@email+")" if @@usuario != '' if @@numserie !='Sketchup'
		x=view.corner(2)[0]
		y=view.corner(2)[1]-30
	end	
	view.draw_text([x+2,y+12],texto)
end

def deactivate(view)
	view.invalidate
end	

def vertical(edge)
	return true if edge.start.position.x==edge.end.position.x && edge.start.position.y==edge.end.position.y && edge.start.position.z != edge.end.position.z
end

def texturas(grupo, transf)
	#pone el material de la arista en las caras verticales
	grupo.entities.grep(Sketchup::Face).each do |f|
		f.edges.each do |e|
			 if e.start.position.z==f.bounds.min.z && e.start.position.z==e.end.position.z #linea horizontal abajo
				puntos=e.get_attribute('dibac','material')
				if puntos
					puntos[1]=puntos[1].transform transf
					puntos[3]=puntos[3].transform transf
					f.position_material(e.material,puntos, true)
				else	
					f.material=e.material
				end	
			end	
		end	if f.normal.z.abs < 0.00001
	end	
end

def extrusiona(face, h)
	face.reverse! if face.normal.z < 0
	face.pushpull h, true
end

def long_valida(valor)
	return nil if !valor
	begin
		value = valor.to_l
		return value if value
        value=con_coma(valor,nil).to_l
    rescue
        # Error parsing the text
        UI.beep
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
	return value
end

def numero_valido(valor)
	return nil if !valor
	begin
		value = valor.to_f
		return value if value
        value=con_coma(valor,nil).to_f
    rescue
        # Error parsing the text
        UI.beep
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
	return value
end

def muestra_valor(t)
	Sketchup::set_status_text t, SB_VCB_VALUE
end

def mocheta_real(carp) ##############Por aqui no pasa nunca, hace la mocheta segun el muro lateral de la puerta
	ancho=ancho_carpinteria(carp)
	ptos = []
	# Buscamos los extremos desde el origen y los transformamos para colocarlos sobre la instancia 
	extremo1 = [0, 0, 0].transform! carp.transformation
	extremo2 = [ancho, 0, 0].transform! carp.transformation
	# Dibujamos una linea para tener vertices en las mochetas
	linea = Sketchup.active_model.active_entities.add_line extremo1, extremo2
	# Buscamos las mochetas en cada vertice
	linea.vertices.each do |ver|
		mocheta = nil
		ver.edges.each do |moch|
			# estan en el mismo grupo, componente o modelo
			if mismo_grupo(moch, carp) #########unica llamada a este metodo
				if perpendicular(linea, moch)
					ptos.push(moch.start.position) if !mocheta 
					mocheta = moch
				end
			end	
		end
		ptos.push(mocheta.end.position) if mocheta
	end
	Sketchup.active_model.active_entities.erase_entities linea
	return ptos
end

def busca_trim(bloque) #definicion
	trim=nil
	bloque.entities.each do |e| 
		if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			trim= e if e.name == 'DIBAC_TRIM'
		end
	end	
	return trim
end

def busca_trim_3d(bloque) #definicion
	trim=nil
	Sketchup.active_model.definitions.each do |d| 
		trim=d if d.name == 'trim#'+bloque.name
		break if trim
	end
	return trim
end

def haz_trim_3d
	@mocheta=@@muro_width if !@mocheta
	if @trim
		para_explotar=[]
		explota_trim(@trim, para_explotar)
		para_explotar.pop #quitamos el ultimo que es el bloque padre
		para_explotar.each{|e| e.explode}
		@trim_definition=@trim.definition if @trim.is_a?(Sketchup::ComponentInstance)
		@trim_definition=@trim.parent if @trim.is_a?(Sketchup::Group)
		trim=Sketchup.active_model.definitions.add('trim#'+@puerta3d.name)
		# trim=Sketchup.active_model.active_entities.add_group
		trim.entities.add_instance(@trim_definition, @trim.transformation)
		@puerta3d.entities.erase_entities(@trim)
		@trim=trim.entities[0]
	else
		#Hacemos el trim con un grupo
		@trim=@puerta3d.entities.add_group 
		bordes=perimetro_concavo(@puerta3d, true)
		@trim.entities.clear!
		cara=@trim.entities.add_face(bordes)

		#comparamos trim con bounds
		p1=Geom::Point3d.new(@puerta3d.bounds.min.x, 0, @puerta3d.bounds.min.z) 
		p2=Geom::Point3d.new(@puerta3d.bounds.max.x, 0, @puerta3d.bounds.min.z)
		p3=Geom::Point3d.new(@puerta3d.bounds.max.x, 0, @puerta3d.bounds.max.z) 
		p4=Geom::Point3d.new(@puerta3d.bounds.min.x, 0, @puerta3d.bounds.max.z) 
		if 	@trim.bounds.min.x>p1.x || @trim.bounds.max.x<p3.x || @trim.bounds.min.z>p1.z || @trim.bounds.max.z<p3.z
			@trim.entities.erase_entities(cara)
			cara=@trim.entities.add_face(p1, p2, p3, p4)
		end	
		cara.reverse! if cara.normal.y>0
		
		#hacemos la profundidad del trim igual al espesor del muro sobre el que va la carpinteria
		cara.pushpull(@mocheta)

		#Si no es un solido lo rehacemos
		if !@trim.manifold? 
			@trim.entities.clear!
			cara=@trim.entities.add_face(p1, p2, p3, p4)
			cara.pushpull(@mocheta)
		end
		@trim_definition=@trim.entities[0].parent #es un grupo
		@trim.name='DIBAC_TRIM'
		@trim.visible=false
		
		#borra lineas ocultas en mochetas y dinteles
		borra_coplanarias(@trim.entities.grep(Sketchup::Edge), @trim.entities) 
		
		#para no tener que suavizar los muros
		suaviza(@trim.entities) 
		
		# añade  un componente a definitions, esto hay que mejorarlo para no cargar el dibujo con componentes inutiles
		# posiblemente se pueda hacer con un hash, seguramente se deja niquelao
		trim=Sketchup.active_model.definitions.add('trim#'+@puerta3d.name)
		trim.entities.add_instance(@trim_definition, @trim.transformation)
		@puerta3d.entities.erase_entities(@trim)
		@trim=trim.entities[0]
	end
end	

def borra_nulos(carp)
	return #no borramos nulos
	carp=carp.definition if carp.is_a?(Sketchup::ComponentInstance)
	borrar=[]
	carp.entities.each do |c| 
		if c.is_a?(Sketchup::ComponentInstance)
			if c.bounds.min.distance(c.bounds.max).to_f < 0.05
				borrar.push(c)
			else
				borra_nulos(c)	
			end
		end
	end
	carp.entities.erase_entities(borrar)
end

def muro_carpinteria(carp)
	# devuelve cuatro puntos definidos por las mochetas y todos los puntos de las mochetas
	#  	1-----------------------------4
	#  	|                                  			|
	#  	2-----------------------------3
	mocheta=carp.definition.get_attribute('dibac', 'mocheta').to_f
	trim=busca_trim(carp.definition)
	#trim.transform!(Geom::Transformation.scaling(1, (mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) #creo que el trim ya esta en la definicion de la carpinteria
	definicion=trim #por si es grupo
	definicion=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
	p_t= saca_puntos([],[], definicion, trim.transformation, true, true)[1]  if trim
	xmax = xmin = p_t[0][0]
	pt1=pt2=pt3=pt4=false
	mocheta=(trim.bounds.max.y-trim.bounds.min.y).to_f.to_l
	p_t.each do |p|
		xmin=p[0] if xmin > p[0]
		xmax=p[0] if xmax < p[0]
		if p[1].abs < 0.000001 #p[1]==0
			pt1=p if !pt1
			pt1=p if p[0] < pt1[0] 
			pt3=p if !pt3
			pt3=p if p[0] > pt3[0]
		end
		if (p[1]+mocheta).abs <0.000001 #p[1]==-mocheta
			pt2=p if !pt2
			pt2=p if p[0] < pt2[0]
			pt4=p if !pt4
			pt4=p if p[0] > pt2[0]
		end
	end
	pt1=[xmin,0,0] if !pt1
	pt2=[xmin,-mocheta,0] if !pt2
	pt3=[xmax,0,0] if !pt3
	pt4=[xmax,-mocheta,0] if !pt4
	#ancho=(pt3[0]-pt1[0])
	ptos=[] #los cuatro puntos de la mocheta
	ptos.push(Geom::Point3d.new(pt1.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt2.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt4.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt3.transform(carp.transformation)))
	return ptos, p_t 
end

def perpendicular(linea1, linea2) # edges
	#return false if !linea1 || !linea2
	#verdadero si dos edges son perpendiculares
	return true	if (linea1 && linea2) && (linea1.start.position-linea1.end.position).perpendicular?(linea2.start.position-linea2.end.position)
end

def angulo_inverso(angulo)
	if angulo < Math::PI
		return(angulo + Math::PI) 
	else 
		return(angulo - Math::PI)
	end
end	

def punto_en_segmento(pt, pt1, pt2)
	return false if !pt || !pt1 || !pt2
	pt=Geom::Point3d.new(pt) if pt.class==Array
	pt1=Geom::Point3d.new(pt1) if pt2.class==Array
	pt2=Geom::Point3d.new(pt2) if pt2.class==Array
	return true if pt.distance(pt1)+pt.distance(pt2) < pt1.distance(pt2)+0.0001
	return true if pt.distance(pt1) < 0.0001
	return true if pt.distance(pt2) < 0.0001
	return false
end

def punto_a_distancia(pt1, pt2, dist)
	return pt1 if dist==0
	@long = pt1.distance(pt2)
	return nil if @long == 0.0 
	return Geom.linear_combination(dist/@long, pt2, 1-(dist/@long), pt1)
end

def punto_medio(pt1, pt2)
	return Geom.linear_combination(0.5, pt1, 0.5, pt2)
end

def puntos_2d(bloque2d)  #para carpinterias
	return if @mocheta == @grueso_muro && !@mobiliario && !bloque2d #con el mobiliario comprobamos siempre los puntos por si hay simetrias que se deben cambiar
	if !bloque2d
		@mocheta=@grueso_muro
		bloque2d=saca_bloque_2d
	else
		@iguales=true
	end
	@puede_max=bloque2d.get_attribute('dynamic_attributes','dibacmax')
	@puede_maxy=bloque2d.get_attribute('dynamic_attributes','dibacmaxy')
	@dibaclenx=bloque2d.get_attribute('dynamic_attributes', 'dibaclenx')
	@dibacleny=bloque2d.get_attribute('dynamic_attributes', 'dibacleny')
	@dibacone=bloque2d.get_attribute('dynamic_attributes', 'dibacone')
	@mochetamin=bloque2d.get_attribute('dynamic_attributes', 'dibacwmin').to_f
	@mochetamax=bloque2d.get_attribute('dynamic_attributes', 'dibacwmax').to_f
	
	if bloque2d.is_a?(Sketchup::ComponentDefinition) && !@iguales
		#if !@mobiliario
			Sketchup.active_model.start_operation(CambiaIdioma('Load component'), false, true, true) # para que no salga deshacer redraw
			trim=busca_trim(bloque2d)
			if trim
				m=@mocheta
				if @mochetamin>0
					m=@mochetamin if @mocheta<@mochetamin
				end
				if @mochetamax>0 
					m=@mochetamax if @mocheta>@mochetamax
				end
				trim.transform!(Geom::Transformation.scaling(1, (m/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) if trim
			end	
		#end	
		puerta=Sketchup.active_model.active_entities.add_instance(bloque2d, @@transf_nula).make_unique
		@puerta2d=puerta.definition 
		@carp_attributes.each{|key| @puerta2d.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
		@puerta2d.set_attribute('dynamic_attributes','dibacmax', @dibacmax.to_f) if @puede_max
		@puerta2d.set_attribute('dynamic_attributes','dibacmaxy', @dibacmaxy.to_f) if @puede_maxy
		@puerta2d.set_attribute('dynamic_attributes','dibacwthick', @mocheta.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacwthick')
		if !@dibacfit
			@dibacfit=bloque2d.get_attribute('dynamic_attributes','dibacfit')
		else
			bloque2d.set_attribute('dynamic_attributes','dibacfit', @dibacfit.to_f)
		end if bloque2d.get_attribute('dynamic_attributes','dibacfit')
		modificar(puerta) if @cambiar
		diccionario=bloque2d.attribute_dictionary('dynamic_attributes')
		diccionario.each{|key, value| @puerta2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		@carp_attributes.each do |key| 
			@puerta2d.set_attribute('dynamic_attributes', key, @carp_defaults[key])
			@puerta2d.set_attribute('dynamic_attributes', '_'+key+'_label', key) if !@puerta2d.get_attribute('dynamic_attributes', '_'+key+'_label')
			@puerta2d.set_attribute('dynamic_attributes', '_'+key+'_units', @carp_units[key]) if !@puerta2d.get_attribute('dynamic_attributes', '_'+key+'_units')
			@puerta2d.set_attribute('dynamic_attributes', '_'+key+'_formlabel', @carp_prompts[key]) if !@puerta2d.get_attribute('dynamic_attributes', '_'+key+'_formlabel')
			@puerta2d.set_attribute('dynamic_attributes', '_'+key+'_access', @carp_access[key]) if !@puerta2d.get_attribute('dynamic_attributes', '_'+key+'_access')
			@puerta2d.set_attribute('dynamic_attributes', '_'+key+'_options', @carp_options[key]) if @carp_options[key] && !@puerta2d.get_attribute('dynamic_attributes', '_'+key+'_options')
		end
		@puerta2d.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
		@puerta2d.set_attribute('dibac','mocheta', @mocheta.to_f) if !@mobiliario
		@puerta2d.set_attribute('dynamic_attributes','dibacmax', @dibacmax.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacmax')
		@puerta2d.set_attribute('dynamic_attributes','dibaclenx', @dibaclenx.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibaclenx')
		@puerta2d.set_attribute('dynamic_attributes','dibacone', @dibacone.to_i) if @puerta2d.get_attribute('dynamic_attributes','dibacone')
		@puerta2d.set_attribute('dynamic_attributes','dibacmaxy', @dibacmaxy.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacmaxy')
		@puerta2d.set_attribute('dynamic_attributes','dibacfit', @dibacfit.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacfit')
		@puerta2d.set_attribute('dynamic_attributes','dibacwthick', @mocheta.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacwthick')
		# $dc_observers.get_latest_class.redraw(puerta, false) if puerta
		if puerta
			until dc_redraw(puerta, true, true); end
			# $dc_observers.get_latest_class.redraw_with_undo(puerta)
			undotransparente
		end	
		#puts('puntos_2d')
		borra_nulos(@puerta2d) 
		Sketchup.active_model.active_entities.erase_entities(puerta)
	else
		@puerta2d=bloque2d.definition if bloque2d.is_a?(Sketchup::ComponentInstance)
		@puerta2d=bloque2d if bloque2d.is_a?(Sketchup::ComponentDefinition)
	end
	#Sketchup.active_model.start_operation('Otro primero', true, false, true) #para que no salga deshacer propiedades en la lista
	@puerta2d.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
	@puerta2d.set_attribute('dibac','mocheta', @mocheta.to_f) if !@mobiliario
	ptos= saca_puntos([],[],@puerta2d, nil, false, true) 	#el primer bloque no tiene transformacion
	@p_c = ptos[0]   
	@p_t = ptos[1] #puntos para trim
	if @mobiliario
		@p_t=@p_c
	else	
		@notrim=false
		haz_trim(@puerta2d) if @p_t.size<4 #trim tiene que tener al menos cuatro puntos  
	end	
	@pt1=@pt2=@pt3=@pt4 = nil
	xmax = xmin = @p_t[0][0]
	@p_t.each do |p|
#		puts(p[0].to_f.to_l.to_s+','+p[1].to_f.to_l.to_s+','+p[2].to_f.to_l.to_s)
		xmin=p[0] if xmin > p[0]
		xmax=p[0] if xmax < p[0]
		if p[1].abs <= 0.000001
			@pt1=p if !@pt1
			@pt1=p if p[0] < @pt1[0] 
			@pt3=p if !@pt3
			@pt3=p if p[0] > @pt3[0]
		end
		if p[1]+@mocheta < 0.000001
			@pt2=p if !@pt2
			@pt2=p if p[0] < @pt2[0]
			@pt4=p if !@pt4
			@pt4=p if p[0] > @pt2[0]
		end if !@mobiliario
	end
	@pt1=[xmin,0,0] if !@pt1
	@pt2=[xmin,-@mocheta,0] if !@pt2
	@pt3=[xmax,0,0] if !@pt3
	@pt4=[xmax,-@mocheta,0] if !@pt4
	@ancho=(@pt3[0]-@pt1[0])
#	puts('____PUNTOS_____')
#	puts(@pt1[0].to_f.to_l.to_s+','+@pt1[1].to_f.to_l.to_s+','+@pt1[2].to_f.to_l.to_s)
#	puts(@pt2[0].to_f.to_l.to_s+','+@pt2[1].to_f.to_l.to_s+','+@pt2[2].to_f.to_l.to_s)
#	puts(@pt3[0].to_f.to_l.to_s+','+@pt3[1].to_f.to_l.to_s+','+@pt3[2].to_f.to_l.to_s)
#	puts(@pt4[0].to_f.to_l.to_s+','+@pt4[1].to_f.to_l.to_s+','+@pt4[2].to_f.to_l.to_s)
#	puts(@ancho)
	#Sketchup.undo #Quita la definicion de la puerta para que no se llene
end

def otra_cara_perp(cara1, pt)
	return nil if !cara1
	return nil if cara1.deleted?
	return nil if cara1.faces.size != 1
	pt = pt.project_to_line cara1.line if !punto_en_segmento(pt, cara1.start.position, cara1.end.position) #Si no está en cara1
	gru = 100000.0
	resultado = nil
	vec1 = cara1.start.position - cara1.end.position
	face = cara1.faces[0]
	face.edges.each do |e|
		if cara1 != e
			vec2 = e.start.position - e.end.position
			if vec1.parallel? vec2
				pt1 = pt.project_to_line e.line
				if punto_en_segmento(pt1, e.start.position, e.end.position) #Está en la perpendicular
					# para que no haga muro con dos lineas paralelas myu juntas de la misma face
					pt3=punto_medio(pt,pt1)
					pt31=punto_medio(pt3,pt1)
					pt32=punto_medio(pt,pt3)
					if face.classify_point(pt3) == Sketchup::Face::PointInside && face.classify_point(pt31) == Sketchup::Face::PointInside && face.classify_point(pt32) == Sketchup::Face::PointInside
						ptos=tramo_comun(edge_extremos(cara1, pt), edge_extremos(e, pt))
						distancia=pt.distance(pt1)
						if distancia < gru
							gru =  distancia
							resultado = e
							#@dar_vuelta = vec1.normalize != vec2.normalize 
							# @ptperp usado por otros procedimientos
							@ptperp = pt1 
						end	if ptos[0] != ptos[1]
					end
				end	
			end
		end	
	end
	return resultado
end	

def edge_extremos(e, pt) #saca los extrmos de una linea desde los finals con muros o carpinterias utilizando intermedios
	pt1=e.start.position
	pt2=e.end.position
	pt=pt.project_to_line e.line #if !punto_en_segmento(pt, e.start.position, e.end.position) #Si no está en e
	inter1=intermedios(nil,[e.start.position, pt], false, true)
	inter2=intermedios(nil,[pt, e.end.position], false, true)
	pt1=inter1[inter1.size-1] if inter1 !=[]
	pt2=inter2[0] if inter2 !=[]
	return([pt1, pt2])
end

def tramo_comun(l1, l2)
	if l1[0].distance(l1[1]) >0 && l2[0].distance(l2[1]) > 0
		pt1 = l1[0]
		pt2 = l2[0].project_to_line(l1) 
		pt3 = l2[1].project_to_line(l1)
		pt4 = l1[1]
		if(pt2 == pt4) or(pt3 == pt1)
			ptini = pt3
			pt3 = pt2
			pt2 = ptini
		end
		if punto_en_segmento(pt1 , pt2, pt3)
			ptini = pt1 
		elsif punto_en_segmento(pt2 , pt1, pt4)	
			ptini = pt2 	
		elsif punto_en_segmento(pt3 , pt1, pt4)
			ptini = pt3
		elsif
			punto_en_segmento(pt4 , pt2, pt3)
			ptini = pt4
		else
			return []
		end	
		if punto_en_segmento(pt4 , pt2, pt3)
			ptfin = pt4 
		elsif punto_en_segmento(pt3 , pt1, pt4)	
			ptfin = pt3 	
		else
			ptfin = pt2
		end	
		return[ptini, ptfin]
	end
	return []
end

def inicioundo(comando)
	Sketchup.active_model.start_operation comando, false, false, false
end

def finalundo
	#Sketchup.active_model.start_operation "finalundo", true, false, true #si aparece finalundo en la lista es que hay algo mal
	Sketchup.active_model.commit_operation
end

def undotransparente
	Sketchup.active_model.start_operation "finalundo",false, false, true #si aparece finalundo en la lista es que hay algo mal
end

def borra_coplanarias_3d(model) #borra planos verticales interiores y coplanarias en  model 
	entidades=model.entities
	selborrar = []
	entidades.grep(Sketchup::Edge).each do |e|
		if e.faces.size < 2
			selborrar.push e #borramos las caras que no estan cerradas
		end
	end
	entidades.erase_entities selborrar if selborrar != []
	selborrar = []
	entidades=model.entities
	entidades.grep(Sketchup::Edge).each do |e|
		if(e.faces.size == 2)
			selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 
		end
	end
	entidades.erase_entities selborrar if selborrar != []  
	selborrar = []
	entidades=model.entities
	entidades.grep(Sketchup::Edge).each do |e|
		if(e.faces.size == 0)
			selborrar.push e   
		end
	end
	entidades.erase_entities selborrar if selborrar != []  
end
 
def mismo_grupo(x, y) ############# no se usa, se llama solo desde mocheta_real
	return true if x.parent == y.parent
	return false
end
 
def interseccion_real(pt1, pt2, pt3, pt4)
	pt1=Geom::Point3d.new(pt1)if pt1.class==Array
	pt2=Geom::Point3d.new(pt2)if pt2.class==Array
	pt3=Geom::Point3d.new(pt3)if pt3.class==Array
	pt4=Geom::Point3d.new(pt4)if pt4.class==Array
	return nil if !pt1 || !pt2
	return pt1 if pt1==pt3 || pt1==pt4
	return pt2 if pt2==pt3 || pt2==pt4
	pt = Geom.intersect_line_line([pt1, pt2],[pt3, pt4])
	return pt if punto_en_segmento(pt, pt1, pt2) && punto_en_segmento(pt, pt3, pt4)
	return nil
end 

def interseccion_real_edges(e1,e2)
	pt1=e1.start.position
	pt2=e1.end.position
	pt3=e2.start.position
	pt4=e2.end.position
	return interseccion_real(pt1,pt2,pt3,pt4)
end	

def otro_vertice(l, p)
	return l[0] if l[1]==p
	return l[1] if l[0]==p
	return nil
end

def perimetro_concavo(definicion, vertical)
	caja=definicion.bounds
	if vertical
		transf=Geom::Transformation.rotation([0,0,0],[1,0,0],Math::PI/2) #lo tiramos al suelo alrededor de eje x 
	else
		transf=Geom::Transformation.new
	end	
	puntos=saca_puntos([],[],definicion,transf,false, false)[0]
	return nil if puntos.size==0
	lineas=[]
	#grupo=Sketchup.active_model.active_entities.add_group
	0.step(puntos.size-1,2) do |i| 
		p1=puntos[i].transform(transf.inverse)
		p2=puntos[i+1].transform(transf.inverse)
		lineas.push([p1, p2]) if p1!=p2
		#grupo.entities.add_line(p1,p2) if p1!=p2
	end
	#grupo.entities.each{|l| lineas.push([l.start.position,l.end.position])}	
	#Sketchup.active_model.active_entities.erase_entities(grupo)
	#lineas.each{|l| Sketchup.active_model.active_entities.add_line(l[0].transform(transf),l[1].transform(transf))}
	primer_p=lineas[0][0]					
	lineas.each do |p| #todo son lineas
		#buscamos el de mas a la derecha
		primer_p=p[0] if p[0].transform(transf).x > primer_p.transform(transf).x 
		primer_p=p[1] if p[1].transform(transf).x > primer_p.transform(transf).x 
	end
	p_actual=p_anterior=angulocomp=nil
	bordes=[]
	#Sketchup.active_model.active_entities.add_instance(trim, transf)
	while p_actual != primer_p do
		p_actual=primer_p if !p_actual #ponemos el primer punto
		#Sketchup.active_model.active_entities.add_cpoint(p_actual.transform(transf)) #Descomentar para comprobacion
		bordes.push(p_actual) # lo insertamos eb bordes
		lineas_punto=lineas.select{|a| a.include?(p_actual)} #buscamos las lineas en p_actual
		l_actual=lineas_punto[0] if !l_actual
		sig_l=nil
		lineas_punto.each{|l| l_actual=l if (!sig_l)}# && l!=l_actual)}
		sig_p=otro_vertice(l_actual, p_actual)
		if angulocomp
			angulocomp=angulo_recta(p_actual.transform(transf), p_anterior.transform(transf))
		else
			angulocomp=0
		end	
		#UI.messagebox(angulocomp*180/Math::PI)
		angulo1 = 2*Math::PI #para que siempre haya uno menor
		lineas_punto.each do |j|
			#if lineas.select{|a| a.include?(otro_vertice(j, p_actual))}.size>1 #comprobamos que no estamos en un callejon sin salida
				angulo2 = angulo_recta(p_actual.transform(transf), otro_vertice(j, p_actual).transform(transf))
				#angulo2 = 2*Math::PI if angulo2 == 0
				angulo2=angulocomp if !angulo2
				angulo2 = angulo2 - angulocomp #colocamos angulocomp como 0
				angulo2 = 0 if angulo2.abs < 0.000001
				angulo2=angulo2+2*Math::PI if angulo2 < 0
				a=sig_l[0].distance(sig_l[1]) if sig_l
				#UI.messagebox(lineas_punto.size.to_s+' - '+(angulo1*180/Math::PI).to_s+'('+a.to_s+')'+' - '+(angulo2*180/Math::PI).to_s+' - '+j[0].to_s+' - '+j[1].to_s+' - '+(j[0]-j[1]).length.to_l.to_s) #Descomentar para comprobacion
				if (angulo2 - angulo1).abs < 0.000001 #iguales
					if j[0].distance(j[1]) < sig_l[0].distance(sig_l[1]) # nos quedamos con el mas corto
						sig_p=otro_vertice(j, p_actual)
						sig_l=j 
					end	
				elsif angulo2 < angulo1
					angulo1 = angulo2	
					sig_p=otro_vertice(j, p_actual)
					sig_l=j 
				end if angulo2 != 0
				#end if j != l_actual  #if otro_vertice(j, p_actual) != p_anterior
			#end	
		end
		break if bordes.include?(sig_p)
		#Sketchup.active_model.active_entities.add_line(sig_l[0].transform(transf),sig_l[1].transform(transf))
		#break if bordes.include?(sig_p)
		#bordes.push(sig_edge)
		l_actual=sig_l
=begin		
		#ahora buscamos interseccion con el resto de lineas	
		p1=p_actual
		p2=sig_p
		l_nuevas=[]
		lineas.each do |l|
			p3=l[0]
			p4=l[1]
			pt=interseccion_real(p1,p2,p3,p4)
			if pt	
				if pt != p1 && pt != p2
					l_nuevas.push([pt, sig_p])	
					if sig_p == l[0]
						l[0] = pt 
					else
						l[1] = pt
					end	
					sig_p=pt
					p2=pt
				end
				if pt != p3 && pt != p4
					l_nuevas.push([pt, p4])
					l[1] = pt
				end
			end
		end
		l_nuevas.each{|l| lineas.push(l)}
=end		
		p_anterior=p_actual
		p_actual=sig_p
	end
	return bordes
end

def saca_puntos(p_c, p_t, bloque, trans, trim, smooth) #da los puntos de una carpinteria en 2d y las mochetas
	trans=Geom::Transformation.new if !trans
	bloque=bloque.definition if bloque.is_a?(Sketchup::ComponentInstance)
	bloque.entities.each do |e|
		incluir=true
		if e.is_a?(Sketchup::Edge)#if (e.visible? && !e.hidden?)  
			incluir=false if (e.smooth? && smooth)
			if incluir
				punto=e.start.position.transform(trans)
				p_c.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f))
				p_t.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f)) if trim
				punto=e.end.position.transform(trans)
				p_c.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f))
				p_t.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f)) if trim
			end	
		end #if e.is_a?(Sketchup::Edge)
		saca_puntos(p_c,p_t,e.definition, trans*e.transformation, (e.name=='DIBAC_TRIM') || trim, smooth) if (e.is_a?(Sketchup::ComponentInstance))#recursivo
		saca_puntos(p_c,p_t,e , trans*e.transformation, (e.name=='DIBAC_TRIM') || trim, smooth) if (e.is_a?(Sketchup::Group))#recursivo
	end
	return p_c, p_t
end

def intermedios(entities,linea,extremos,carpinterias) # Devuelve el primer punto de la line y las intesecciones con muros. 
	puntos = [] 
	entities=Sketchup.active_model.active_entities if !entities
	entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if e.faces.size == 1
				pt = interseccion_real(linea[0], linea[1], e.start.position, e.end.position)
				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)
					puntos.push(pt)
				end if pt
			end	
		elsif e.is_a?(Sketchup::ComponentInstance) && carpinterias
			if tipo_bloque(e) =='carpinteria'
				ptcarp=muro_carpinteria(e)[0]
  				pt = interseccion_real(linea[0], linea[1], ptcarp[0], ptcarp[3])
				if extremos ||(pt != linea[1] && pt != linea[2] && pt != puntos.last)
					puntos.push(pt)
				end if pt
				pt = interseccion_real(linea[0], linea[1], ptcarp[1], ptcarp[2])
				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)
					puntos.push(pt)
				end if pt
			end
		end
	end
	return puntos if puntos.size < 2
	i = -1
	result=[]
	ultimadistancia=-1
	while i < puntos.size-1 do
		j = 0
		k = 0
		distancia = 10000000.0
		while j < puntos.size
			if puntos[j] 
				dist = linea[0].distance(puntos[j])
				if dist < distancia
					distancia = dist
					punto = puntos[j]
					k = j
				end	
			end 
			j += 1
		end
		result.push(punto) if distancia > ultimadistancia
		ultimadistancia=distancia
		puntos[k] = nil
		i += 1
	end	
	return(result)
end

def onCancel(flag, view)
	reset
	view.lock_inference if( view.inference_locked? )
	view.invalidate
	#menu if flag==0 #para diferenciarlo de Ctrl-Z
end

def texto_comando #por si no hay
end

def draw(view)
	texto_comando
end	

def onRButtonDown(flags, x, y, view)
	#reset
	view.invalidate
	menu
end	

def menu	
	reset #para las funciones que no tiene menu
end

def pon_color(entidad,mat)
	return if !entidad
	if mat =="<Ninguno>"
		mat = nil
	end
	entidad.material=mat
	entidad.back_material = mat if entidad.is_a?(Sketchup::Face)
end

def datos_menu(definicion, attr, prompts, defaults, units, access, options) #carpinteria y 3D
	diccionario=definicion.attribute_dictionary('dynamic_attributes')
	diccionario.each do |key, value|
		if value == 'TEXTBOX' || value == 'LIST'
			propiedad=key.split('_')[1]
			propiedad=propiedad+'_'+key.split('_')[2] if propiedad == 'dibac'
			attr.push(propiedad)
			prompts[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_formlabel')
			units[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_units')
			defaults[propiedad]=definicion.get_attribute('dynamic_attributes', propiedad)
			access[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_access')
			options[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_options')
		end
	end if diccionario
	#definicion.entities.each {|e| datos_menu(e.definition, attr, prompts, defaults, units, access, options) if e.is_a?(Sketchup::ComponentInstance)}#recursivo
end

def saca_definicion #BUSCAMOS EN TEMP
	definicion=nil
	nombre=File.basename(@carp[0],".skp")
	Sketchup.active_model.definitions.each{|d| definicion=d if !definicion && d.name==nombre }
	Sketchup.active_model.definitions.each{|d| definicion=d if !definicion && d.name == @carp[0]} if !definicion #el bloque completo no lo tengo que repetir
	begin
		Sketchup.active_model.start_operation('Cargar componente', true, false, true) #CAMBIADO t,t,t
		if File.exist?(@carp[0])
			definicion=Sketchup.active_model.definitions.load(@carp[0]) 
		else
			definicion=Sketchup.active_model.definitions.load(@@current_path+'/model/'+nombre+'.skp') 
		end	
	rescue
		return
	end	if !definicion
	return definicion
end

def saca_menu(definicion)
	@carp_attributes = []
	@carp_prompts = Hash.new
	@carp_defaults = Hash.new
	@carp_units = Hash.new
	@carp_access = Hash.new
	@carp_options = Hash.new
	defbase=saca_definicion
	definicion=defbase if !definicion #para que saque los atributos del objeto
	return false if !definicion
	@carp_epigrafe=defbase.get_attribute('dynamic_attributes','description')
	@carp_name=definicion.name

	bloques=carpinterias_2d3d(definicion) #sacamos el menu de la carpinteria 2d y de la 3d
	datos_menu(bloques[0], @carp_attributes , @carp_prompts, @carp_defaults, @carp_units, @carp_access, @carp_options)

	datos_menu(bloques[1], @carp_attributes , @carp_prompts, @carp_defaults, @carp_units, @carp_access, @carp_options)
	@carp_attributes.uniq!
	@carp_attributes=@carp_attributes.sort
	return true
end

end # de la clase Dibac_Base

class Dibac_Borrar < Dibac_Base
=begin
 Clase	        	:	Borrar
 Desciende de		:	Dibac
 Descripción   		:	Realiza el borrado de elementos de Dibac
 Item de Menu  	:	Dibujo->Dibac->Borrar elementos Dibac // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se marca lo que se quiere borrar y se reparan lo empalmes o se cierran los		
							huecos de	carpinterias.
							Para que funcione a borrar muros hay que marcarlos en puntos donde la 
							ortogonal corte a la otra cara.
							Si se marcan elemento que no son de Dibac se realiza el borrado normal.

Fecha        		:	14/11/2010
=end

def reset
	@puntos_muro = []
	@carpinterias = []
	@previo=true if Sketchup.active_model.selection.count>0
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto = CambiaIdioma("Select items to erase or drag across multiple items.")
	texto = texto + " " + CambiaIdioma("Shift")+"="+CambiaIdioma("Hide")
	texto = texto +", Ctrl=" if WIN
	texto = texto +", Option=" if MAC
	texto = texto +CambiaIdioma("Soften/Smoth")
	texto = texto +", Alt=" if WIN
	texto = texto +", Cmd=" if MAC
	texto = texto+CambiaIdioma("Dibac")+"."
	Sketchup::set_status_text  texto
	@cursor = @@borrarcursor_id if !@cursor
end

def activate
	Sketchup.active_model.active_view.invalidate
	reset
end	

def onSetCursor
	UI.set_cursor(@cursor)
end

def selecciona(x, y, view)
	return if !@borrando
	ph = view.pick_helper #Inicializa pickhelper
	ph.do_pick x, y #pick inicial buscando todos los elementos en el punto x,y
	# Sketchup.active_model.active_entities.add_cpoint((view.inputpoint x,y).position)
	Sketchup.active_model.selection.clear if @previo
	@previo=false
	@puntos_muro.push [x,y]
	for i in 0 ... ph.count
		e=ph.element_at(i)
		begin
		if !ph.leaf_at(i).is_a?(Sketchup::Face)
			@carpinterias << e if e.is_a?(Sketchup::ComponentInstance) 
			if e.is_a?(Sketchup::Edge) && e.curve
				e.curve.edges.each{|d|  Sketchup.active_model.selection.add d}
			else	
				Sketchup.active_model.selection.add e 
 			end	
		end
		rescue	
		end	#if !e.is_a?(Sketchup::Axes) #detecta los ejes y da un error en consola ruby
	end	
end

def onMouseMove(flags, x, y, view)
	selecciona(x, y, view)
end

def onLButtonDown(flags, x, y, view)
	@borrando = true
	selecciona(x, y, view)
end

def onLButtonUp(flags, x, y, view)
	@pulsado_shift = false if Dibac_Extension.cambio_view
	@borrando = false
	sel = Sketchup.active_model.selection
	if @pulsado_shift && !@pulsado_ctrl
		inicioundo(CambiaIdioma("Hide"))
		sel.each { |e| e.hidden=true}	
		sel.clear
		finalundo
		return	
	end
	if @pulsado_ctrl && !@pulsado_shift
		inicioundo(CambiaIdioma("Soften edges"))
		sel.grep(Sketchup::Edge).each do |e| 
			e.soft=true
			e.smooth=true
		end		
		sel.clear
		finalundo
		return	
	end
	inicioundo(CambiaIdioma("Erase"))	
	if @pulsado_alt
		@puntos_muro.each do |pt|
			borra_muro(pt[0], pt[1], view, true)
		end
		@carpinterias.each do |carp|
			borra_carpinteria(carp, nil) if !carp.deleted?
		end
		reset
	end
	Sketchup.active_model.active_entities.erase_entities sel
	finalundo
end

def onKeyDown(key, rpt, flags, view)
	@pulsado_shift = false if Dibac_Extension.cambio_view
	@pulsado_shift = true if key == CONSTRAIN_MODIFIER_KEY
	@pulsado_ctrl = true if key == COPY_MODIFIER_KEY
	@pulsado_alt = true if key == ALT_MODIFIER_KEY
	#@cursor = @@borrarcursordibac_id if key == ALT_MODIFIER_KEY
	Dibac_Extension.cambio_view= false if @pulsado_shift
end

def onKeyUp(key, rpt, flags, view)
	#@cursor = @@borrarcursor_id
	@pulsado_shift = false if key == CONSTRAIN_MODIFIER_KEY
	@pulsado_ctrl = false if key == COPY_MODIFIER_KEY
	@pulsado_alt = false if key == ALT_MODIFIER_KEY
end

def draw(view)
	textoevaluacion(view)
end

end # de la clase Borrar

class Dibac_Muro < Dibac_Base
=begin
 Clase	        		:	Muro
 Desciende de		:	Dibac
 Descripción   		:	Dibuja muros en planta
 Item de Menu  	:	Dibujo->Dibac->Muro // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         		:	Para dibujar el muro primero se tiene que proporcionar el
						punto de arranque. Luego se van marcando los puntos sucesivos.
						Pulsando [Tab] se cambia la cara de enganche entre izquierda,
						centro y derecha sucesivamente.
						Si se introdue un numero positivo se toma como longitud en la direccion marcada.   
								Si se introduce un numero negativo se toma como espesor del	muro.
								Para terminar una secuencia de muro se pulsa [Esc].
								Cuando se engancha a una arista esta se marca en magenta.
								Para cambiar el angulo del de las guias se introduce el caracter "<"(menor que)
								sequido el nuevo angulo
								Si se introduce una secuencia de numeros separados por @@separador_listas se interpretara que cada uno
								de ellos sera un muro girado 90 grados o -90 grados segun el signo y con la longitud del numero
								asi para introducir una planta en L de lados 5,10,5,5,10,15 introducimos lo siguiente desde el
								primer punto saliendo a la derecha 5;10;-5;5;10;15
             		   
             		  
 Fecha        			:	14/11/2010
=end

def menu
	@@cuentagotas=@@muro_width if !@@cuentagotas
	nolicencia(false)
	prompts = 	[CambiaIdioma("Thickness")	]
		defaults = [	@@muro_width.to_l.to_s
						]
	list = 			[	""
						]
	if @@cuentagotas
		@@muro_width=@@cuentagotas
		@@cuentagotas = nil
	else
		input = UI.inputbox prompts, defaults, list, CambiaIdioma("Wall")
		if input
			h1 = a_longitud(input[0]).abs
			@@muro_width = h1 if h1>0
			case input[1].to_s
			when CambiaIdioma("Left") 
				@@muro_cara=0.0
			when CambiaIdioma("Center") 
				@@muro_cara=0.5
			when CambiaIdioma("Right")
				@@muro_cara=1.0
			end
			h1 = input[2].to_s.upcase
		else	
			Sketchup.active_model.select_tool nil	
			return
		end
	end	
	Sketchup.write_default("Dibac","Wall",@@muro_width.to_f)		
end

def reset
	Sketchup.active_model.active_view.invalidate
	@tramo=nil
	@@ip1.clear
	borra_auxiliares
	#Sketchup.active_model.commit_operation if @primer_punto
	finalundo if @primer_punto
	@primer_punto = @pulsado_tab = @midiendo = false
	# puntos temporales para el muro enganchado al cursor
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
	# aristas a las que se engancha al principio y al final
	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end

def activate
	@comando_en_curso = "Wall"
	#Dibac_Extension.esquema!
	menu
	reset
end

def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+"."# +"["+ @@muro_width.to_l.to_s+"]. "
	if !@primer_punto && !@ultima_dist
		texto = texto+CambiaIdioma("Starting point")+"."
		Sketchup::set_status_text CambiaIdioma("Thickness")+":", SB_VCB_LABEL
	else	
		texto= texto+CambiaIdioma("End point")+ "." 
		Sketchup::set_status_text CambiaIdioma("Length")+" "+@@separador_listas+" "+CambiaIdioma("Thickness") + ":",SB_VCB_LABEL
	end	
	if @primer_punto
		texto = texto + " Tab="+CambiaIdioma("Change edge")+"." if WIN
		texto = texto + " Ctrl="+CambiaIdioma("Change edge")+"." if MAC
	end	
	Sketchup::set_status_text  texto 
end		

def deactivate(view)
	reset
	finalundo #cerramos el undo que esta abierto al salir
	view.invalidate
end

def onSetCursor
	UI.set_cursor(@@murocursor_id)
end

def calcula_puntos
	#return false if !@pt1 || !@pt2
	return false if !@primer_punto
	if @comando_en_curso == "Wall"
		if @vertice1 && @vertice2
			vec =(@vertice1.position - @vertice2.position)
			@ptini = @vertice1.position.offset(vec, -@@muro_cara*vec.length)
		end	
	end	
	i = 1
	while i < 5  #para ponerse en el lado bueno cuando de sale de una esquina
		if @@muro_cara > 0 then
			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]
			if vec.length>0
				@pt1 = @ptini.offset(vec, @@muro_cara * @@muro_width)	 
				@pt2 = @ptfin.offset(vec, @@muro_cara * @@muro_width)
			end	
		else
			@pt1 = @ptini	 
			@pt2 = @ptfin	   
		end
		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]
		if vec.length>0
			@pt3 = @pt1.offset(vec, @@muro_width) if @pt1!=[]
			@pt4 = @pt2.offset(vec, @@muro_width) if @pt2!=[]	  
		end	
		return if @comando_en_curso != "Wall"
		if !@arfin.deleted? 
			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line) 
			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line) if @pt4!=[]
			if 	punto_en_segmento(pt0,@arfin.start.position,@arfin.end.position )
				@pt2 = pt0
				@pt4 = pt1
			end	if punto_en_segmento(pt1,@arfin.start.position,@arfin.end.position )
		end if @arfin
		if @lineai && @linead
			# Si existe la interseccion movemos el extremo
			@pt1 = pt0 if pt0 = Geom.intersect_line_line([@pt1, @pt2], @lineai)
			@pt3 = pt0 if pt0 = Geom.intersect_line_line([@pt3, @pt4], @linead)
		elsif @arini && !@arini.deleted?
			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arini.line)
			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arini.line) if @pt4!=[]
			if 	punto_en_segmento(pt0,@arini.start.position,@arini.end.position )
				@pt1 = pt0 
				@pt3 = pt1 
				#@pulsado_tab = true
				return true
			end if punto_en_segmento(pt1,@arini.start.position,@arini.end.position )
			if !@pulsado_tab
				i += 1 
				tabulador
			end 
		end	
		i = 5 if !@arini || @pulsado_tab 
	end
	@pulsado_tab = true
end
 
def onMouseMove(flags, x, y, view)
	 return false if( !@@ip.pick(view, x, y, @@ip1))
	texto_comando # por si se ha borrado con otro comando
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @@ip.tooltip
	if !@primer_punto
		Sketchup::set_status_text @@muro_width.to_l, SB_VCB_VALUE
		view.invalidate if @arini = busca_cara(x, y, view)
    else
		@ptfin = @@ip.position
		@ptfin.z=@ptini.z
		@dist = @ptini.distance(@ptfin)
		Sketchup::set_status_text @dist.to_l.to_s+" "+@@separador_listas+" "+@@muro_width.to_l.to_s, SB_VCB_VALUE
		calcula_puntos if @dist > 0
		@arfin = busca_cara(x, y, view)
	end
	view.invalidate
end
 
def haz_muro
	@tramo=true
	puntos = intermedios(nil,[@pt1,@pt2], false,false).unshift(@pt1)
	pt1 = puntos.last
	puntos = puntos + intermedios(nil,[@pt2,@pt4], false,false).unshift(@pt2)
	x = intermedios(nil,[@pt4,@pt3], false,false).unshift(@pt4)
	pt2 = @pt3
	pt2 = x[1] if x.size > 1
	puntos = puntos + x
	puntos = puntos + intermedios(nil,[@pt3,@pt1], false,false).unshift(@pt3)
	begin #por si el muro se deja a cero.
		face = Sketchup.active_model.active_entities.add_face puntos 
		pon_color(face,@@color_superficies)
		selborrar = []
		Sketchup.active_model.active_entities.each do |e|
			if e.is_a?(Sketchup::Edge)
				if face.classify_point(punto_medio(e.start.position,e.end.position)) == Sketchup::Face::PointInside
					selborrar.push(e)
				end
			end
		end
		Sketchup.active_model.active_entities.erase_entities selborrar if selborrar != []
		# conservamos las lineas para interseccion en calcula puntos
		@lineai = [@pt1, @pt2]
		@linead = [@pt3, @pt4]
		# sacamos el extremo frontal
		linea_ult = Sketchup.active_model.active_entities.add_line @pt2, @pt4
		pon_color(linea_ult,@@color_lineas)
		# sacamos los vertices
		@vertice1 = linea_ult.start
		@vertice2 = linea_ult.end
		# guardamos las caras
		caras = face.edges
		caras.each do |e|
			pon_color(e,@@color_lineas)
		end

		# borramos aristas coincidentes
		borra_coplanarias(caras, Sketchup.active_model.active_entities)
		@ptini = @ptfin
		# si se ha borrado la cara frontal del muro
		if linea_ult.deleted? || @vertice2.deleted? || @vertice1.deleted? #|| @arfin
			reset
			# salimos sin inicioundo
			return false
		end
	rescue	
		reset
		return false
	end
	return true
end

def create_muro
	#finalundo
	if @lineai && @linead
		# Si existe la interseccion movemos el extremo
		vec = @pt1-@vertice1.position
		Sketchup.active_model.active_entities.transform_entities(vec, @vertice1) if vec.length > 0 && !@vertice1.deleted?
		vec = @pt3-@vertice2.position
		Sketchup.active_model.active_entities.transform_entities(vec, @vertice2) if vec.length > 0 && !@vertice2.deleted?
	end
	#inicioundo(CambiaIdioma("Wall")) if haz_muro
	haz_muro
	@pulsado_tab = false
end

def onLButtonDown(flags, x, y, view)
	borra_auxiliares
	@@ip1.pick(view,x,y,@@ip)
	if !@primer_punto
		@ptini = @@ip.position
		Sketchup::set_status_text CambiaIdioma("Length"), SB_VCB_LABEL
		@primer_punto = true
		@segundo_punto=false
	else
		@segundo_punto=true
		if @midiendo
			cambia_iowall
		else
			Sketchup.active_model.start_operation CambiaIdioma(@comando_en_curso), false, false, false if @comando_en_curso != 'Parallel wall' #por el doble click
			create_muro
			#Sketchup.active_model.commit_operation  if @comando_en_curso != 'Parallel wall'
			finalundo if @comando_en_curso != 'Parallel wall'
		end	
		@arini = nil
		@long_usuario = false
	end
	crea_auxiliares(@ptini)
	texto_comando
	view.lock_inference
end

def longitud_usuario(valores, view) # view por si un dia funciona el posicionar el cursor
	return nil if valores[0]==''
	# longitud del muro
	if @ptfin && @ptini
		vec = @ptfin - @ptini
		if( vec.length > 0.0 )
			valores.each do |value|
				vec = @ptini - @ptfin if con_coma(value,nil).to_l < 0
				vec.length = value.to_l.abs 
				@ptfin = @ptini.offset(vec)
				calcula_puntos
				ptperp = @ptini.transform(Geom::Transformation.rotation(@ptfin, [0,0,1], Math::PI/2))
				Sketchup.active_model.start_operation CambiaIdioma(@comando_en_curso), false, false, false# if @comando_en_curso != 'Parallel wall'
				create_muro
				#Sketchup.active_model.commit_operation#  if @comando_en_curso != 'Parallel wall'
				finalundo
				@@ip1.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y) 
				@arini = nil
				#@ptfin = ptperp
				@ptini = @ptfin
				#vec = @ptfin - @ptini
				#view.invalidate
			end
		end
	end	
end

def onUserText(text, view)
	valores=text.split(@@separador_listas)
	value1=value2=nil
	if !@primer_punto && !@ultima_dist
		value1=long_valida(valores[0])
	elsif valores.size > 1
		value1=long_valida(valores[1])
	end	
	text=con_coma(valores[0],nil)
	if text[0].chr == '*'
		valores = text.split("*") #muro paralelo
		value = valores[1].to_i
		if value > 0
			muro_multiplica(value)
			return
		end
	elsif text[0].chr == '/'
		valores = text.split("/") #muro paralelo 
		value = valores[1].to_i
		if value >  0
			muro_multiplica(1.0/value)
			return
		end
	elsif text[0].chr == '+' 
		muro_suma(@@muro_width) 
		return	
	elsif text[0].chr == '-'
		muro_suma(-@@muro_width) 
		return	
	end if text != '' && @comando_en_curso == 'Parallel wall'	
	@@muro_width = value1.abs if value1.to_f != 0	
	Sketchup.write_default("Dibac","Wall",@@muro_width.to_f)
	longitud_usuario([text], view) 
	calcula_puntos
	view.invalidate
end

def draw(view)
 	textoevaluacion(view)
	@dist=@perp.length if @perp #cuando es muro paralelo
	if !@primer_punto && !@ultima_dist
		Sketchup::set_status_text @@muro_width.to_l, SB_VCB_VALUE
    else
		Sketchup::set_status_text @dist.to_l.to_s+" "+@@separador_listas+" "+@@muro_width.to_l.to_s, SB_VCB_VALUE if @dist
	end
    # Muestra el punto actual
	@@ip.draw(view) if( @@ip.valid? && @@ip.display? )
	if @tramo
		@tramo=false
		@@ip1.pick(view, view.screen_coords(@ptini).x, view.screen_coords(@ptini).y)
	end	
	@@ip1.draw(view) if(@ptfin != [] && @@ip1.valid? && @@ip1.display? )
	# pone en magenta las lineas a las que engancha
    if !@arini.deleted?
		view.line_width = 4
		view.drawing_color = "magenta"
		view.draw(GL_LINES, @arini.start.position,@arini.end.position)
	end if @arini
    if !@arfin.deleted?
		view.line_width = 4
		view.drawing_color = "magenta"
		view.draw(GL_LINES , @arfin.start.position,@arfin.end.position)
	end if @arfin && !@midiendo
    # previsualiza el muro
    view.drawing_color = "black"
    view.line_width = 1 
    inference_locked = view.inference_locked?
	view.set_color_from_line(@@ip1, @@ip) if @primer_punto
	view.line_width = 4 if inference_locked && !@midiendo
	if @primer_punto
		view.line_stipple='-.-'
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		if !@midiendo
			view.line_stipple=''
			view.draw(GL_LINE_STRIP, @pt2, @pt4) if @pt4!=[]
			view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt2!=[]
			view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt4!=[]
			view.draw(GL_LINE_STRIP, @vertice1.position, @pt1) if @vertice1
			view.draw(GL_LINE_STRIP, @vertice2.position, @pt3) if @vertice2
			view.draw(GL_LINE_STRIP, @pt1, @pt3) if !@vertice1 && @pt3!=[]
		end	
	end
end

def getExtents
	bb = Sketchup.active_model.bounds
	bb.add @pt1 if @pt1 && @pt1!=[]
	bb.add @pt2 if @pt2 && @pt2!=[]
	bb.add @pt3 if @pt3 && @pt3!=[]
	bb.add @pt4 if @pt4 && @pt4!=[]
	return bb
end

def tabulador
	if @@muro_inc then
		@@muro_cara += 0.5
	elsif
		@@muro_cara -= 0.5
	end	
	@@muro_inc = !@@muro_inc if @@muro_cara != 0.5
end

def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) || (key==VK_CONTROL && MAC) then
		borra_auxiliares
		tabulador
		calcula_puntos
		crea_auxiliares(@ptini) if @comando_en_curso=="Wall"
		view.invalidate
		@pulsado_tab = true if @primer_punto
	elsif key == 119 #F8
		lb = @arfin.line 
		if lb
			@@hv = [lb[1][0],lb[1][1]] #coseno y seno del angulo
			borra_auxiliares
			crea_auxiliares(@ptini) if @primer_punto
		end
	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )
        # Si esta activado desactivarlo
        if( view.inference_locked? )
            view.lock_inference
        elsif !@primer_punto
            view.lock_inference @@ip
        elsif
            view.lock_inference @@ip, @@ip1
		end
	end
end	

def onKeyUp(key, rpt, flags, view)
	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)
		view.lock_inference
    end
end

end # de la clase Muro

class Dibac_Muro_Ritkonsult  < Dibac_Muro

def cambia_iowall
	muros=Sketchup.find_support_file "iowalls.txt","plugins/iscarnet_dibac"
	lines = open(muros).readlines if muros
	lines.each do |l|
		valores=l.split(';')
		if @dist <= valores[0].to_f.cm || valores[0].to_f==0
			@@muro_outer=valores[1].to_f.cm.to_f
			@@muro_inner=valores[2].to_f.cm.to_f
			Sketchup.write_default("Dibac","InnerWall",@@muro_inner)
			Sketchup.write_default("Dibac","OuterWall",@@muro_outer)
			@carp = Sketchup.read_default('Dibac', 'Window', Sketchup.find_support_file("dibac_window_opening.skp","plugins/iscarnet_dibac")).split('#')
			@carp =['./dibac_window_opening.skp'] if @carp.size==0
			definicion=saca_menu(nil)
			texto=@carp[0]
			@carp_defaults['a03alfeizar']=valores[3].to_f.cm.to_f if @carp_defaults['a03alfeizar']
			@carp_attributes.each do |key|
				texto=texto+'#'+@carp_defaults[key].to_s
			end	
			Sketchup.write_default('dibac', 'Window', texto)
			@@alturas_planta = valores[4].to_f.cm.to_f 
			Sketchup.write_default('Dibac', 'FloorHeight', @@alturas_planta[0].to_f.to_s+'#'+@@alturas_planta[0]+@@alturas_planta[1].to_f.to_s)
			texto= 'Building length = '+ @dist.to_l.to_s+"\n"
			texto= texto + 'Outer wall = '+@@muro_outer.to_l.to_s+"\n"
			texto= texto + 'Inner wall = '+@@muro_inner.to_l.to_s+"\n"
			texto= texto + 'Window sill = '+@carp_defaults['a03alfeizar'].to_l.to_s+"\n"
			texto= texto + 'Extrude height = '+@@alturas_planta.to_l.to_s+"\n"
			UI.messagebox(texto)
			break
		end	
	end
	activate
end

def deactivate(view)
	@@muro_width=@gruesofijo
	reset
	view.invalidate
end

def onLButtonDoubleClick(flags, x, y, view)
	return if @segundo_punto
	@midiendo = true
	texto_comando
end	

def onRButtonDown(flags, x, y, view)
	reset
end

def onSetCursor
	if @midiendo
		UI.set_cursor(@@medircursor_id)
	else	
		UI.set_cursor(@@murocursor_id)
	end	
end

def texto_comando
	return if !@comando_en_curso
	if !@midiendo
		texto = CambiaIdioma(@comando_en_curso) +"["+ @@muro_width.to_l.to_s+"]." 
	else
		texto = CambiaIdioma("Measuring building length.")
	end	
	
	if !@primer_punto
		texto = texto+CambiaIdioma("Starting point")+" ("+ CambiaIdioma("Dbl_Click for tape measure")+")"
	else	
		texto= texto+CambiaIdioma("End point")
	end	
	if !@midiendo
		texto = texto + " Tab="+CambiaIdioma("Change edge")+"." if WIN
		texto = texto + " Ctrl="+CambiaIdioma("Change edge")+"." if MAC
	end
	Sketchup::set_status_text  texto 
end		

end # de la clase Muro Ritkonsult

class Dibac_Muro_Inner < Dibac_Muro_Ritkonsult
def activate
	@comando_en_curso = "Inner wall"
	@gruesofijo=@@muro_width
	@@muro_width=@@muro_inner
	reset
end
end # de la clase Muro Inner

class Dibac_Muro_Outer < Dibac_Muro_Ritkonsult
def activate
	@comando_en_curso = "Outer wall"
	@gruesofijo=@@muro_width
	@@muro_width=@@muro_outer
	reset
end
end # de la clase Muro Outer

class Dibac_Murop < Dibac_Muro
=begin
 Clase	        		:	Murop
 Desciende de		:	Muro
 Descripción   		:	Dibuja muros paralelos a una linea cualquiera en planta
 Item de Menu  	:	Dibujo->Dibac->Muro paralelo // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Primero se tiene que proporcionar la linea base que aparecera en magenta
								Luego se arrastra el muro hasta la posicion deseada.
								Pulsando [Tab] se cambia la cara de enganche entre izquierda,
								centro y derecha sucesivamente.
								Si se introdue un numero positivo se toma como distancia a la linea base.   
								Si se introduce un numero negativo se toma como espesor del	muro.
								Para terminar una secuencia de muro paralelo se pulsa [Esc].
             		  
 Fecha        			:	14/11/2010
=end

def reset
	@tramo=nil
	@comando_en_curso = "Parallel wall"
	@primer_punto = @pulsado_tab = false
	# puntos temporales para el muro enganchado al cursor
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
	# aristas a las que se engancha al principio y al final
	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end

def deactivate(view)
	view.invalidate
	@@penultima_dist=@ultima_dist if @ultima_dist
end	

def create_muro
	inicioundo(CambiaIdioma("Parallel wall"))
	@ultp1=@lbase.start.position
	@ultp2=@lbase.end.position
	@ultimo_punto=@primer_punto
	@@penultima_dist=@ultima_dist if @ultima_dist
	@ultima_dist=@perp.length if @perp
	haz_muro
	finalundo
	#pillamos la primera cara del muro
	reset
end

def muro_multiplica(value)
	if( @perp.length > 0.0 )
		if !@primer_punto 
			Sketchup.undo
			inicioundo(CambiaIdioma("Parallel wal"))
			longitud=@perp.length
			if value>=1
				paso = longitud 
			else
				paso = longitud*value
				value=1/value
			end
			for i in 1..value
				@perp.length=paso*i
				@primer_punto=@ultimo_punto
				@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2	
				@ptini = @lbase.start.position.offset(@perp)
				@ptfin = @lbase.end.position.offset(@perp)
				calcula_puntos
				haz_muro
			end
			finalundo
			@perp.length = longitud
			reset
		end
	end	
end

def muro_suma(value)
	if( @perp.length > 0.0 )
		if !@primer_punto 
			Sketchup.undo
			inicioundo(CambiaIdioma("Parallel wal"))
			value=@perp.length+value
			@perp.length=value
			@primer_punto=@ultimo_punto
			@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2	
			@ptini = @lbase.start.position.offset(@perp)
			@ptfin = @lbase.end.position.offset(@perp)
			calcula_puntos
			haz_muro
			finalundo
			reset
		end
	end	
end

def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+"."#"["+@@muro_width.to_l.to_s+"]. "
	if !@primer_punto
		texto = texto + CambiaIdioma("Baseline")+"."
		Sketchup::set_status_text CambiaIdioma("Thickness")+":", SB_VCB_LABEL
	else
		texto = texto + CambiaIdioma("Position of wall")+"."
		Sketchup::set_status_text CambiaIdioma("Distance")+" "+@@separador_listas+" "+CambiaIdioma("Thickness") + ":",SB_VCB_LABEL
	end
	if @primer_punto
		texto = texto + " Tab="+CambiaIdioma("Change edge")+"." if WIN
		texto = texto + " Ctrl="+CambiaIdioma("Change edge")+"." if MAC
	end	
	Sketchup::set_status_text texto
end		

def onSetCursor
	UI.set_cursor(@@muropcursor_id)
end

def onMouseMove(flags, x, y, view)
	texto_comando
    return false if !@@ip.pick(view, x, y, @@ip1) 
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @@ip.tooltip
	if !@primer_punto
		Sketchup::set_status_text @@muro_width.to_l, SB_VCB_VALUE
		view.invalidate if @arini = busca_cara(x, y, view)
    else
		@ptfin = @@ip.position
		@ptini = @ptfin.project_to_line [@lbase.start,@lbase.end]
		@perp = @ptfin - @ptini
		Sketchup::set_status_text @perp.length.to_s+" "+@@separador_listas+" "+@@muro_width.to_l.to_s, SB_VCB_VALUE
		@ptini = @lbase.start.position.offset(@perp)
		@ptfin = @lbase.end.position.offset(@perp)
		calcula_puntos
	end
	view.invalidate
end

def onLButtonDown(flags, x, y, view)
	if !@primer_punto
		@@ip1.pick(view,x,y,@@ip)
		@lbase = busca_cara(x, y, view)
		if @lbase	
			#crea_auxiliares(@@ip.position)
			@primer_punto = true
		end	
	else
		create_muro
	end
	texto_comando
	view.lock_inference
end

def onLButtonDoubleClick(flags, x, y, view)
	if @@penultima_dist
		longitud_usuario([@@penultima_dist.to_s],view) if @@penultima_dist>0
	end	
end

def longitud_usuario(valores, view) 
	# distancia a paralela
	valores[0]=@ultima_dist if valores[0] == ''
	return if !valores[0]
	if( @perp.length > 0.0 )
		if !@primer_punto 
			Sketchup.undo
			@primer_punto=@ultimo_punto
			@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2
		end
		@perp.length = valores[0].to_l
		@ptini = @lbase.start.position.offset(@perp)
		@ptfin = @lbase.end.position.offset(@perp)
		calcula_puntos
		create_muro
	end	if @perp
end

end # de la clase Murop

class Dibac_Estiramuro < Dibac_Muro
=begin
 Clase	        		:	Estiramuro
 Desciende de		:	Muro
 Descripción   		:   Estira/acorta un muro existente
 Item de Menu  	:	Dibujo->Dibac->Prolongar muro // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se marca el muro por una de las caras en un punto proximo al extremo que queremos mover
								la linea elegida se marcara en magenta.
								Luego se arrastra el extremo hasta la posicion deseada.
             		  
 Fecha        			:	14/11/2010
=end

def menu
	nolicencia(false)
end	

def reset
	@tramo=nil
	@comando_en_curso = "Extend wall"
	Sketchup.active_model.abort_operation if @primer_punto 
	@primer_punto = false
	@pt1 = @pt2 = @pt3 = @pt4 = @vertice1 = @vertice2 = nil
	@arini = @arfin = nil
end

def create_muro
	haz_muro
	finalundo
end

def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+": "
	if !@primer_punto
		texto = texto+CambiaIdioma("Enter end to extend")+"."
	else
		texto = texto+CambiaIdioma("Enter new position")+"."
	end	
	Sketchup::set_status_text texto
end		

def onSetCursor
	UI.set_cursor(@@estiramurocursor_id)
end

def calcula_puntos
	if @arfin 
		pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line)
		@pt1 = pt0 if pt0
		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]
		pt0 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line)
		@pt3 = pt0 if punto_en_segmento(pt0, @arfin.start.position, @arfin.end.position)	
	else
		@pt1 = @@ip.position.project_to_line [@puntos[0], @puntos[2]]
		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]
	end
end

def onMouseMove(flags, x, y, view)
	texto_comando
    return false if !@@ip.pick(view, x, y, @@ip1) 
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @@ip.tooltip
	if !@primer_punto
		view.invalidate if @arini = busca_cara(x, y, view) #@arini para que se ponga roja
    else
		@arfin = busca_cara(x, y, view)
		calcula_puntos
	end
	view.invalidate
end

def onLButtonDown(flags, x, y, view)
	if !@primer_punto
		pt = @@ip.position
		cara = busca_cara(x, y, view)
		if cara	
			otracara=otra_cara_perp(cara, pt)
			return false if !otracara
			inicioundo(CambiaIdioma("Extend wall"))
			@puntos = borra_muro(x, y, view, false)
			lado = @puntos[0].distance(pt) - @puntos[2].distance(pt)
			if lado	<= 0 
				@pt1 = @puntos[0]
				@pt2 = @puntos[2]
				@pt3 = @puntos[1]
				@pt4 = @puntos[3]
			else
				@pt1 = @puntos[2]
				@pt2 = @puntos[0]
				@pt3 = @puntos[3]
				@pt4 = @puntos[1]
			end	
			@primer_punto = true
			@arini = nil
			calcula_puntos
		end	
		@@ip1.copy! @@ip # si se pone al principio da error en el punto medio
	else
		@primer_punto = false # para que no haga reset
		create_muro
		reset
	end
	texto_comando
	view.lock_inference
	view.invalidate
end

end # de la clase Estiramuro

class Dibac_Componente < Dibac_Base

def ancho_maximo(vf)
	return nil if !@puerta2d ### 31/7/2017
	@maximo_hueco = vf if @puerta2d.get_attribute('dynamic_attributes','dibacmax') 
	@maximo_hueco_y = vf if @puerta2d.get_attribute('dynamic_attributes','dibacmaxy') 
	@pulsado_alt = false
	@mocheta=0 if !vf
	@dibacmax=0 if !vf
	@dibacmaxy=0 if !vf
end

def draw(view)
	texto_comando #por si se ha borrado
	return if !@ancho || !@p_c
	textoevaluacion(view)
    # Muestra el punto actual 
    if( @@ip.valid? && @@ip.display? )
        @@ip.draw(view)
    end
    # previsualiza la carpinteria
	if @primer_punto 
		pto_carpinteria = @primer_punto
	else
		pto_carpinteria = @@ip.position
	end
	set_transform(false) 
	view.drawing_color = "magenta"
	view.drawing_color = "blue" if @pulsado_alt
	view.line_width = 2
	if !puntos_hueco(pto_carpinteria) #aqui se decide donde se coloca la carpinteria
		@mocheta=0 if @maximo_hueco || @maximo_hueco_y
		puntos_2d(nil) if (@maximo_hueco || @maximo_hueco_y) && @cara1 && @cara2
		if !@mobiliario
			view.drawing_color = "black"
			view.line_width = 1
		end
	end
	@ph1 = pto_carpinteria
	ptos = []
	@p_c.each do |pt|
		ptos.push pt.transform(@transform)
	end 
	@p_t.each do |pt|
		ptos.push pt.transform(@transform)
	end if @notrim
	view.draw(GL_LINES, ptos)  if ptos  != []
end

def extremo_mocheta(p1,p2) #busca el vertice coincidente con el punto contrario del muro que sale de una carpinteria
	Sketchup.active_model.active_entities.grep(Sketchup::Edge).each do |e|
		otrovertice=nil
		if e.start.position == p1 
			otrovertice=intermedios(nil,[p1,e.end.position],true,true)[1]
		elsif e.end.position == p1
			otrovertice=intermedios(nil,[p1,e.start.position],true,true)[1]
		end	
		if otrovertice
			Sketchup.active_model.active_entities.grep(Sketchup::ComponentInstance).each do |c|
				ptos=[]
				ptos=muro_carpinteria(c)[0] if tipo_bloque(c) == 'carpinteria'
				#si hay dos carpinterias no alineadas devolvemos p1
				 return p1 if ptos.include?(p1) && ptos.include?(otrovertice) && p1 != otro_extremo_carp(otrovertice, ptos) && otrovertice.on_line?([p1,p2])
			end	
			return otrovertice if otrovertice.on_line?([p1,p2]) 
		end	
	end
	return p1	
end

def graba_valores
	texto=@carp[0]
	@carp_attributes.each {|key| texto=texto+'#'+@carp_defaults[key].to_s}
	@carp= arregla_carp(texto.split('#'))
	texto=texto+'#'+@carp_umbral.to_f.to_s #el ultimo en el registro es el umbral
	Sketchup.write_default('dibac', @carp_registro, texto)
end

def getExtents
	return if !@transform
	bb = Sketchup.active_model.bounds
	@p_c.each {|pt| bb.add pt.transform(@transform)} if @p_c
	@p_t.each {|pt| bb.add pt.transform(@transform)} if @notrim
	return bb
end

def hueco_pantalla(vf) #de momento esta inhabilitado
	return if @comando_en_curso != "Place window"
	@pantalla = vf
	@maximo_hueco = false
	reset
	return if !vf
	if otra_cara_perp(@cara1, @@ip.position) 
		@primer_punto = @@ip.position
		@cara_ventana = @cara1
		@ancho=0
	end if @cara1
end

def texto_comando
	texto = CambiaIdioma(@carp_registro)+': '+File.basename(@carp[0]).sub('.skp','')
	if @carp.size>1
		texto=texto+" ["
		semicolon=false	
		@carp_attributes.each do |a|
			texto=texto+@@separador_listas if semicolon
			semicolon=true
			texto=texto+@carp_defaults[a].to_f.to_l.to_s
		end
		texto = texto +"]."
	end
	#texto = texto +" ["+CambiaIdioma("Force")+" "
	#texto = texto + @distancia_carpinteria.to_l.to_s + "]. "
	texto = texto + CambiaIdioma("Select position")+"."
	if !@dibacfit
		texto=texto+" Ctrl=" if WIN
		texto=texto+" Option=" if MAC
		texto = texto +CambiaIdioma("Force")
	end	
	texto = texto + ', '+CambiaIdioma("Shift")+"="+CambiaIdioma("Max.") if @puede_max || @puede_maxy
	if !@mobiliario
		texto = texto +", Alt=" if WIN
		texto = texto +", Cmd=" if MAC
		texto=texto+CambiaIdioma("Overlap")
	end
	texto = texto +", Tab="+CambiaIdioma("Center/End") if WIN
	texto = texto +", Ctrl="+CambiaIdioma("Center/End") if MAC
	Sketchup::set_status_text texto
	texto=CambiaIdioma("Elevation")
	texto=texto+" "+@@separador_listas+" "+CambiaIdioma("Force") if !@dibacfit 
	textio=texto+ ":"
	Sketchup::set_status_text texto,SB_VCB_LABEL
	texto=@carp_umbral.to_f.to_l.to_s
	texto= texto+@@separador_listas+" "+@distancia_carpinteria.to_l.to_s if !@dibacfit
	Sketchup::set_status_text texto, SB_VCB_VALUE
end	

def menu
	nolicencia(false)
	prompts=[]
	defaults=[]
	list=[]
	if @carp_attributes
		@carp_attributes.each do |key|
			prompts.push(CambiaIdioma(@carp_prompts[key]))
			if @carp_units[key] == 'INTEGER'
				defaults.push(@carp_defaults[key].to_i)
			elsif @carp_units[key] == 'PERCENT'
				defaults.push((@carp_defaults[key].to_f*100.0).to_i.to_s+'%')
			elsif	@carp_units[key] == 'STRING'
				defaults.push(@carp_defaults[key].to_s)
			else
				defaults.push(@carp_defaults[key].to_f.to_l)
			end
			list.push("") #de momento hasta que sepamos poner opciones
		end
	else
		Sketchup.active_model.select_tool nil	
		return
	end	
	input = UI.inputbox prompts, defaults, list, CambiaIdioma(@comando_en_curso)+": "+@carp_name if !@@cuentagotas
	if input 
		i=0
		@carp_attributes.each do |key|
			if @carp_units[key] == 'INTEGER'
				valor=input[i].to_i
			elsif @carp_units[key] == 'PERCENT'
				valor=input[i].split('%')[0].to_i/100.0
			elsif @carp_units[key] == 'STRING'
				valor=input[i].to_s
			else
				valor=a_longitud(input[i]).to_f#.abs #en principio todos positivos
			end
			@carp_defaults[key]=valor
			i += 1
		end	
		graba_valores
	else
		Sketchup.active_model.select_tool nil	
		return
	end if prompts.size>0 && !@@cuentagotas
	@@cuentagotas=nil
	reset
end

def modificar(entity) #recursivo
	entity.definition.entities.each{|e| modificar(e) if e.is_a?(Sketchup::ComponentInstance)}
	scalex=entity.definition.get_attribute('dynamic_attributes','dibacscalex')
	return if !scalex
	tr=entity.transformation
	sx=(tr.to_a[0]**2+tr.to_a[1]**2+tr.to_a[2]**2)**0.5
	sy=(tr.to_a[4]**2+tr.to_a[5]**2+tr.to_a[6]**2)**0.5
	sz=(tr.to_a[8]**2+tr.to_a[9]**2+tr.to_a[10]**2)**0.5
	trans=Geom::Transformation.scaling(-1/sx ,1/sy,1/sz)
	entity.transformation=tr*trans
end

def reset
	@mocheta=0 #para que genere la carpinteria
	puntos_2d(@@cuentagotas)
	#UI.start_timer(0.001,false){Sketchup.active_model.active_view.refresh} #para que no corra demasiado al redibujar y se quite la marca de agua
	#Sketchup.active_model.active_view.refresh #no hace falta
end 

def onLButtonDown(flags, x, y, view)
	colocar_bloque 
	view.invalidate	
end

def onMouseMove(flags, x, y, view)
	#ip.pick(view, x, y)
    return false if( !@@ip.pick(view, x, y) )
	# pone tooltip segun el elemento al que se aproxime
 	view.tooltip = @@ip.tooltip
	if !@primer_punto
		@cara1 = busca_cara(x, y, view)
		@carpinteria = nil
		if !@cara1
			@carpinteria = busca_instancia(x, y, view)
			@carpinteria=nil if @carpinteria && tipo_bloque(@carpinteria) != 'carpinteria'
		end	
		@ph1 = @@ip.position
	else	
		@ancho=0 
		puntos_2d(nil)  # cuando estamos en @pantalla o forzando
		
	end
	view.invalidate
end

def onCancel(flag, view)
	if flag  == 0 && @carp_defaults.size > 0
		hueco_pantalla(false) if !@pulsado_alt
		view.invalidate
		menu
	else #Ctrl-Z
		Sketchup.active_model.select_tool nil
	end	
	#menu if flag==0 #para diferenciarlo de Ctrl-Z
end

def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) ||(key==VK_CONTROL && MAC) then #Tab
		@carpinteria_hueco=0 if !@carpinteria_hueco
		@carpinteria_hueco += 1
		@carpinteria_hueco = 0 if @carpinteria_hueco > 1
		view.invalidate
	elsif key == CONSTRAIN_MODIFIER_KEY && !@primer_punto #&& !@mobiliario #Quitar en 2015
		ancho_maximo(true)
		view.invalidate
	elsif key == COPY_MODIFIER_KEY && !@primer_punto #&& !@mobiliario #Quitar en 2015
		@forzar_carpinteria=true
		view.invalidate
	elsif key == ALT_MODIFIER_KEY
		@pulsado_alt=true
	#	if !@primer_punto
	#		hueco_pantalla(true)
	#		view.invalidate
	#	else
	#		@primer_punto=nil
	#	end	
	end	
	texto_comando
	no_menu=true if key == ALT_MODIFIER_KEY #No se porque pero funciona, no sale el menu
end	

def onKeyUp(key, rpt, flags, view)
	if key == CONSTRAIN_MODIFIER_KEY && !@primer_punto
		ancho_maximo(false)
		view.invalidate
	elsif key == COPY_MODIFIER_KEY && !@primer_punto
		@forzar_carpinteria=false
		view.invalidate
	elsif key == ALT_MODIFIER_KEY 
		@pulsado_alt=false
	#	if !@primer_punto
	#		hueco_pantalla(false)
	#		@@forzar_carpinteria=false
	#		view.invalidate
	#	end	
	end
end

def onUserText(text, view)
	valores=text.split(@@separador_listas)
	if valores[0] !=''
		value=long_valida(valores[0])
		@carp_umbral = value if value
		graba_valores
	end	
	if valores.size > 1
		value=long_valida(valores[1])
 		@distancia_carpinteria = value.abs if value
		Sketchup.write_default('Dibac','Force',@distancia_carpinteria)
	end
	view.invalidate
end

def otro_extremo_carp (p1, ptoscarp)
	return ptoscarp[3] if p1 ==  ptoscarp[0]
	return ptoscarp[2] if p1 ==  ptoscarp[1]
	return ptoscarp[1] if p1 ==  ptoscarp[2]
	return ptoscarp[0] if p1 ==  ptoscarp[3]
end

def tramo_extendido(extremos)
	p1=extremos[0]
	p2=extremos[1]
	extremo1 = otro_extremo1 = p1
	extremo2 = otro_extremo2 = p2
	Sketchup.active_model.active_entities.grep(Sketchup::ComponentInstance).each do |e|
		if tipo_bloque(e) =='carpinteria'
			ptoscarp=muro_carpinteria(e)[0]
			otro_extremo1 = extremo_mocheta(otro_extremo_carp(p1,ptoscarp), p1) if extremo1 == p1 && ptoscarp.include?(p1)
			otro_extremo1 = p1 if !punto_en_segmento(p1,otro_extremo1,p2)
			otro_extremo2 = extremo_mocheta(otro_extremo_carp(p2,ptoscarp), p2) if extremo2 == p2 && ptoscarp.include?(p2)	
			otro_extremo2 = p2 if !punto_en_segmento(p2,otro_extremo2,p1)
			dist = extremo1.distance(extremo2)
			dist12= extremo1.distance(otro_extremo2)
			dist21=extremo2.distance(otro_extremo1)
			extremo1 = otro_extremo1 if dist < dist21
			extremo2 = otro_extremo2 if dist < dist12
		end	
		
	end
	extremos=tramo_extendido([extremo1, extremo2]) if extremo1 != p1 || extremo2 != p2
	return (extremos)	
end	

def puntos_hueco (posicion) #en posicion viene la posicion del cursor
	return false if @mobiliario && !@forzar_carpinteria && !@maximo_hueco && !@maximo_hueco_y
	if !@carpinteria || @mobiliario
		@cara1 = @cara_ventana if @cara_ventana
		return false if !@cara1
		@cara2 = otra_cara_perp(@cara1, posicion)	#aqui viene @ptperp
		return false if !@cara2
		extremos1=edge_extremos(@cara1, posicion)
		extremos2=edge_extremos(@cara2, posicion)
	else #si carpinteria buscamos los extremos a partir de las mochetas
		ptos1 = muro_carpinteria(@carpinteria)[0]
		ptos2=[]
		#Ahora buscamos los extremos de los muros al que van a las mochetas
		# Según la proximidad del cursor le damos la vuelta a los puntos
		if @ph1.distance(ptos1[0]) > @ph1.distance(ptos1[1])
			paso=ptos1[0]
			ptos1[0]=ptos1[1]
			ptos1[1]=paso
			paso=ptos1[2]
			ptos1[2]=ptos1[3]
			ptos1[3]=paso
		end	
		ptos2.push(extremo_mocheta(ptos1[0],ptos1[3])	)	
		ptos2.push(extremo_mocheta(ptos1[1],ptos1[2])	)	
		ptos2.push(extremo_mocheta(ptos1[2],ptos1[1])	)	
		ptos2.push(extremo_mocheta(ptos1[3],ptos1[0])	)	
		#ptos2.each {|p| Sketchup.active_model.active_entities.add_cpoint(p)}
		# Si forzamos o agarramos por el centro utilizamos todo el tramo
		extremos1=[ptos2[0],ptos2[3]]
		extremos2=[ptos2[1],ptos2[2]]
		#posicion=posicion.project_to_line(extremos1)
		if @maximo_hueco  || @forzar_carpinteria || @carpinteria_hueco != 0 || @dibacfit
			posicion=punto_medio(ptos1[0],ptos1[3]) if @carpinteria_hueco != 0
		elsif posicion.distance(ptos1[0]) < posicion.distance(ptos1[3])
			extremos1=[ptos1[0],ptos2[3]]
			#extremos2=[ptos1[1],ptos2[2]]
			posicion=ptos1[0]
		else	
			extremos1=[ptos2[0],ptos1[3]]
			#extremos2=[ptos2[1],ptos1[2]]
			posicion=ptos1[3]
		end
	end
	#proyectamos posicion a @cara1
	posicion=posicion.project_to_line(extremos1)
	
	#puts('extremo') if posicion == extremos1[0] or  posicion == extremos1[1]  
	
	#segmento util de @cara1

	ptos=extremos1

	if !@mobiliario
		ptos = tramo_comun(extremos1, extremos2) 
	else
		ptos = tramo_extendido(extremos1)
		#Sketchup.active_model.active_entities.add_cpoint(ptos[0])
		#Sketchup.active_model.active_entities.add_cpoint(ptos[1])
	end
	
	return false if !ptos #armario puede devolver false
	ptini = ptos[0]
	ptfin = ptos[1]
	@angulo1 = angulo_recta(ptos[0], ptos[1])
	@angulo2 = angulo_recta(ptos[0], ptos[0].project_to_line(extremos2))
	anguloperp = @angulo2 +Math::PI
	anguloperp -=2*Math::PI if anguloperp>=2*Math::PI
	#gruesoant = @grueso_muro
	@grueso_muro =ptos[0].distance( ptos[0].project_to_line(extremos2))

	if @mochetamin>0
		return false if @grueso_muro<@mochetamin
	end if @mochetamin
	if @mochetamax>0
		return false if @grueso_muro>@mochetamax
	end if @mochetamax

	#puntos_2d(true) if @grueso_muro != gruesoant
	# ptref1 y ptref 2 son los extremos del segmento utill
	if @simetria_hueco != 1 
		ptref1 = ptfin 
		ptref2 = ptini
	else
		ptref1 = ptini
		ptref2 = ptfin
	end	

	maximo = ptini.distance(ptfin)

	if @dibacfit != maximo #para armarios
		@dibacfit=maximo 
		@mocheta=0 #para que recalcule puntos
	end if @dibacfit 	
	
	if 	@dibacmax != maximo
		@dibacmax =  maximo
		@mocheta=0 #para que recalcule puntos
	end if @maximo_hueco 
	
	if @maximo_hueco_y
		e2 = contrario = ptosperp = nil
		Sketchup.active_model.active_entities.grep(Sketchup::Edge).each do |e|
			contrario = intermedios(nil,[(ptref1),otro_vertice([e.start.position, e.end.position], ptref1)],false,true)[0]
			contrario= otro_vertice([e.start.position, e.end.position], ptref1) if !contrario
			# puede ser un punto intermedio ...
			if punto_en_segmento(ptref1, e.start.position, e.end.position)
				if angulo_recta(ptref1, e.start.position) == anguloperp	
					contrario = e.start.position
				else
					contrario = e.end.position
				end 
			end if !contrario 		
			if contrario && angulo_recta(ptref1, contrario) == anguloperp
				e2 = otra_cara_perp(e, ptref1)
				#e2 = nil if e2 && otro_vertice([e2.start.position, e2.end.position], ptref1) == ptref2
				break if e2
			end
		end
		# ... o una carpinteria
		carp=nil
		Sketchup.active_model.active_entities.grep(Sketchup::ComponentInstance).each do |e|
			if tipo_bloque(e) == 'carpinteria'
				ptos1 = muro_carpinteria(e)[0]
				if ptos1.include?(ptref1)
					contrario=otro_extremo_carp(ptref1, ptos1)
					if angulo_recta(ptref1, contrario) == anguloperp
						contrario=extremo_mocheta(contrario, ptref1)
					else
						contrario=nil
					end	
				end	
			end
			break if contrario
		end if !e2	
		if contrario
			contrario = tramo_extendido([ptref1, contrario])[1] 
			maximo=ptref1.distance(contrario)
			if 	@dibacmaxy != maximo
				@dibacmaxy =  maximo
				@mocheta=0 #para que recalcule puntos
			end
		end	
	end

	if @forzar_carpinteria || @dibacfit || @maximo_hueco || @maximo_hueco_y
		if posicion.distance(ptini) < posicion.distance(ptfin)	
			@simetria_hueco = 1
			ptref1 = ptini
			ptref2 = ptfin
		else
			@simetria_hueco = -1
			ptref1 = ptfin
			ptref2 = ptini
		end
		# ahora buscamos los elementos en ptref1 que es el mas cercano al cursor.
		# en el extremo hay o una linea de muro ...
		
		if @carpinteria_hueco != 0 || @dibacfit  #|| @maximo_hueco# por el centro
			@ph1 = punto_a_distancia(punto_medio(ptref1, ptref2), posicion, @ancho/2)
		elsif	@maximo_hueco # distancia cero
			@ph1 = punto_a_distancia(ptref1, posicion, 0)
		else # por el extremo
			@ph1 = punto_a_distancia(ptref1, posicion, @distancia_carpinteria)
		end	
	else
		@ph1 = punto_a_distancia(posicion, ptref1, @ancho*@carpinteria_hueco/2)
	end
	if !punto_en_segmento(@ph1, ptini, ptfin)
		return false 		
	end if @mocheta != 0
	return false if !@ph1 
	#no hace falta buscar @cara2
	#@cara2 = otra_cara_perp(@cara1, @ph1)	
	#if !@cara2
	#	@ancho = @ancho_anterior 
	#	return false 
	#end
	@ptperp=@ph1.project_to_line(extremos2) 
	#@ph2 = @ptperp
	vuelta = 0
	#vuelta=1 if @pantalla #no damos la vuelta a la carpinteria
	while vuelta < 2
		if ptref1 == ptini
			ptref1 = ptfin
			ptref2 = ptini
		else	
			ptref1 = ptini
			ptref2 = ptfin
		end  if @ph1 == ptref2
		#sacamos los puntos
		@simetria_hueco = -@simetria_hueco if @ph3 != punto_a_distancia(@ph1, ptref2, @ancho) && @primer_punto #bien porque @ancho es @pt3-@pt1
		@ph3 = punto_a_distancia(@ph1, ptref2, @ancho) #if !@primer_punto #Si @primer_punto viene calculado de puntos carpinteria
		#@ph4 = @ph3.project_to_line(extremos2) 
		@angulo1=0 #por si ancho no es mayor que cero
		@angulo1 = angulo_recta(@ph1, @ph3) if @ancho>0
		@angulo2 = angulo_recta(@ph1, @ptperp)
		set_transform(true) #aqui obtenemos @transform
		puntos_2d(nil) if !@primer_punto
		if punto_en_segmento(@ph3, ptini, ptfin) && (@mobiliario || punto_en_segmento(@ph2, extremos2[0], extremos2[1])) && (@mobiliario || punto_en_segmento(@ph4, extremos2[0], extremos2[1]))
			if @carpinteria
				return true
			else 
				ocp=otra_cara_perp(@cara1, @ph3)
				#Sketchup.active_model.active_entities.add_cpoint(@ph3) if ocp
				#Sketchup.active_model.active_entities.add_cpoint(@ptperp) if ocp
				return true if ocp == @cara2
			end	
		end	
		return  if @primer_punto
		@simetria_hueco = -@simetria_hueco
		if ptref1 == ptini
			ptref1 = ptfin
			ptref2 = ptini
		else	
			ptref1 = ptini
			ptref2 = ptfin
		end  
		vuelta += 1
	end
	#@ancho = @ancho_anterior
	return false
end

def set_transform(enmuro)
	return if !@angulo1 || !@angulo2 
	@ph1=Geom::Point3d.new(0, 0, 0) if !@ph1 
	pi =Math::PI
	if @angulo1 < pi/2  
		if @angulo2 > pi 
			@angulo2=@angulo2-2*pi
		end
	end	
	if @angulo1 >= 3*pi/2  
		if @angulo2 < pi 
			@angulo2=@angulo2+2*pi
		end
	end	
	if !enmuro 
		@transform = Geom::Transformation.translation @ph1-[@carpinteria_hueco*@ancho/2,0,0] 
	else	
		@transform = Geom::Transformation.translation @ph1
	end	
	@transform =(Geom::Transformation.scaling(@ph1,1,-1,1)) * @transform if @angulo2 > @angulo1
	@transform =(Geom::Transformation.rotation @ph1, [0,0,1], @angulo1) * @transform 
	@ph2=@pt2.transform(@transform) if @pt2
	@ph3=@pt3.transform(@transform) if @pt3
	@ph4=@pt4.transform(@transform) if @pt4
end

end # de la clase componente

class Dibac_Mobiliario < Dibac_Componente
=begin
 Clase	        		:	Mobiliario
 Desciende de		:	Base
 Descripción   		:	Dibuja componentes en 2d y 3d
 Item de Menu  	:	Dibujo->Dibac->Mobiliario // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se elige el componente y se coloca
								Pulsando [Tab] se cambia elpunto de enganche entre extremo y centro.
								Los parametro por texto anchos se introducen en la forma param1;param2; ...
								Se puede omitir cualquiera los lados del ";" y se actuara solo sobre el lado introducido.
								Si despues del ; ponemos el signo = el dato correspondiente sera igual al anterior.
								Introduciendo un numero negativo indicamos que queremos forzar la colocacion a una distancia. 
								Cuando esta activa la colocacion forzada, la tecla Tab cambia entre extremo y centro. 
								La posicion forzada se calcula siempre sobre el tramo comun entre la cara interior
								y exterior del muro.
 Fecha        			:	24/08/2013
=end

def initialize
	@mobiliario=true
	@angulo1 = 0.0
	@angulo2 = Math::PI*3/2
	@distancia_carpinteria = Sketchup.read_default('Dibac','Force',0.10.m) if !@distancia_carpinteria 
	@simetria_hueco = -1 # si no se cambian las simetrias iguales al colocarlas (cocina)
	@grueso_muro=@@muro_width if !@grueso_muro
	@mocheta=0
	@carpinteria_hueco=0
	@comando_en_curso = "Choose component"
	@carp_registro='Component'
	if @@cuentagotas
		@carp=@@cuentagotas.definition.get_attribute('dibac','2d') 
		@carp_umbral=@@cuentagotas.get_attribute('dibac','z')
	else
		@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Component', Sketchup.find_support_file("dibac_table.skp","plugins/iscarnet_dibac")).split('#'))
	end
	@carp= ['./dibac_table.skp'] if @carp.size == 0
	archivo = UI.openpanel(DibacStrings.GetString(@comando_en_curso), File.dirname(@carp[0]) ,"Sketchup files|*.skp||") if !@@cuentagotas
	if archivo
		if archivo != @carp[0]
			Sketchup.write_default('Dibac','Component', archivo.gsub('\\','/')) 
			@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Component', Sketchup.find_support_file("dibac_table.skp","plugins/iscarnet_dibac")).split('#'))
			@carp= ['./dibac_table.skp'] if @carp.size == 0
		end	
	end
	if archivo || @@cuentagotas
		saca_menu(nil)
		i=1
		@carp_attributes.each do |key|
			@carp_defaults[key] = @carp[i] if i<@carp.size
			i += 1
		end if @carp.size>2	
		Sketchup::set_status_text "", SB_VCB_LABEL
		Sketchup::set_status_text "", SB_VCB_VALUE
	end
end

def onRButtonDown(flags, x, y, view)
	Sketchup.active_model.select_tool nil 
	return if !@colocado
	Sketchup.active_model.selection.clear
	Sketchup.active_model.selection.add @colocado 
	Sketchup.send_action "selectMoveTool:"
end	

def colocar_bloque
	finalundo
	pto_carpinteria = @@ip.position
	inicioundo(CambiaIdioma(@comando_en_curso))
	#puerta=Sketchup.active_model.active_entities.add_instance @puerta2d, @transform
	# sacamos el bloque por si se ha borrado con undo
	puntos_2d(nil) 
	definicion=saca_bloque_2d
	# Si tenemos el atributo DIBACONE generamos un bloque nuevo con un valor unico (Time)
	 if @dibacone && definicion.instances.count > 0
		bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(definicion.name))
		definicion.attribute_dictionaries.each do |d|
			d.each{|key, value| bloquenuevo.set_attribute(d.name, key, value)}
		end
		bloquenuevo.entities.add_instance(definicion, @@transf_nula).explode
		definicion=bloquenuevo
	end	
	definicion.set_attribute('dynamic_attributes','dibacone',Time.now.to_i) if @dibacone
	@colocado=Sketchup.active_model.active_entities.add_instance definicion, @transform
	#@colocado.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero 
	@colocado.set_attribute('dibac','z',@carp_umbral.to_f)
	#si existe dibaclenx quitamos dibacmax para poder escalarlo
	@colocado.set_attribute('dynamic_attributes','dibacmax',0) if @puede_max && @dibaclenx
	@colocado.set_attribute('dynamic_attributes','dibacmaxy',0) if @puede_maxy && @dibacleny
	 if tipo_bloque(@colocado)=='conjunto'
		conjunto=@colocado.explode.grep(Sketchup::Group)
		conjunto.each{|e| e.explode}
	end
	undotransparente
	#Sketchup.active_model.selection.clear
	#Sketchup.active_model.selection.add puerta
	#Sketchup.send_action "selectMoveTool:"
end

end

class Dibac_Carpinteria < Dibac_Componente
=begin
 Clase	        				:	Carpinteria
 Desciende de	 		:	Base
 Descripción   			:	Dibuja carpinterias en muros
 Item de Menu  		:	Dibujo->Dibac->Puerta/ventana/armario/generica // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         						:	Para dibujar la carpinteria primero se tiene que proporcionar la cara del muro
											Cuando la carpinteria se puede colocar se muestra coloreada en coral.
											Pulsando boton izquierdo fuera de un muro se cambia el sentido.
											Pulsando [Tab] se cambia elpunto de enganche entre extremo y centro.
											Los parametro por texto anchos se introducen en la forma param1;param2; ...
											Se puede omitir cualquiera los lados del ";" y se actuara solo sobre el lado introducido.
											asi, por ejemplo,para introducir solo hoja 2 y dejar hoja1 como estaba: ;hoja2
											para hacer puertas de una sola hoja: ;0
											Si despues del ; ponemos el signo = el dato correspondiente sera igual al anterior.
											Introduciendo un numero negativo indicamos que queremos forzar la colocacion a una distancia. 
											Cuando esta activa la colocacion forzada, la tecla Tab cambia entre extremo y centro. 
											La posicion forzada se calcula siempre sobre el tramo comun entre la cara interior
											y exterior del muro.
 Fecha        					:	24/08/2013
=end

def haz_trim(puerta2d)
	@notrim=true
	#puts((puerta2d.bounds.max.x-puerta2d.bounds.min.x).to_l)
	@p_t.push([puerta2d.bounds.min.x,0,0]) #Se ha puesto la coordenada Z para que salgan bien las mochetas cuando se dibuja en un plano distinto.
	@p_t.push([puerta2d.bounds.min.x,-@mocheta,0])
	@p_t.push([puerta2d.bounds.max.x,0,0])
	@p_t.push([puerta2d.bounds.max.x,-@mocheta,0])
end

def init_carpinteria
	saca_menu(nil)
	i=1
	@carp_attributes.each do |key|
		@carp_defaults[key] = @carp[i]
		i += 1
	end	if @carp.size > 1
	@dibacmax = 0 
	@dibacmaxy = 0
	@grueso_muro=@@muro_width if !@grueso_muro
	@transform = @@transf_nula
	@cara1 = @carpinteria = nil
	@angulo1 = 0.0
	@angulo2 = Math::PI*3/2
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	@simetria_hueco = 1
	@pulsado_alt = false
	@carp_umbral=@carp.pop.to_f if @carp.size>@carp_attributes.size+1
end

def colocar_bloque
	superponer=@pulsado_alt
=begin	
	if @cara1 && superponer
		#@carpinteria_hueco = 0
		if !@primer_punto
			@primer_punto = @ph1
			@cara_ventana = @cara1
			#return
		else
			@ph1 = @primer_punto
			Sketchup::set_status_text CambiaIdioma("Length"), SB_VCB_LABEL
		end
	end
	#@ph1=@@ip.position if !@primer_punto
=end	
	if @primer_punto  
		pto_carpinteria = @primer_punto
	else
		pto_carpinteria = @@ip.position
	end

	if puntos_hueco(pto_carpinteria)
		finalundo #Este haceque aparezcadibac en borrar despues de undo colocar carpinteria
		inicioundo(CambiaIdioma(@comando_en_curso))
		0.step(@p_t.size-1, 2)  {|i|	Sketchup.active_model.active_entities.add_line(@p_t[i].transform(@transform), @p_t[i+1].transform(@transform))}
		#Sketchup.active_model.start_operation @comando_en_curso, false, true, false
		set_transform(true)
		#Sketchup.active_model.start_operation @comando_en_curso, false, true, true
		if @carpinteria && !superponer
			superponer = (@carpinteria.get_attribute('dibac','mocheta').to_f < 0)
			if !superponer
				borra_carpinteria(@carpinteria, nil)
			else
				Sketchup.active_model.active_entities.erase_entities @carpinteria
			end	
			@carpinteria=nil
		end
		if !superponer
			#mat = @cara1.material.color.to_i if @cara1.material
			#pon_color(Sketchup.active_model.active_entities.add_line(@ph1, @ph2),mat)
			#Sketchup.active_model.active_entities.add_line(@ph1, @ph2)
			#pon_color(Sketchup.active_model.active_entities.add_line(@ph3, @ph4),mat)
			#Sketchup.active_model.active_entities.add_line(@ph3, @ph4)
			0.step(@p_t.size-1, 2)  {|i|	Sketchup.active_model.active_entities.add_line(@p_t[i].transform(@transform), @p_t[i+1].transform(@transform))}
			lborrar = Sketchup.active_model.active_entities.add_line @ph1, @ph3
			Sketchup.active_model.active_entities.erase_entities lborrar
			lborrar = Sketchup.active_model.active_entities.add_line @ph2, @ph4
			Sketchup.active_model.active_entities.erase_entities lborrar
		end
		carp = pon_carpinteria(superponer)
		pon_color(carp,@@color_lineas)
		#$dc_observers.get_latest_class.redraw_with_undo(carp)
		@primer_punto = @cara_ventana = false
		#@maximo_hueco = false
		#Hay que poner los dos para que se cierre bien el undo sin sacar propiedades en undolist
		#undotransparente
		#finalundo
		#Sketchup.active_model.commit_operation
	else
		@simetria_hueco = -@simetria_hueco
		@angulo1 = angulo_inverso(@angulo1)
		@angulo2 = @angulo2 +2*Math::PI if @angulo2<0.0
		#puntos_2d(false)
	end
	#reset #creo que no hace falta 
	#puntos_2d
end

def pon_carpinteria (superponer)
	#puerta = Sketchup.active_model.active_entities.add_instance @puerta2d, @transform
	puntos_2d(nil) 
	definicion=saca_bloque_2d
	puerta=Sketchup.active_model.active_entities.add_instance definicion, @transform
	#puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero 
	puerta.set_attribute('dibac','z',@carp_umbral.to_f)
	puerta.set_attribute('dibac','mocheta', -@mocheta) if superponer
	#puerta.set_attribute('dynamic_attributes','dibacwthick', @mocheta) los dynamic no se pueden poner sin redibujar
	trim=nil
	puerta.definition.entities.each do |e| 
		if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			trim= e if e.name == 'DIBAC_TRIM'
		end	
	end
	if !trim
		trim=puerta.definition.entities.add_group
		trim.entities.add_line(@p_t[0],@p_t[1])
		trim.entities.add_line(@p_t[2],@p_t[3])
		trim.name = 'DIBAC_TRIM'	
	end		
	trim.transform!(Geom::Transformation.scaling(1, (@mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1))
	#@@carp_1_attributes.each{|key| puerta.set_attribute('dynamic_attributes',key, @@carp_1_defaults[key])} if !@iguales
	return puerta
end

def hueco_a_distancia(vf)
	@forzar_carpinteria = vf
	@maximo_hueco = false
end

end # de la clase Carpinteria

class Dibac_Puerta < Dibac_Carpinteria

def initialize
	@distancia_carpinteria =Sketchup.read_default('Dibac', 'Force', 0.10.m) if !@distancia_carpinteria
	@carpinteria_hueco = @@puerta_hueco #por extremo o por centro
	@comando_en_curso = "Place door"
	@carp_registro='Door'
	@carp= arregla_carp(Sketchup.read_default('Dibac', 'Door', Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac")).split('#'))
	@carp = ['./dibac_door.skp'] if @carp.size==0 
	init_carpinteria
end

def deactivate(view)
	finalundo #por si se aborta sin colocar
	@@puerta_hueco = @carpinteria_hueco 
	view.invalidate #para que quite el dibujo flotante
end

end # de la clase Puerta

class Dibac_Ventana < Dibac_Carpinteria

def initialize
	@distancia_carpinteria = Sketchup.read_default('Dibac','Force',0.10.m) if !@distancia_carpinteria
	@carpinteria_hueco = @@ventana_hueco #por extremo o por centro
	@comando_en_curso = "Place window"
	@carp_registro='Window'
	@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Window', Sketchup.find_support_file("dibac_window.skp","plugins/iscarnet_dibac")).split('#'))
	@carp =['./dibac_window.skp'] if @carp.size==0
	init_carpinteria
	@carp_umbral=1.2.m if !@carp_umbral
end

def deactivate(view)
	finalundo #por si se aborta sin colocar
	@@ventana_hueco = @carpinteria_hueco 
	view.invalidate
end
end #De la clase Dibac_Ventana

class Dibac_Armario < Dibac_Carpinteria

def initialize
	@distancia_carpinteria = Sketchup.read_default('Dibac','Force',0.10.m) if !@distancia_carpinteria
	@carpinteria_hueco = @@armario_hueco #por extremo o por centro
	@comando_en_curso = "Place wardrobe"
	@carp_registro='Wardrobe'
	@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Wardrobe', Sketchup.find_support_file("dibac_wardrobe.skp","plugins/iscarnet_dibac")).split('#'))
	@carp = ['./dibac_wardrobe.skp'] if @carp.size==0
	init_carpinteria
end

def deactivate(view)
	finalundo #por si se aborta sin colocar
	view.invalidate
end
end #De la clase Dibac_Armario

class Dibac_Elegir < Dibac_Carpinteria

def initialize
	 if @@cuentagotas
		@carp=@@cuentagotas.definition.get_attribute('dibac','2d')
		@carp_umbral=@@cuentagotas.get_attribute('dibac','z')
	else	
		@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Choose', Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac")).split('#'))
	end	
	@carp = ['./dibac_door.skp']  if @carp.size==0
	@comando_en_curso = "Choose joinery"
	@carp_registro='Choose'
	@distancia_carpinteria = Sketchup.read_default('Dibac','Force',0.10.m) if !@distancia_carpinteria
	@carpinteria_hueco = @@elegir_hueco #por extremo o por centro
	archivo = UI.openpanel(CambiaIdioma(@comando_en_curso), File.dirname(@carp[0]),"Sketchup files|*.skp||") if !@@cuentagotas
	if archivo
		if File.basename(archivo) != File.basename(@carp[0])
			Sketchup.write_default('Dibac','Choose', archivo.gsub('\\','/')) 
			@carp =  arregla_carp(Sketchup.read_default('Dibac', 'Choose', Sketchup.find_support_file("dibac_door.skp","plugins/iscarnet_dibac")).split('#'))
			@carp = './dibac_door.skp' if @carp.size==0
		end	
	end  
	init_carpinteria if archivo || @@cuentagotas
end

def deactivate(view)
	finalundo #por si se aborta sin colocar
	view.invalidate
end
end #De la clase Dibac_Armario

class Dibac_CotaContinua < Dibac_Base
=begin
 Clase	        		:	CotaContinua
 Desciende de		:	Dibac
 Descripción   		:	Realiza cotas continuas sobre plantas Dibac
 Item de Menu  	:	Dibujo->Dibac->Acotado continuo // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se indica punto inicial y final de la linea de corte seguido de la posicion de las cotas.
								El acotado solo tiene en cuenta los muros dibujados con Dibac.
								Si se introduce cualquier numero se entendera como vañor minimo por debajo del cual
								no se visualizara la cota.

Fecha        			:	8/01/2011
=end

def initialize
	reset
end

def reset
	if @grupo
		pt = @ptpos.project_to_line [@ptini,@ptfin]
		@grupo.transform!(Geom::Transformation.translation(pt - @ptpos))	
		@grupo.explode
		finalundo
	end	
	@ptini = @ptfin = @ptint = @ptpos = @grupo = false
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end

def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+"("+CambiaIdioma("min.")+" "+@@cota_minima.to_l.to_s+"): "
	if !@ptini
		texto = texto + CambiaIdioma("Enter start point, or minimun value")
	elsif !@grupo
		texto = texto + CambiaIdioma("Enter end point, or minimun value")
	else
		texto = texto + CambiaIdioma("Enter dimension line position")
	end	
	texto = texto +"."
	Sketchup::set_status_text texto
end	

def onMouseMove(flags, x, y, view)
    return false if( !@@ip.pick(view, x, y, @@ip1) )
	texto_comando # por si se ha borrado con otro comando
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @@ip.tooltip
	if !@grupo
		@ptfin = @@ip.position
		@ptfin.z=@ptini.z
		@@ip.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y) 
		@ptint = @ptfin
	else	
		@ptint = @ptpos if @ptpos
		@ptpos = @@ip.position
		@ptpos.z = @ptini.z
		@@ip.pick(view, view.screen_coords(@ptpos).x, view.screen_coords(@ptpos).y) 
        pt = @ptpos.project_to_line [@ptini,@ptfin]
		pt = @ptint.project_to_line [pt,@ptpos]	
		@grupo.transform!(Geom::Transformation.translation(@ptpos-pt))
	end if @ptini
	view.invalidate
end

def onLButtonDown(flags, x, y, view)
	@@ip1.pick(view,x,y,@@ip)
	if !@ptini
		@ptini = @@ip.position
		#puts(Sketchup.active_model.active_entities.parent.bounds.min.z)
		@ptini.z=Sketchup.active_model.active_entities.parent.bounds.min.z if !busca_cara(x, y , view) #si no estamos en un linea del grupo nos ponemos en cota del grupo.
	elsif !@grupo
		puntos = intermedios(nil,[@ptini,@ptfin],true,true)
		#Sketchup.active_model.definitions.load(Sketchup.find_support_file("DIBAC_COTAL.skp","Plugins/iscarnet_dibac")) #para que funcione el undo
		inicioundo(CambiaIdioma("Continuous dimension"))
		@grupo = Sketchup.active_model.active_entities.add_group
		i = 0	
		while i < puntos.size-1 do
			pon_cota_lineal(@grupo,puntos[i],puntos[i+1]) if(puntos[i]-puntos[i+1]).length >= @@cota_minima
			i += 1
		end
	else 
		@grupo.explode
		finalundo
		@grupo = false
		reset
	end
	texto_comando
	view.lock_inference
	view.invalidate
end

def onLButtonDoubleClick(flags, x, y, view)
	onLButtonDown(flags, x, y, view)
end

def draw(view)
	textoevaluacion(view)
 	# Muestra el punto actual
    if( @@ip.valid? && @@ip.display? )
        @@ip.draw(view)
    end
    # previsualiza la linea de cota
	view.drawing_color = "black"
	view.line_width = 1 
	inference_locked = view.inference_locked?
	view.set_color_from_line(@@ip1, @@ip) if @ptini
	if !@grupo 
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		puntos = intermedios(nil,[@ptini,@ptfin],true,true)
		view.draw_points(puntos,6,2,"red") if puntos.size > 0
		return if puntos.size < 2
		Sketchup::set_status_text  CambiaIdioma("Length"), SB_VCB_LABEL
		vec=puntos.first - puntos.last
		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE
		i = 0		
		i=-1 if Sketchup.version_number <= 8000999
		while i < puntos.size-1 do
			vec = puntos[i]-puntos[i+1]
			view.draw_text(view.screen_coords(punto_medio(puntos[i], puntos[i+1])),vec.length.to_s) if vec.length >= @@cota_minima
			i += 1
		end
	end if @ptini
end

def onUserText(text, view)
	# Aqui se introduce el espesor minimo para acotar
	text=con_coma(text,nil)
   begin
        valor = text.to_l
    rescue
        # Error al no tratarse de un numero
        UI.beep
        valor = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !valor
	@@cota_minima = valor
	texto_comando
	view.invalidate
end

def onKeyDown(key, rpt, flags, view)
	Sketchup::set_status_text CambiaIdioma("Minimun dimension"), SB_VCB_LABEL
end

def pon_cota_lineal(model, pt1, pt2)
	@componente = Sketchup.active_model.definitions.load(Sketchup.find_support_file("DIBAC_COTAL.skp","Plugins/iscarnet_dibac"))
	transform = Geom::Transformation.translation(pt1)
	transform =(Geom::Transformation.scaling(pt1,pt1.distance(pt2),1,1)) * transform 
	transform =(Geom::Transformation.rotation(pt1, [0,0,1], angulo_recta(pt1,pt2))) * transform	
	@instance = model.entities.add_instance(@componente,transform)
	@cota=@instance.explode	
	@cota[0].set_attribute "dibaccotas", "pt1", pt1
	@cota[0].set_attribute "dibaccotas", "pt2", pt2
	return @cota
end

end # de la clase Dibac_CotaContinua

class Dibac_TresDimensiones < Dibac_Base
=begin
Clase	        		:	TresDimensiones
Desciende de		:	Dibac
Descripción   		:	Genera un modelo 3D a partir de la planta
Item de Menu  		:	Dibujo->Dibac->Convertir en 3D // Barra de herramientas Dibac
Menú contextual	:	NO
Uso         				:	

Fecha        			:	10/03/2012 
=end

def texto_comando
	if @elementos_2d
		Sketchup::set_status_text CambiaIdioma("Top")+" "+@@separador_listas+" "+CambiaIdioma("Bottom")+":",SB_VCB_LABEL
		Sketchup::set_status_text @hu.to_l.to_s+" "+@@separador_listas+" "+@hd.to_l.to_s, SB_VCB_VALUE
	else
		Sketchup.active_model.select_tool nil
	end	
end		

def menu
	#Sketchup.active_model.selection.add(@grupos)
	prompts = 	[	CambiaIdioma("Height"),
							CambiaIdioma("Keep 2D")
						]
	grupo = CambiaIdioma("YES")
	grupo = CambiaIdioma("NOT") if !@@crear_grupo					

	defaults = 	[	@@alturas_planta[0].to_f.to_l,
							grupo
						]
						
	list = 			[	"",
							CambiaIdioma("YES")+"|"+CambiaIdioma("NOT")
						]
=begin
	input = UI.inputbox prompts, defaults, list, CambiaIdioma("Convert to 2D/3D")
	if input
		h1 = a_longitud(input[0]).abs
		@@alturas_planta = h1 if h1>0
		h1 = input[1].to_s.upcase
		@@crear_grupo = (h1 == CambiaIdioma("YES"))
		Sketchup.write_default('Dibac', 'FloorHeight', @@alturas_planta.to_f)
	else	
		Sketchup.active_model.select_tool nil	
		return false
	end
=end		
	@tiempo=Time.now
	#Sketchup.active_model.start_operation "Convert to 2D/3D", false, false, false
	inicioundo(CambiaIdioma("Convert to 2D/3D")) 
		ejecuta_3d
	#Sketchup.active_model.commit_operation
	finalundo
	#puts("Tiempo total="+(Time.now-@tiempo).to_s)
	#Sketchup.active_model.active_view.refresh
	#Sketchup.active_model.select_tool(nil)	
end

def ponz(ptos, h)
	ptos.each do |pt|		
		pt.z=pt.z+h
	end	
end	

def draw(view) #para que no haga nada al dibujar
	texto_comando
	#puts("Tiempo parcial="+(Time.now-@tiempo).to_s)
end

def activate
	return if nolicencia(true)
	@comando_en_curso='Convert to 2D/3D'
	@tiempo=Time.now
	@hay_undo=false #para controlar si hay elementos que convertir no se esta usando
	Sketchup.active_model.active_view.invalidate
	@grupos=Sketchup.active_model.selection.grep(Sketchup::Group)
	path = Sketchup.active_model.active_path
	if @grupos ==[] && path
		path=path.pop #Esto saca el elemento de path
		@grupos=[path] if path.is_a?(Sketchup::Group)
	end	
	if @grupos == []
		UI.messagebox(CambiaIdioma("You must select at least one group."))
		Sketchup.active_model.select_tool(nil)	
		return false
	end	
	seguir=false
	@elementos_2d=false
	@elementos_3d=false
	@grupos.each do |g|
		if !seguir
			seguir=busca_elementos(g) 
			seguir2=seguir
			seguir2.pop
			seguir=false if seguir2.flatten == []
			 if seguir
				if g.get_attribute('dibac','3d')	
					@elementos_3d=true 
				else
					@elementos_2d=true 
				end	
			end	
		end
	end
	if !seguir
	    UI.messagebox(CambiaIdioma("No items to make 2D/3D."))
		Sketchup.active_model.select_tool(nil)	
		return false	
	end
	return if !@hu && !menu
end

def resume(view)
	view.invalidate
end	
	
def onUserText(text, view)
	# Aqui se introduce la altura
	valores=text.split(@@separador_listas)
	valor1=nil
	if valores[0] != ""
		text=con_coma(valores[0],nil)
		begin
			valor1 = text.to_l.to_f.abs
			valor1 =nil if valor1 == @hu
		rescue
			# Error al no tratarse de un numero
			UI.beep
			valor1 = nil
		end	
    end if valores[0]
	valor2=nil
	if valores[1] != ""
		text=con_coma(valores[1],nil)
	begin
        valor2 = text.to_l.abs
		valor2 =nil if valor2 == @hd 
		rescue
			# Error al no tratarse de un numero
			UI.beep
			valor2 = nil
		end
	end	if valores[1]
	#return if nuevas_alturas == @@alturas_planta
	if valor2 == 0
		@hd = 0 if valor1.to_f != 0 || @hu != 0 
	else
		@hd = valor2
	end	if valor2
	if valor1 == 0 #esto hace que en caso de 0,0 predomine la altura hacia arriba
		@hu = 0 if @hd !=0 
	else
		@hu = valor1
	end	if valor1
	Sketchup.write_default('Dibac', 'FloorHeight', @hu.to_f.to_s+'#'+@hd.to_f.to_s)
	inicioundo(CambiaIdioma("Cambio de altura")) 
	@grupos.each do |g| 
		g.delete_attribute('dibac', '2d') #para que lo haga con los valores nuevos
		tresd=g.get_attribute('dibac', '3d')
		g.set_attribute('dibac','3d',[@hu,  @hd, tresd[2]]) if tresd
	end		
	ejecuta_3d 
	finalundo
	ejecuta_3d
	finalundo
	#Sketchup.active_model.commit_operation
end

def busca_elementos(model)
	carpinterias = []
	mobiliario = []
	muros = []
	escaleras=[]
	conjuntos=[]
	resto=[]
	zcero=nil
	explotar=false
    if model.get_attribute  "dibac","escalera2d"
		escaleras.push model
	elsif model.get_attribute  "dibac","escalera3d"
		escaleras.push model
	elsif model.get_attribute 'dibac','3d'
		hu=model.get_attribute('dibac','3d')[0]
		hd=model.get_attribute('dibac','3d')[1]
		zcero=model.get_attribute('dibac','3d')[2]
		model.entities.each do |entidad|
			if	entidad.is_a?(Sketchup::ComponentInstance	)
				tipo=tipo_bloque_3d(entidad)
				if tipo == 'carpinteria'
					carpinterias.push(entidad)
				elsif	tipo == 'mobiliario'
					mobiliario.push(entidad)
				elsif tipo == 'conjunto'
					conjuntos.push(entidad)
				else 
					resto.push(entidad)	
				end
			elsif  entidad.get_attribute  "dibac","escalera3d"	
				escaleras.push entidad
			elsif entidad.is_a?(Sketchup::Face)	
				muros.push(entidad) if entidad.plane[2].abs < 0.000001 #es una cara vertical
			else
				if entidad.is_a?(Sketchup::Edge)
					resto.push entidad #if entidad.bounds.min.z != zcero || entidad.bounds.max.z != zcero
				else
					#resto.push entidad
				end	
			end
		end
	else
		model.entities.each do |entidad|
			if	entidad.is_a?(Sketchup::ComponentInstance	)
				tipo=tipo_bloque(entidad)
				if tipo == 'carpinteria'
					carpinterias.push(entidad)
				elsif	tipo == 'mobiliario'
					mobiliario.push(entidad)
				elsif tipo == 'conjunto'
					conjuntos.push(entidad)
				else resto.push(entidad)	
					# dos veces la primera para hacer undo al leer archivo nuevo en el paso a 3D
				end 
			elsif entidad.is_a?(Sketchup::Face)
				esmuro = true
				entidad.edges.each do |e|
					esmuro = false if e.faces.size > 2
					if e.faces.size == 2
						esmuro=false if !(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999)
					end
				end
				muros.push(entidad) if esmuro
			elsif  entidad.get_attribute  "dibac","escalera2d"	
				escaleras.push entidad
			else
				if entidad.is_a?(Sketchup::Edge)
					resto.push entidad if entidad.faces.size != 1
				else
					resto.push entidad
				end	
			end
		end
	end
	#if carpinterias+muros+escaleras+mobiliario==[]
		#Sketchup.active_model.select_tool(nil)	
		#return false	
	#else
	return carpinterias, muros, escaleras, mobiliario, conjuntos, resto
	#end
end

def ejecuta_3d
	#Sketchup.active_model.selection.clear
	@hu=@@alturas_planta[0].to_f
	@hd=@@alturas_planta[1].to_f
	#i=0
	inicio=Time.now
	@grupos.each do |g|
		if @@crear_grupo
			grupo=g.copy
			grupo.set_attribute('dibac','3d', g.get_attribute('dibac','3d'))
			altura=g.get_attribute "dibac","escalera2d"
			grupo.set_attribute "dibac","escalera2d",altura if altura
			#Sketchup.active_model.active_entities.erase_entities(g) if !@@crear_grupo
		end	
		#i+=1
		#puts('Grupo '+i.to_s)
		if g.get_attribute('dibac','3d') || g.get_attribute('dibac','escalera3d')
			model_2d(g)
		else
			model_3d(g)
		end	
	end
	#puts ('Tiempo empleado: '+(Time.now-inicio).to_s)
end

def perimetro_convexo(trim)
	caja=trim.bounds
	transf=Geom::Transformation.rotation([0,0,0],[1,0,0],Math::PI/2) if caja.min.y == caja.max.y #lo tiramos al suelo alrededor de eje x
 	transf=Geom::Transformation.rotation([0,0,0],[0,1,0],Math::PI/2) if caja.min.x == caja.max.x #lo tiramos al suelo alrededor de eje y
	transf=@@transf_nula if caja.min.z == caja.max.z #ya esta en el suelo
	return nil if !transf #no es plano
	bordes=[]
	trim.entities.each do |e| #todo son edges
		linea1=[e.start.position.transform(transf),e.end.position.transform(transf)]
		angulo1 = angulo_recta(e.start.position.transform(transf), e.end.position.transform(transf))
		#puts(angulo1*180/Math::PI)
		lado=nil
		primerlado=nil
		mismolado=true
		trim.entities.each do |e2|
			angulo2 = angulo_recta(e2.start.position.transform(transf), e2.start.position.transform(transf).project_to_line(linea1))
			lado=angulo2 if !lado
			if angulo2
				#puts((lado-angulo2)*180/Math::PI)
				mismolado=false if (lado - angulo2).abs > 0.000001
			end
			angulo2 = angulo_recta(e2.end.position.transform(transf), e2.end.position.transform(transf).project_to_line(linea1))
			lado=angulo2 if !lado
			if angulo2
				mismolado=false if (lado - angulo2).abs > 0.000001
			end	
			break if !mismolado
		end
		bordes.push(e)	if mismolado
		#Sketchup.active_model.active_entities.add_line(e.start.position.transform(transf),e.end.position.transform(transf)) if mismolado
	end
	return bordes
end

def carpinteria_3d(carpinteria)
	definicion=nil
	#inicioundo(CambiaIdioma(@comando_en_curso))
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == @carp_name} #el bloque completo no lo tengo que repetir
	if !definicion
		Sketchup.active_model.start_operation('Cargo carpinteria para 3d',true,true,true) #para que sea transparente al undo #CAMBIADO
		definicion=Sketchup.active_model.definitions.load(carpinteria) 
	end
	#inicioundo('puturru') #esto hace que funcione aunque el bloque este cargado. 
	
	bloques=carpinterias_2d3d(definicion)
	bloque3d=bloques[1]
	
	#bloque3d.delete_attribute('dibac','3d') #por si esta en el bloque
	#@@carp_1_attributes.each{|key| bloque2d.set_attribute('dynamic_attributes', key, @@carp_1_defaults[key])}
	#	ahora buscamos en definiciones de nuevo y si esta tiene trim y todo lo demas
	@iguales=false
	Sketchup.active_model.definitions.each do |d|
		#por si no hay instancias pero si una definicion válida
			#UI.messagebox(d.name + ' - ' + bloque2d.name.to_s+' - ' + d.get_attribute('dibac','2d').to_s) if d.name.split('#')[0] == bloque2d.name.split('#')[0]
		if d.name.split('#')[0] == bloque3d.name.split('#')[0] && d.get_attribute('dibac','3d') #&& d.name.split('#').size > 1
			@iguales=true
			@carp_attributes.each do |a|
				@iguales= false if d.get_attribute('dynamic_attributes', a).to_s != @carp_defaults[a].to_s
#				UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', a).to_s+' - '+@carp_defaults[a].to_s)
			end
			#UI.messagebox(d.name+' - '+@iguales.to_s)
			@iguales=false if d.get_attribute('dibac','mocheta').to_f.to_l != @mocheta.to_f.to_l
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+ancho_trim(d).to_f.to_l.to_s+' - '+@mocheta.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l != @dibacmax.to_f.to_l
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmaxy').to_f.to_l != @dibacmaxy.to_f.to_l
			
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l.to_s+' - '+@dibacmax.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacfit').to_f.to_l != @dibacfit.to_f.to_l
			#@iguales=false if d.get_attribute('dynamic_attributes', 'dibaclenx').to_f.to_l != @dibaclenx.to_f.to_l 
			@iguales=false if @dibaclenx && d.get_attribute('dynamic_attributes', 'dibaclenx').to_f.to_l != @dibaclenx.to_f.to_l
			@iguales=false if @dibacleny && d.get_attribute('dynamic_attributes', 'dibacleny').to_f.to_l != @dibacleny.to_f.to_l
			
			@cambiar=aspectox(d) #if @mobiliario
			if @cambiar
				vector=@transform.xaxis.transform(Geom::Transformation.rotation([0,0,0], @transform.zaxis, Math::PI/2))
				vector2=@cambiar.transformation.xaxis.transform(Geom::Transformation.rotation([0,0,0],@cambiar.transformation.zaxis, Math::PI/2))
				if !(vector == @transform.yaxis) #buscamos uno que tenga la simetria
					@iguales=false if vector2 == @cambiar.transformation.yaxis		
				else
					@iguales=false if !(vector2 == @cambiar.transformation.yaxis) 
					#@cambiar=false	
				end
			end if @iguales 
			return [d, bloque3d]  if @iguales
		end	
	end
	return bloque3d, bloque3d
end

def escalera_3d(escalera)
	 escalera.make_unique if escalera.entities.parent.instances.count>1
	altura=escalera.get_attribute "dibac","escalera2d"
	return if !altura
	#escalera.make_unique
	#la escalera dentro de su grupo esta siempre en la cota cero
	temp=[]
	escalera.entities.grep(Sketchup::Face).each {|p| temp.push p if p.get_attribute "dibac","escalon"}

	mas_bajo=altura

	temp.each do |p|
		if !p.deleted?
			peld=p.get_attribute "dibac","escalon"
			extrusiona(p,peld) 
			mas_bajo = peld if peld < mas_bajo
		end
	end
	antes=escalera.entities.size

	escalera.entities.grep(Sketchup::Edge).each do |e| 
		if (e.start.edges.size==4 || e.end.edges.size==4) && e.bounds.min.z==0 && e.bounds.max.z==0
			escalera.entities.erase_entities(e.faces)
		end
	end 
	
	#hay que hacerlo otra vez si no se han borrado ?????
	escalera.entities.grep(Sketchup::Edge).each do |e| 
		if (e.start.edges.size==4 || e.end.edges.size==4) && e.bounds.min.z==0 && e.bounds.max.z==0
			escalera.entities.erase_entities(e.faces)
		end
	end if antes=escalera.entities.size

	escalera.entities.grep(Sketchup::Face).each do |f| 
		if f.bounds.min.z == 0 && f.bounds.max.z > mas_bajo
			escalera.entities.erase_entities(f)
		end
	end
	
	selborrar = []
	escalera.entities.grep(Sketchup::Edge).each {|e| selborrar.push(e) if e.faces.size == 0} 
	escalera.entities.erase_entities selborrar.flatten 

	#UI.messagebox('tercero')
	#borramos las que salgan de cero y tengan solo una cara para los laterales del primer peldaño
	escalera.set_attribute "dibac","escalera3d", altura
	escalera.delete_attribute "dibac","escalera2d"
	#escalera.set_attribute "dibac","escalera2d",false dejamos escalera2d como estaba
	borra_coplanarias(escalera.entities.grep(Sketchup::Edge), escalera.entities)
	#Sketchup.active_model.active_view.refresh
end

def escalera_2d(escalera)
	 escalera.make_unique if escalera.entities.parent.instances.count>1
	masalto=escalera.bounds.max.z-escalera.bounds.min.z
	borrar=[]
	for f in escalera.entities #borramos todas las que no son horizontales primero
		if f.is_a?(Sketchup::Face)
			if f.plane[2].abs != 1
				borrar.push(f)
				for g in f.edges
					horizontal=false
					for h in g.faces
						horizontal=true if h.plane[2].abs == 1
					end	
					borrar.push(g) if !horizontal
				end
			end
		elsif f.is_a?(Sketchup::Edge)
			borrar.push(f) if f.faces.size == 0
		else
			borrar.push(f)
		end 		
	end
	escalera.entities.erase_entities(borrar)
	for f in escalera.entities.grep(Sketchup::Face) #solo deben estar las horizontales
		altura = (f.bounds.min.z)
		escalera.entities.transform_entities((Geom::Transformation.translation [0,0, -altura]), f)
		f.set_attribute "dibac", "escalon",  altura
	end
	escalera.set_attribute "dibac", "escalera2d", masalto
	escalera.delete_attribute "dibac", "escalera3d"
end

def explota_trim (trim, para_explotar)
	definicion=trim
	definicion=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
	definicion.entities.each {|t| explota_trim(t, para_explotar) if (t.is_a?(Sketchup::ComponentInstance) || t.is_a?(Sketchup::Group))}
	para_explotar.push(trim) if (trim.is_a?(Sketchup::ComponentInstance) || trim.is_a?(Sketchup::Group))
end	

def suaviza(entidades)
	entidades.grep(Sketchup::Face).each  do |f|
		f.edges.each do |e|
			if(e.faces.size == 2) 
				e.soft=true if(e.faces[0].normal.dot(e.faces[1].normal) > 0.95) 
				e.smooth=true if(e.faces[0].normal.dot(e.faces[1].normal) > 0.95) 
			end	
		end
	end
end	

def instancias_3d(i, carpinteria)
	d=i.definition
	@mobiliario=!carpinteria
	@carp=d.get_attribute('dibac', '2d')
	@carp=d.get_attribute('dibac', '3d') if !@carp
	@carp_name=d.name #por si se ha borrado el original
	saca_menu(nil)
	@carp_attributes.each{|key| @carp_defaults[key]=d.get_attribute('dynamic_attributes', key)}
	@mocheta=d.get_attribute('dibac','mocheta').to_f if carpinteria
	@dibacmax=d.get_attribute('dynamic_attributes','dibacmax')
	@dibacmaxy=d.get_attribute('dynamic_attributes','dibacmaxy')
	@dibacfit=d.get_attribute('dynamic_attributes','dibacfit')
	@dibaclenx=d.get_attribute('dynamic_attributes','dibaclenx')
	@dibacleny=d.get_attribute('dynamic_attributes','dibacleny')
	@dibacone=d.get_attribute('dynamic_attributes','dibacone')
	@transform=i.transformation #para que sirva la comprobacion de scalex del 2d
	bloque3d=saca_bloque_3d
	if !@iguales
		if carpinteria
			trim=busca_trim(bloque3d)	
			trim.transform!(Geom::Transformation.scaling(1, (@mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) if trim
		end
		diccionario=d.attribute_dictionary('dynamic_attributes')
		@puerta3d=nil
		if diccionario 
			puerta=Sketchup.active_model.active_entities.add_instance(bloque3d, @@transf_nula)
			if puerta
				@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
				puerta.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
				puerta.set_attribute('dibac','mocheta', @mocheta.to_f) if carpinteria
				diccionario=d.attribute_dictionary('dynamic_attributes')
				diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'}
				puerta.set_attribute('dynamic_attributes', 'dibacmax', @dibaclenx) if @dibacmax && @dibaclenx
				puerta.set_attribute('dynamic_attributes', 'dibacmaxy', @dibacleny) if @dibacmaxy && @dibacleny
				puerta.set_attribute('dynamic_attributes', 'dibacone', @dibacone) if @dibacone
				#Sketchup.active_model.start_operation "No pasa nada", false, true, true#(NUEVO)
				$dc_observers.get_latest_class.redraw(puerta,is_recursive_call=false)
				#Sketchup.active_model.start_operation "No pasa nada", false, false, true #CAMBIADO
				@puerta3d=puerta.definition if puerta.definition.name != bloque3d.name
				Sketchup.active_model.active_entities.erase_entities(puerta)
			end	
		end
		if !@puerta3d
			bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque3d.name))
			bloque3d.attribute_dictionaries.each do |d|
				d.each{|key, value| bloquenuevo.set_attribute(d.name, key, value)} if !@@protected.include?(d.name)
			end
			bloquenuevo.entities.add_instance(bloque3d, @@transf_nula).explode
			@puerta3d = bloquenuevo
		end
		@carp_attributes.each{|key| @puerta3d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
		diccionario.each{|key, value| @puerta3d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		borra_nulos(@puerta3d) 
		if carpinteria
			@trim=busca_trim(@puerta3d)	
			haz_trim_3d
		end	
	else
		#bloque3d=bloques[0]
		@puerta3d=bloque3d.definition if bloque3d.is_a?(Sketchup::ComponentInstance)
		@puerta3d=bloque3d if bloque3d.is_a?(Sketchup::ComponentDefinition)
	end	
	@puerta3d.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
	@puerta3d.set_attribute('dibac','mocheta', i.definition.get_attribute('dibac', 'mocheta').to_f) if carpinteria
end					

def instancias_2d(i, carpinteria)
	d=i.definition
	@mobiliario=!carpinteria
	@carp=d.get_attribute('dibac', '3d')
	@carp_name=d.name #por si se ha borrado el original
	saca_menu(nil)
	@carp_attributes.each{|key| @carp_defaults[key]=d.get_attribute('dynamic_attributes', key)}
	@mocheta=d.get_attribute('dibac','mocheta').to_f if carpinteria
	@dibacmax=d.get_attribute('dynamic_attributes','dibacmax')
	@dibacmaxy=d.get_attribute('dynamic_attributes','dibacmaxy')
	@dibacfit=d.get_attribute('dynamic_attributes','dibacfit')
	@dibaclenx=d.get_attribute('dynamic_attributes','dibaclenx')
	@dibacleny=d.get_attribute('dynamic_attributes','dibacleny')
	@dibacone=d.get_attribute('dynamic_attributes','dibacone')
	@transform=i.transformation #para que sirva la comprobacion de scalex del 2d
	bloque2d=saca_bloque_2d
	if !@iguales
		diccionario=d.attribute_dictionary('dynamic_attributes')
		@puerta2d=nil
		if diccionario 
			puerta=Sketchup.active_model.active_entities.add_instance(bloque2d, @@transf_nula)
			if puerta
				@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
				puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
				puerta.set_attribute('dibac','mocheta', @mocheta.to_f) if carpinteria
				diccionario=d.attribute_dictionary('dynamic_attributes')
				diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'}
				puerta.set_attribute('dynamic_attributes', 'dibacmax', @dibaclenx) if @dibacmax && @dibaclenx
				puerta.set_attribute('dynamic_attributes', 'dibacmaxy', @dibacleny) if @dibacmaxy && @dibacleny
				puerta.set_attribute('dynamic_attributes', 'dibacone', @dibacone) if @dibacone
				#Sketchup.active_model.start_operation "No pasa nada", false, true, true  #(NUEVO) 
				$dc_observers.get_latest_class.redraw(puerta, is_recursive_call=false) 
				#Sketchup.active_model.start_operation "No pasa nada", false, false, true  #CAMBIADO
				@puerta2d=puerta.definition if puerta.definition.name != bloque2d.name
				Sketchup.active_model.active_entities.erase_entities(puerta)
			end	
		end
		if !@puerta2d
			bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque2d.name))
			bloque2d.attribute_dictionaries.each do |d|
				d.each{|key, value| bloquenuevo.set_attribute(d.name, key, value)}
			end
			bloquenuevo.entities.add_instance(bloque2d, @@transf_nula).explode
			@puerta2d = bloquenuevo
		end
		if carpinteria
			trim=busca_trim(@puerta2d)	
			if !trim
				trim=@puerta2d.entities.add_group
				trim.entities.add_line([@puerta2d.bounds.min.x,0],[@puerta2d.bounds.min.x,-@mocheta])
				trim.entities.add_line([@puerta2d.bounds.max.x,0],[@puerta2d.bounds.max.x,-@mocheta])
				trim.name = 'DIBAC_TRIM'
			end	
			trim.transform!(Geom::Transformation.scaling(1, (@mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) if trim
		end
		@carp_attributes.each{|key| @puerta2d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
		diccionario.each{|key, value| @puerta2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		borra_nulos(@puerta2d) 
	else
		@puerta2d=bloque2d.definition if bloque2d.is_a?(Sketchup::ComponentInstance)
		@puerta2d=bloque2d if bloque2d.is_a?(Sketchup::ComponentDefinition)
	end	
	@puerta2d.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
	@puerta2d.set_attribute('dibac','mocheta', i.definition.get_attribute('dibac', 'mocheta').to_f) if carpinteria
end

def conectadas(face, conjunto, result) #recursivo devuelve en result las caras conectadas que esten en conjunto
	result.push(face)
	face.edges.each{|e| e.faces.each{|f| result=conectadas(f, conjunto, result) if conjunto.include?(f) && !result.include?(f)}}
	return result
end

def model_3d(model)
	#si model.parent.entities==Sketchup.active_model-active_entities estamos fuera del grupo
	out=model.parent.entities==Sketchup.active_model.active_entities
	alturas=model.get_attribute('dibac', '2d')
	if alturas
		@hu=alturas[0]
		@hd=alturas[1]
		fuera=alturas[3] #para saber si tenemos que aplicar transformacion a las texturas
	end	
	inicio=Time.now
	model.make_unique if model.entities.parent.instances.count>1
	if !Dibac_Extension.paths.include?(model.entities)
		Dibac_Extension.paths= model.entities
		model.entities.add_observer(Dibac_ObservadorEntities.new) #observador de entidades para simetrias
	end	
	path=Sketchup.active_model.active_path	
	trabs=@@transf_nula		
	path.each{|m| trabs=trabs*m.transformation} if path
	trabs=trabs*model.transformation if !path || !path.include?(model)
	escaleras=[] #por si el grupo solo es una escalera
	if model.get_attribute "dibac","escalera2d"
		escaleras.push(model)
	else	
		pp=Sketchup.active_model.entities.add_group#.transform!(model.transformation) #Grupo vacio con la transformacion de model para poder copiar el model
		pp.entities.add_instance(model.entities.parent, @@transf_nula).explode #añadimos el grupo y lo explotamos
		solomuros=model.entities.add_group
		solomuros.entities.add_instance(pp.entities.parent, @@transf_nula).explode 
		Sketchup.active_model.entities.erase_entities(pp) #Bug Splat cuando hay escalera y no hay carpinterias
		elementos=busca_elementos(solomuros)
		carpinterias=elementos[0]
		muros=elementos[1] 
		escaleras=elementos[2]
		mobiliario=elementos[3]
		conjuntos=elementos[4]
		resto=elementos[5]
		solomuros.entities.erase_entities(escaleras, mobiliario, conjuntos, resto) #dejamos solo los muros
		carpinterias.each{|e| borra_carpinteria(e, solomuros.entities)} 
		elementos=busca_elementos(solomuros)
		muros=elementos[1]
		#model.entities.erase_entities(model.entities.grep(Sketchup::Edge)) #borramos todas las lineas de model mas abajo tambien lo hacemos con muros pero ya no hay nada
		#muros=elementos[1] #if elementos #buscamos los muros despues de borrar las carpinterias
		#__________________________RITKONSULT (Suelo)______________________
		if RITKONSULT
			 suelo=solomuros.copy
			 suelo.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
			 borra_coplanarias(suelo.entities.grep(Sketchup::Edge), suelo.entities)
		end
		#_______________________________________________________________	
		muros.each {|face| extrusiona(face,@hu) if !face.deleted?}
		transf=@@transf_nula
		transf=model.transformation if out 
		texturas(solomuros, transf) #pone material
		murosup=[]
		murosdown=[]
		zcero=solomuros.bounds.min.z
		zmax=zcero+@hu
		zmin=zcero-@hd
		solomuros.entities.grep(Sketchup::Face){|f| murosup.push(f) if f.bounds.min.z == zmax} #cara superior cerrada
		murosdown=muros
		murosdown.each{|face| face.pushpull (-@hd) if !face.deleted?}
		elementos=busca_elementos(model)
		carpinterias=elementos[0]
		muros=elementos[1]
		escaleras=elementos[2]
		mobiliario=elementos[3]
		conjuntos=elementos[4]
		definiciones=[]
		carpinterias.each{|c| definiciones.push(c.definition)}
		conjuntos.each do |c| 
			 camino=File.dirname(c.get_attribute('dibac','2d')[0])
			 muebles=c.explode.grep(Sketchup::ComponentInstance)
			 muebles.each do |m|
			 carp=m.get_attribute('dibac','2d')	
				 if !saca_definicion
					 nuevo=(File.join(camino,File.basename(carp[0])))
					 m.set_attribute('dibac','2d',[nuevo])
				 end if carp
				 mobiliario.push(m)
			 end	
		end	
		mobiliario.each{|c| definiciones.push(c.definition)} 
		definiciones.uniq!
		#Sketchup.active_model.close_active while Sketchup.active_model.active_path
		invisibles=[]
		trims=solomuros.entities.add_group #Grupo con los trims
		trims.name='trims'
		carastrim=solomuros.entities.add_group
		carastrim.name='carastrim'
		definiciones.each do |d|
			esta=false #variable para soltar cuando este
			@trim=nil
			instancias=d.instances.to_a
			instancias.each do |i|
				if carpinterias.include?(i) || mobiliario.include?(i)
					 zdif=i.get_attribute('dibac','z').to_f
					 if zdif !=0
						 tpoint=Geom::Point3d.new(0,0,zdif)
						 transf =Geom::Transformation.new(tpoint)*i.transformation 
					 else
						 transf= i.transformation
					 end
					 if carpinterias.include?(i)
						if !esta
							instancias_3d(i, true) #aqui se hace el trim
							trims=solomuros.entities.add_group if trims.deleted?
							carastrim=solomuros.entities.add_group if carastrim.deleted?
							esta=true
						end
						 if @trim.manifold?
							#No necesito interseccion cuando paso por encima
							#@trim_definition.entities.intersect_with false, solomuros.transformation*transf*@trim.transformation , solomuros, solomuros.transformation, false, solomuros 
							cf=[] #caras de fachada
							gr=carastrim.entities.add_group #grupo dentro de carastrim
							gr.entities.add_instance(@trim_definition,@@transf_nula).explode #trim dentro del grupo
							gr.entities.grep(Sketchup::Face).each do |f|
								ymin=gr.bounds.min.y
								ymax=gr.bounds.max.y
								fymin=f.bounds.min.y
								fymax=f.bounds.max.y
								gr.entities .erase_entities(f) if !(fymin==ymin && fymax==ymin) && !(fymin==ymax && fymax==ymax)
								gr.entities.grep(Sketchup::Edge).each{|e| gr.entities.erase_entities(e) if e.faces.size==0}
							end
							carastrim.entities.transform_entities(transf*@trim.transformation, gr) 
							trim=trims.entities.add_instance(@trim_definition,transf*@trim.transformation)
							nuevazmax=solomuros.bounds.max.z
							nuevazmin=solomuros.bounds.min.z
							#el trim esta por encima de los muros actuales
							if nuevazmax>zmax
								 murosup.each {|face| face.pushpull(nuevazmax+10-zmax ,false) if !face.deleted?} 
								 zmax=nuevazmax+10
							end

							if nuevazmin<zmin
								murosdown.each {|face| face.pushpull(nuevazmin-10-zmin ,false) if !face.deleted?} 
								zmin=nuevazmin-10
							end	 
=begin							
							if trim.bounds.min.z == zmin #necesita el intersesct mientras no crezca hacia abajo Si crece hacia abajo no hace falta
								ant=solomuros.entities.grep(Sketchup::Face)
								@trim_definition.entities.intersect_with false, solomuros.transformation*transf*@trim.transformation , solomuros, solomuros.transformation, false, solomuros 
								post=solomuros.entities.grep(Sketchup::Face)-ant
								post.each do |f|
									if f.bounds.min.z==f.bounds.max.z
										if f.bounds.min.z == zmin
											murosdown.push f
										end	
									end	
								end
							end
=end							
							elementostrim=trim.explode
							gr.explode
							#solomuros.entities.erase_entities(carastrim.grep(Sketchup::Face))
							#Esto habra que cambiarlo si vamos a distinguir caras para poner texturas de interior o exterior
							elementostrim.grep(Sketchup::Face).each{|f| f.reverse! if !f.deleted?} #para que salga la cara buena
						end if @trim
						puerta=model.entities.add_instance(@puerta3d, transf)
						puerta.hidden=true
						invisibles << puerta	
						#Sketchup.active_model.active_view.refresh
					elsif mobiliario.include?(i)
						if !esta
							instancias_3d(i, false)
							esta=true
						end	
						puerta=model.entities.add_instance(@puerta3d,transf)
						puerta.hidden=true
						invisibles << puerta
						puerta.set_attribute('dynamic_attributes','dibacmax',0) if @dibacmax && @dibaclenx
						puerta.set_attribute('dynamic_attributes','dibacmaxy',0) if @dibacmaxy && @dibacleny #para poder escalarlos
					end
				end	
			end	
		end

		coplanarias=[]
		mochetas=[]
		if !carastrim.deleted?
			carastrim.entities.grep(Sketchup::Edge).each{|e| coplanarias << e if (e.faces.size == 2) && (e.faces[0].normal.dot(e.faces[1].normal).abs > 0.999999)}
			trims.entities.intersect_with false, solomuros.transformation, trims, solomuros.transformation, false, trims  if coplanarias.size != 0
			coplanarias.each{|c| trims.entities.erase_entities(trims.entities.add_line(c.start.position, c.end.position))}
			carastrim.entities.erase_entities (coplanarias) 
			coplanarias=[]
			trims.entities.grep(Sketchup::Edge).each{|e| coplanarias.push e if (e.faces.size == 2) && (e.faces[0].normal.dot(e.faces[1].normal).abs > 0.999999)}
			trims.entities.erase_entities(coplanarias)
			mochetas=trims.explode.grep(Sketchup::Face) #tiene todas las caras del trim
			carastrim=carastrim.explode
			solomuros.entities.erase_entities(carastrim.grep(Sketchup::Face))
		end	
		#textura en las mochetas
		temp=[]
		mochetas.each {|m| temp << m if m.deleted?}
		mochetas=mochetas-temp	
		while mochetas.size > 0
			moch=conectadas(mochetas[0], mochetas,[])
			mochetas=mochetas-moch
			#buscamos los bordes de la mocheta, solo son dos
			sup=0
			cara=nil
			moch.each do |m|
				m.edges.each do |e|					
					e.faces.each do |f|	
						if !moch.include?(f) && f.normal.z.abs < 0.00001 && f.area>sup
							cara=f
							sup=f.area
						end	
					end
				end
				end
			if cara && cara.material
				moch.each do |m|
					if !m.material
						m.material=cara.material
						#if cara.material.texture
#tw = Sketchup.create_texture_writer
						#	uvh=cara.get_UVHelper  true, false, tw
						#	puntos=[]
						#	linea=m.edges[0]
						#	puntos << linea.start.position
						#	puntos << uvh.get_front_UVQ(linea.start.position)
						#	puntos << linea.end.position
						#	puntos << uvh.get_front_UVQ(linea.end.position)
						#	m.position_material(m.material,puntos, true)
						#end
					end	
				end
			end
		end
		
		
		borrar=[]
		grupo=[]	#entidades del grupo de corte para que no entren en nuevos
		zmenor=zmayor=nil
		if zmax>zcero+@hu || zmin < zcero-@hd
			grupo=solomuros.entities.add_group
			grupo_faces=grupo.entities.add_group
			bmin  = solomuros.bounds.min
			bmax  = solomuros.bounds.max
			if zmax>zcero+@hu 
				zmayor=zcero+@hu-1
				p1=Geom::Point3d.new(bmin.x-1,bmin.y-1,zmayor)
				p2=Geom::Point3d.new(bmin.x-1,bmax.y+1,zmayor)
				p3=Geom::Point3d.new(bmax.x+1,bmax.y+1,zmayor)
				p4=Geom::Point3d.new(bmax.x+1,bmin.y-1,zmayor)
				grupo.entities.add_face p1,p2,p3,p4
			end	
			if zmin<zcero-@hd 
				zmenor=zcero-@hd+1
				p1=Geom::Point3d.new(bmin.x-1,bmin.y-1,zmenor)
				p2=Geom::Point3d.new(bmin.x-1,bmax.y+1,zmenor)
				p3=Geom::Point3d.new(bmax.x+1,bmax.y+1,zmenor)
				p4=Geom::Point3d.new(bmax.x+1,bmin.y-1,zmenor)
				grupo.entities.add_face p1,p2,p3,p4
			end	
			solomuros.entities.intersect_with false, solomuros.transformation, grupo_faces, grupo.transformation, false, grupo
			grupo_faces.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
			grupo_faces.entities.each do |e| 
				if e.is_a?(Sketchup::Face)
					e.reverse! if e.normal.z > 0
				elsif e.is_a?(Sketchup::Edge)
					grupo_faces.entities.erase_entities(e) if e.faces.size == 0
				end	
			end
			sacacaras(grupo_faces)
			edges=grupo.entities.grep(Sketchup::Edge)
			grupo.entities.erase_entities(edges)
			solomuros.entities.grep(Sketchup::Face){|f| f.erase! if f.bounds.min.z==zcero-@hd && f.bounds.max.z==zcero-@hd} if zmin < zcero-@hd
			grupo_faces.explode	
			solomuros.entities.intersect_with false, solomuros.transformation, grupo, grupo.transformation, false, grupo
			grupo.explode
			borrar=[]
			solomuros.entities.grep(Sketchup::Edge).each do |e| 
				z1=e.bounds.min.z
				z2=e.bounds.max.z
				borrar << e if z1>zcero+@hu || (z2 > z1 &&  z1 == zcero+@hu)
				borrar << e if z2<zcero-@hd || (z2 > z1 &&  z2 == zcero-@hd)
			end
		end
		if zmenor
			murosdown=[]
			solomuros.entities.grep(Sketchup::Face).each{|f| murosdown.push(f) if f.bounds.min.z == zmenor &&  f.bounds.max.z==zmenor} #cara inferior
			murosdown.each {|face| face.pushpull(zmenor-zcero-@hd,false) if !face.deleted?} 
		end
		if zmayor
			murosup=[]
			solomuros.entities.grep(Sketchup::Face){|f| murosup.push(f) if f.bounds.min.z == zmayor &&  f.bounds.max.z==zmayor} #cara superior
			murosup.each {|face| face.pushpull(zmayor-zcero-@hu,false) if !face.deleted?} 
		end
		model.entities.erase_entities(carpinterias, mobiliario, borrar)
		muros.each{|m| m.edges.each{|b| model.entities.erase_entities(b) if !b.deleted?} if !m.deleted?}
		#suaviza(solomuros.entities)
		#puts('solomuros='+solomuros.entities.size.to_s)	
		borra_coplanarias_3d(solomuros) 
		#puts(solomuros.entities.size.to_s)	
		#puts('model='+model.entities.size.to_s)	
		borra_coplanarias_3d(model)
		@gruposeccion=solomuros.entities.add_group
		#puts(model.entities.size.to_s)	
		#esto tarda un güevo si hay mucha matriz de transformacion
		solomuros.entities.intersect_with false, model.transformation, @gruposeccion.entities, model.transformation, false, model
		#puts ((Time.now-inicio).to_s)

		#A ver si esto tarda menos
		#saca_gruposeccion(Sketchup.active_model.active_entities, trabs, model, solomuros)

		#Borramos los elementos de seccion que estan en bottom, en cero, o en top
		borrar=[]	
		@gruposeccion.entities.each do |e| 
			 if (e.bounds.min.z == zcero && e.bounds.max.z == zcero) ||
			 (e.bounds.min.z == zcero-@hd && e.bounds.max.z == zcero-@hd) ||
			 (e.bounds.min.z == zcero+@hu && e.bounds.max.z == zcero+@hu)
				borrar.push(e)
			end
		end	
		@gruposeccion.entities.erase_entities(borrar) if borrar != []

		#Sacamos los puntos de la seccion
		#puntos=[]
		#@gruposeccion.entities.grep(Sketchup::Edge).each{|e| puntos << [e.start.position, e.end.position] } 
		#puntos.flatten!
		#puntos.uniq!
		#puntos.each{|p| @gruposeccion.entities.add_line(p,[p.x,p.y, zcero+@hu]) if p.z < zcero+@hu}
		#puntos.each{|p| solomuros.entities.add_cpoint(p) if p.z < zcero+@hu}
		
		
		#Descomponemos la seccion y nos quedamos con los ejes
		#nuevos=[]
		nuevos=@gruposeccion.explode.grep(Sketchup::Edge)
		#grupo=grupo.explode.grep(Sketchup::EdgeUse) if grupo.is_a?(Sketchup::Group) 
		#ejes=[] #para que no ponga tapa en las habitaciones a media altura
		#grupo.each{|e| ejes << e.edge}
		#nuevos=nuevos-ejes
		#ejes.each{|e| solomuros.entities.erase_entities(e) if e.faces.size < 2}
		#quitamos las caras nuevas que no sean verticales 
		caras=solomuros.entities.grep(Sketchup::Face).to_a
		nuevos.each{|e| e.find_faces if !e.deleted?} #porque algunos mechinales no salen
		caras=solomuros.entities.grep(Sketchup::Face).to_a - caras
		caras.each{|f| solomuros.entities.erase_entities f if !(f.normal.z.abs < 0.000001)}
=begin		
		#hacemos las verticales saliendo siempre de la parte mas alta
		#esto no merece la pena ya que tarda mucho y no se gana nada
		tri=trabs.inverse
		pt1=Geom::Point3d.new([0,0,0].transform(trabs))
		pt2=Geom::Point3d.new([0,0,-1].transform(trabs))
		vec=pt2-pt1
		puntos2=[]
		nuevos2=[]
		puntos.each do |v|
			if v.z < zcero+@hu
				pt=v.transform(trabs)
				ptsup=[v.x,v.y, zcero+@hu].transform(trabs)
				rayt=Sketchup.active_model.raytest(ptsup,vec)
				puntos2.push(rayt[0].transform(tri)) if rayt
			end	
		end	
		puntos2.uniq!

		puntos2.each {|v| nuevos2.push(solomuros.entities.add_line(v, [v.x,v.y, zcero+@hu]))}
=end

		#Estudiamos las coplanarias
  		coplanarias=[]
		solomuros.entities.grep(Sketchup::Edge).each{|e| coplanarias << e if (e.faces.size == 2) && (e.faces[0].normal.dot(e.faces[1].normal) > 0.999999)}
		borrar=[]
		coplanarias.each do |e| 
			#borro la que tenga el bounds mas alto (esto no borra en caras horizontales)
			c1=e.faces[0]
			c2=e.faces[1]
			if c1.bounds.min.z > c2.bounds.min.z
				borrar.push(c1) if c2.bounds.max.z > zcero
			elsif c1.bounds.min.z < c2.bounds.min.z
				borrar.push(c2) if c1.bounds.max.z > zcero
			end
			if c1.bounds.max.z < c2.bounds.max.z
				borrar.push(c1) if c2.bounds.min.z < zcero
			elsif	c1.bounds.max.z > c2.bounds.max.z
				borrar.push(c2) if c1.bounds.min.z < zcero
			end
		end	
		solomuros.entities.erase_entities(borrar) if borrar.size>0
		
		#borramos las faces que en bounds.min no tengan 3 faces y 3 edges sin contar coplanarias (solo en caras verticales)
=begin
		borrar=[]
		solomuros.entities.grep(Sketchup::Face).each do |f|
			#zbajo=f.bounds.min.z
			suprimir=false
			f.vertices.each do |v| 
				if v.position.z == zcero
					edges=0
					v.edges.each{|e| edges += 1 if !coplanarias.include?(e)} 
					suprimir=true if  v.faces.size<3 || edges<3
				end
			end if f.bounds.max.z > zcero
			borrar.push(f) if suprimir
		end
		solomuros.entities.erase_entities(borrar)
=end		
		#borramos caras sueltas
		borrar=[]
		solomuros.entities.grep(Sketchup::Face).each do |f|
			suprimir=true
			f.edges.each{|e| suprimir=false if e.faces.size>1 && !coplanarias.include?(e)}
			borrar.push(f) if suprimir
		end
		solomuros.entities.erase_entities(borrar) if borrar.size>0

		#borramos de arriba y de abajo las lineas con una sola cara
		solomuros.entities.grep(Sketchup::Edge).each do |e|
			if e.faces.size == 1
				if e.faces[0].bounds.min.z==e.faces[0].bounds.max.z
					if e.faces[0].bounds.min.z==zcero+@hu || e.faces[0].bounds.min.z==zcero-@hd
						solomuros.entities.erase_entities(e)
					end
				end	
			end if !e.deleted?
		end
		
		#borramos las lineas sueltas
		borrar=[]
		solomuros.entities.grep(Sketchup::Edge).each do |e|
			borrar << e if e.faces.size==0
		end	
		solomuros.entities.erase_entities(borrar)
		solomuros.explode
		model.delete_attribute('dibac','2d')	
		model.set_attribute('dibac','3d',[@hu,@hd,zcero-model.entities.parent.insertion_point.z]) 
		invisibles.each {|i| i.hidden=false if !i.deleted? && i.bounds.min.z <= zcero+@hu}
		#puts ((Time.now-inicio).to_s)
		#Sketchup.active_model.active_view.refresh
	end
	escaleras.each do |escalera| 
		escalera_3d(escalera)
		if model != escalera
			zesc=escalera.get_attribute('dibac','z')
			escalera.transform!(Geom::Transformation.translation [0,0, zesc]) if zesc
		end		
	end	
end	

def verticales(face, x, y, face2)
	result=[]
	face.edges.each do |e|
		result.push(e) if vertical(e) && e.start.position.x == x && e.start.position.y == y && e.faces.to_a.include?(face2)
	end
	return result
end	

def saca_gruposeccion(entities, transf, model, solomuros)
	
	for e in entities
		next if e == model #solomuros esta dentro de model
		entidades=nil
		if e.is_a?(Sketchup::Group)
			entidades = e.entities 
		elsif e.is_a?(Sketchup::ComponentInstance) 
			entidades = e.definition.entities
		end if e.visible? && e.layer.visible?
		if entidades
			saca_gruposeccion(entidades, transf*e.transformation, model, solomuros)
		end
		if entities
			entities.intersect_with false, transf, @gruposeccion.entities, model.transformation, false, solomuros.entities.to_a
		end	
	end
end	

def sacacaras(grupo)	#tapa superior cuando se seccion con plano
	faces = grupo.entities.grep(Sketchup::Face)
	faces = faces.uniq
	caras = []
	while faces.size > 0
		cara = faces[0]
		for face in faces
			cara = face if face.area>cara.area
		end	
		caras.push(cara)
		faces = faces-[cara]
	end
	
	for cara in caras
		borrar = true
		for edge in cara.edges
			borrar = false if edge.faces.size == 1
		end
		if borrar
			cara.erase! 
		end	
	end 	
	grupo.explode if (grupo != @gruposeccion && grupo.entities.count == 0)
end

def solape(trims, trim, model)
	z=trim[0][0][2]
	#Comparamos todol los puntos con las lineas del trim
	trims.each do |i,t|
		t.each do |l|
			#model.entities.add_line(l[0],l[1]) #Comprobacion de los trim
			#l.each do |p|
				p1=l[0]
				p2=l[1]
				punto1=[p1[0], p1[1], z]
				punto2=[p2[0], p2[1], z]
				trim.each do |linea| 
					return true if  p1[2] <= z && punto_en_segmento(punto1, linea[0],linea[1]) && punto_en_segmento(punto2, linea[0],linea[1])
					return true if  p1[2] <= z && punto_en_segmento(punto1, linea[0],linea[1]) && punto1 != linea[0] && punto1 != linea[1]
					return true if  p1[2] <= z && punto_en_segmento(punto2, linea[0],linea[1]) && punto2 != linea[0] && punto2 != linea[1]
				end	
			#end	
		end if t != trim
	end
	#Ahora miramos hacia abajo
	trims.each do |i,t|
		z=t[0][0][2]
		trim.each do |l|
			#l.each do |p|
				p1=l[0]
				p2=l[1]
				punto1=[p1[0], p1[1], z]
				punto2=[p2[0], p2[1], z]
				t.each do |linea|
					return true if  p1[2] >= z && punto_en_segmento(punto1, linea[0],linea[1]) && punto_en_segmento(punto2, linea[0],linea[1])
					return true if  p1[2] >= z && punto_en_segmento(punto1, linea[0],linea[1]) && punto1 != linea[0] && punto1 != linea[1]
					return true if  p1[2] >= z && punto_en_segmento(punto2, linea[0],linea[1]) && punto2 != linea[0] && punto2 != linea[1]
				end	
			#end	
		end if t != trim		
	end			
	return nil
end

def model_2d(model)
	#si model.parent.entities==Sketchup.active_model-active_entities estamos fuera del grupo
	out=model.parent.entities==Sketchup.active_model.active_entities
	bmin  = model.entities.parent.bounds.min
	bmax  = model.entities.parent.bounds.max
	alturas=[model.get_attribute('dibac','3d')].flatten!
	alturas=[3,0,0] if !alturas
	zcero=0
	alturas.push(3.m) if alturas.size == 0
	alturas.push(0) if alturas.size == 1
	alturas.push(0) if alturas.size == 2
	hu=alturas[0].to_f
	hd=alturas[1].to_f
	zcero=alturas[2].to_f
	origen=model.entities.parent.insertion_point#.transform(model.transformation)
	model.make_unique if model.entities.parent.instances.count>1
	if !Dibac_Extension.paths.include?(model.entities)
		Dibac_Extension.paths= model.entities
		model.entities.add_observer(Dibac_ObservadorEntities.new) #observador de entidades para simetrias
	end
	elementos=busca_elementos(model)
	carpinterias=elementos[0]
	muros=elementos[1] 
	escaleras=elementos[2]
	mobiliario=elementos[3]
	conjuntos=elementos[4]
	resto=elementos[5]
	grupo=model.entities.add_group
	grupo_faces=grupo.entities.add_group
	zcero=zcero+model.entities.parent.insertion_point.z
	p1=[bmin.x-1,bmin.y-1,zcero]
	p2=[bmin.x-1,bmax.y+1,zcero]
	p3=[bmax.x+1,bmax.y+1,zcero]
	p4=[bmax.x+1,bmin.y-1,zcero]
	grupo.entities.add_face p1,p2,p3,p4
	grupo.entities.intersect_with false,grupo.transformation, grupo_faces, grupo.transformation, false, muros
 	model.entities.grep(Sketchup::Edge).each do |e| 
		grupo_faces.entities.add_line(e.start.position, e.end.position) if e.start.position.z == e.end.position.z && e.start.position.z == zcero
	end if grupo_faces.entities.size == 0 #Si no hay interseccion cogemos la cara de abajo
	grupo_faces.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
	grupo_faces.entities.each do |e| 
		if e.is_a?(Sketchup::Face)
			e.reverse! if e.normal.z > 0
		elsif e.is_a?(Sketchup::Edge)
			grupo_faces.entities.erase_entities(e) if e.faces.size == 0
		end	
	end
	sacacaras(grupo_faces)
	
	#Textura de la cara vertical
	#aqui buscamos el material para los edges de grupo_faces
	grupo_faces.entities.grep(Sketchup::Edge).each do |e|
		#añadimos una linea ¡¡¡en model!!! para controlar las faces
		linea=model.entities.add_line(e.start.position, e.end.position)
		linea.faces.each do |f|	
			if f.normal.z.abs < 0.00001
				e.material=f.material
				if f.material && f.material.texture
					tw = Sketchup.create_texture_writer
					uvh=f.get_UVHelper  true, false, tw
					puntos=[]
					#damos ocho puntos por si sirve la deformacion
					transf=@transf_nula
					transf=model.transformation if out
					
					(0..1).each do |i|
						puntos << f.outer_loop.vertices[i].position
						puntos << uvh.get_front_UVQ( f.outer_loop.vertices[i].position)
					end	
					if out	
						puntos[1]=puntos[1].transform transf.inverse
						puntos[3]=puntos[3].transform transf.inverse
					end	
					e.set_attribute('dibac','material', puntos)
				end
			end	
		end
	end if !grupo_faces.deleted?
	edges=grupo.entities.grep(Sketchup::Edge)
	grupo.entities.erase_entities(edges) #borramos el plano de seccion
	grupo_faces.explode	if !grupo_faces.deleted?
	model.entities.erase_entities(resto) #Dejamos carpinterias muebles y conjuntos
	grupo.explode
	definiciones=[]
	carpinterias.each{|c| definiciones.push(c.definition)}
	conjuntos.each do |c| 
		camino=File.dirname(c.get_attribute('dibac','3d')[0])
		muebles=c.explode.grep(Sketchup::ComponentInstance)
		muebles.each do |m|
		carp=m.get_attribute('dibac','3d')	
			if !saca_definicion
				nuevo=(File.join(camino,File.basename(carp[0])))
				m.set_attribute('dibac','3d',[nuevo])
			end if carp
			mobiliario.push(m)
		end	
	end		
	mobiliario.each{|c| definiciones.push(c.definition)} 
	definiciones.uniq!
	trims=Hash.new
	carpinterias.each do |c| 
		@trim_definition=busca_trim_3d(c.definition)
		if !@trim_definition
			@puerta3d=c.definition
			instancias_3d(c, true)
		end	
		b=@trim_definition.bounds
		minx=b.min.x
		maxx=b.max.x
		miny=b.min.y
		maxy=b.max.y
		minz=b.min.z
		#puntos inferiores de los trim
		pt1=[minx,miny,minz].transform(c.transformation)
		pt2=[minx,maxy,minz].transform(c.transformation)
		pt3=[maxx,miny,minz].transform(c.transformation)
		pt4=[maxx,maxy,minz].transform(c.transformation)
		#lineas longitudinales inferiores de los trim
		trims[c]=[[pt1,pt3],[pt2,pt4]] #solo las lineas en el muro
		trims[c]=[[pt1,pt3],[pt2,pt4]] #solo las lineas en el muro
		#Añadimos las lineas de mocheta en el suelo sobre las que ya hay
		#model.entities.add_line([pt1[0],pt1[1],zcero],[pt3[0],pt3[1],zcero])
		#model.entities.add_line([pt2[0],pt2[1],zcero],[pt4[0],pt4[1],zcero])
		#moch.push(model.entities.add_line([pt1[0],pt1[1],zcero],[pt2[0],pt2[1],zcero]))
		#moch.push(model.entities.add_line([pt3[0],pt3[1],zcero],[pt4[0],pt4[1],zcero]))
	end	

	definiciones.each do |d|
		esta=false
		instancias=d.instances.to_a
		instancias.each do |i|
			if carpinterias.include?(i) || mobiliario.include?(i)
				zdif=zcero-Geom::Point3d.new(0,0,0).transform!(i.transformation).z
				if zdif !=0
					tpoint=Geom::Point3d.new(0,0,zdif)
					transf =Geom::Transformation.new(tpoint)*i.transformation 
				else
					transf= i.transformation
				end
				if carpinterias.include?(i)
					if !esta
						instancias_2d(i, true)
						esta=true
					end
					puerta=model.entities.add_instance(@puerta2d, transf)
					#puerta.definition.set_attribute('dibac','2d',@puerta2d.get_attribute('dibac','2d'))
					if !solape(trims, trims[i], model)
						ptos=muro_carpinteria(puerta)
						p_t=ptos[1]
						ptos=ptos[0]
						0.step(p_t.size-1, 2) do |i|
							model.entities.add_line(p_t[i].transform(puerta.transformation), p_t[i+1].transform(puerta.transformation))	
						end
						lborrar = model.entities.add_line ptos[0], ptos[3]
						model.entities.erase_entities lborrar
						lborrar = model.entities.add_line ptos[1], ptos[2]
						model.entities.erase_entities lborrar
					else
						puerta.set_attribute('dibac','mocheta',-1)
					end	
				elsif mobiliario.include?(i)
					if !esta
						instancias_2d(i, false)
						esta=true
					end	
					puerta=model.entities.add_instance(@puerta2d, transf)
					puerta.definition.set_attribute('dibac','2d', @puerta2d.get_attribute('dibac','2d'))
					puerta.set_attribute('dynamic_attributes','dibacmax',0) if @dibacmax && @dibaclenx
					puerta.set_attribute('dynamic_attributes','dibacmaxy',0) if @dibacmaxy && @dibacleny
				end
				 if zdif != 0
					puerta.set_attribute('dibac','z', -zdif)
				else
					puerta.delete_attribute('dibac','z')
				end	
			end	
		end	
	end
	model.entities.erase_entities(carpinterias, mobiliario)
	escaleras.each  do |escalera| 
		escalera_2d(escalera)
		if model != escalera 
			zesc=escalera.bounds.min.z
			if zesc != zcero
				escalera.transform!(Geom::Transformation.translation [0,0, zcero-zesc])
				escalera.set_attribute('dibac','z',zesc-zcero)
			end
		else
			#escalera.('dibac','z')  #Aqui daba un error, pero no se para que estaba esta linea, sería para leer la cota z puesta en los atributos pero funciona sin ella
		end
	end	
	model.delete_attribute('dibac','3d')	
	model.set_attribute('dibac','2d',[hu,hd, zcero,out]) 
end	

end # de la clase TresDimensiones

class Dibac_Escalera < Dibac_Base

def initialize
 	@comando_en_curso = "Stair"
end

def menu
	nolicencia(false)
	prompts = [	CambiaIdioma("Width"),
						CambiaIdioma("Height"),
						CambiaIdioma("Going"),
						CambiaIdioma("Rise"),
						CambiaIdioma("Slope")
					 ] 

	defaults=Sketchup.read_default('Dibac', 'Stair', 'nada').split('#')
	if defaults != ['nada']
		@@escalera_width=defaults[0].to_f
		@@escalera_height=defaults[1].to_f
		@@escalera_huella=defaults[2].to_f
		@@escalera_huellamin=defaults[3].to_f
		@@escalera_tabica=defaults[4].to_f
		@@escalera_tabicamax=defaults[5].to_f
		@@escalera_slope =defaults[6].to_f
	end
	huella =a_longitud(@@escalera_huella).to_s
	huella = '>'+(@@escalera_huellamin.to_l.to_s) if @@escalera_huellamin > 0
	tabica =(@@escalera_tabica.to_l).to_s
	tabica = '<'+(@@escalera_tabicamax.to_l).to_s if @@escalera_tabicamax > 0	
		
	defaults = [	@@escalera_width.to_l.to_s,
						@@escalera_height.to_l.to_s,
						huella,
						tabica,
						@@escalera_slope.to_l.to_s
					 ]
	
	list = 		[	"",
						"",
						"",
						"",
						""
					 ]				 
	input = UI.inputbox prompts, defaults, list, CambiaIdioma(@comando_en_curso)
	if input
		h1 =a_longitud(input[0]).abs #ancho
		@@escalera_width = h1 if h1>0
		texto=@@escalera_width.to_s
		h1 = a_longitud(input[1]).abs #alto
		@@escalera_height = h1
		texto=texto+'#'+@@escalera_height.to_s
		h1 = con_coma(input[2],nil) #huella
		if h1[0].chr == ">"		
			@@escalera_huellamin = h1.split(">")[1].to_l.to_f.abs 
		else
			h1=a_longitud(h1).abs
			if h1  > 0
				@@escalera_huella = h1
				@@escalera_huellamin = 0 
			end	
		end	
		texto=texto+'#'+ @@escalera_huella.to_s+'#'+ @@escalera_huellamin.to_s
		h1 = con_coma(input[3],nil) #tabica 
		if h1[0].chr == "<"		
			@@escalera_tabicamax = h1.split("<")[1].to_l.to_f.abs 
		else
			h1=a_longitud(h1).abs
			if h1  > 0
				@@escalera_tabica = h1
				@@escalera_tabicamax = 0 
			end	
		end	
		texto=texto+'#'+ @@escalera_tabica.to_s+'#'+ @@escalera_tabicamax.to_s
		h1 =a_longitud(input[4]) .abs#comodidad
		@@escalera_slope = h1
		texto=texto+'#'+@@escalera_slope.to_s
		Sketchup.write_default('dibac', 'Stair', texto)
	else	
		Sketchup.active_model.select_tool nil	
		return
	end	
	@huella=@@escalera_huellamin
	@huella=@@escalera_huella if @@escalera_huellamin==0
	huella_tabica
	reset				 
end

def reset
	borra_auxiliares
	@puntos = @total_peld = 0
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
    @pts_d = [] #puntos cara derecha
	@pts_i = [] #Puntos cara izquierda
	@pts_cursor = [] #Puntos cursor
	@cara_tramo =[] #cara en que se construyo el tamo
	@arfin = nil
	@cl1=nil
	@recorrido=false
	@cancelar=false #Para distinguir entre Ctrl-Z y Esc.
    Sketchup::set_status_text "", SB_VCB_LABEL
    Sketchup::set_status_text "", SB_VCB_VALUE
    texto_comando
end

def activate
	Sketchup.active_model.active_view.invalidate
    menu
end

def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso) 
	if !@recorrido
		texto= texto+"["+ @@escalera_width.to_l.to_s+'].'
	else
		texto= texto+"["+ CambiaIdioma("Path")+'].'
	end
	if @puntos == 0
		texto = texto+CambiaIdioma("Starting point")+"("+ CambiaIdioma("Dbl_Click for Path")+")"
	else	
		texto= texto+CambiaIdioma("End point")
		texto = texto + ", " + CambiaIdioma("or specify width preceded by") + " '-'" if !@recorrido
	end	
	texto = texto+"."
	if @puntos>0
		texto = texto + " Tab=" if WIN
		texto = texto + " Ctrl=" if MAC	
		texto=texto + CambiaIdioma("Change edge")+"." 	
		texto=texto+" Ctrl=" if WIN
		texto=texto+" Option=" if MAC
		texto = texto +CambiaIdioma("Force")+"."
	end if !@recorrido
	Sketchup::set_status_text  texto 
end		

def deactivate(view)
	view.invalidate
	reset
end

def onSetCursor
	UI.set_cursor(@@escaleracursor_id)
end

def auxiliares(punto)
	borra_auxiliares
	inicioundo('Tramo de escalera')
	crea_auxiliares(punto)
	finalundo
end

def crea_auxiliares(pt)
	#return #no hay auxiliares
	return if pt==[]
	@cl1 = Sketchup.active_model.active_entities.add_cpoint pt
	return
	@cl1 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl2 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl1.direction = [@@hv[0], @@hv[1]]
	@cl2.direction = [-@@hv[1], @@hv[0]]
	@cl1.stipple = @cl2.stipple = "."
	@cl1.start = @cl1.end = @cl2.start = @cl2.end = nil
end

def borra_auxiliares
	if !@cl1.deleted?
		Sketchup.undo
	end if @cl1
end	

def calcula_puntos
	if(@puntos == 0) then 
 		@ptini = @@ip.position
    else
		if @puntos > 1 
			vertice1=@ptini.project_to_line [@pts_i[@puntos-1],@pts_i[@puntos-2]]
			vertice2=@ptini.project_to_line [@pts_d[@puntos-1],@pts_d[@puntos-2]]
			vec =(vertice1 - vertice2)
			@ptini = vertice1.offset(vec, -@@escalera_cara*vec.length)
		end	
 		if @@escalera_cara > 0 then
			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]
			return if vec.length == 0
			@pt1 = @ptini.offset(vec, @@escalera_cara * @@escalera_width)	 
			@pt2 = @ptfin.offset(vec, @@escalera_cara * @@escalera_width)
		else
			@pt1 = @ptini	 
			@pt2 = @ptfin	   
		end
		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]
		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE
		if vec.length > 0
			@pt3 = @pt1.offset(vec, @@escalera_width)	 
			@pt4 = @pt2.offset(vec, @@escalera_width)	   
		end	
		if(@puntos > 1) 
			if !((@pt3- @pt4).parallel?(@pts_d[@puntos-2]-@pts_d[@puntos-1]))
				vec =(@pts_d[@puntos-2]-@pts_d[@puntos-1])
				vec =(@pts_i[@puntos-2]-@pts_i[@puntos-1]) if vec.length < 0.000001
				@pt3 = Geom.intersect_line_line([@pt3, @pt4], [@pts_d[@puntos-2], vec])
				@pt1 = Geom.intersect_line_line([@pt1, @pt2], [@pts_i[@puntos-2], vec])
			end if ((@pt3- @pt4).length >0) && ((@pts_d[@puntos-2]-@pts_d[@puntos-1]).length >0)
		end
	end
end

def onMouseMove(flags, x, y, view)
    return false if(!@@ip.pick(view, x, y, @@ip1))
	texto_comando
    # pone tooltip segun el elemento
    view.tooltip = @@ip.tooltip
	@ptfin=@@ip.position
	@ptfin.z=@ptini.z if @ptini!=[]
    calcula_puntos
	view.invalidate
	@arfin = busca_cara(x, y, view) #para F8 
end

def tramo_escalera
	@pt_final_i=@pt_rest_i
	@pt_final_d=@pt_rest_d
	@pts_cursor[@puntos] = @ptini
	@ptini = @ptfin
	@pts_i[@puntos] = @pt2
	@pts_d[@puntos-1] = @pt3
	@pts_d[@puntos] = @pt4
	@pts_i[@puntos-1] = @pt1
	@cara_tramo[@puntos] = @@escalera_cara
end

def escalones(linea) # Devuelve los escalones de usuario. 
	lineas_ini = []
	puntos =[]
	Sketchup.active_model.active_entities.grep(Sketchup::Edge).each do |e|
		pt=interseccion_real(linea[0], linea[1], e.start.position, e.end.position)
		if pt
			puntos.push pt
			lineas_ini.push e
		end	
	end		
	i = -1
	ultimadistancia=-1
	lineas_ordenadas=[] 
	while i < puntos.size-1 do
		j = 0
		k = 0
		distancia = 1000000.0
		while j < puntos.size
			if puntos[j] 
				if(linea[0]-puntos[j]).length < distancia
					distancia =(linea[0]-puntos[j]).length
					linea_mas_cerca = lineas_ini[j]
					k = j
				end	
			end 
			j += 1
		end
		lineas_ordenadas.push(linea_mas_cerca) if distancia > ultimadistancia
		ultimadistancia=distancia
		puntos[k] = nil
		i += 1
	end	
	caras=[]
	lineas_ordenadas.each do |e|		
		if e.faces.size == 2 ||(e.faces.size ==1 && caras.size==0 && @huellas_recorrido.size==0)
			normales=0
			e.faces.each do |f|
				normales=normales+f.normal.z.abs
			end
			if normales>0.999999+e.faces.size-1
				e.faces.each do |f|
					caras.push f if f != @ultima_huella
				end
				@ultima_huella=caras[caras.size-1]
			end	
		end 
	end	
	return caras
end

def onLButtonDown(flags, x, y, view)
	@@ip1.pick(view,x,y,@@ip)
	if @puntos == 0 then
		@pts_i[@puntos] = @@ip.position
		@pts_cursor[@puntos] = @@ip.position
	else
		@ptfin=@ptescalon if !@pulsado_control  && !@recorrido
		calcula_puntos
		tramo_escalera
	end
	@puntos +=1
	auxiliares(@ptini)
	texto_comando
end

def onRButtonDown(flags, x, y, view)
	ejecuta_escalera
end	

def onLButtonDoubleClick(flags, x, y, view)
	if @puntos==1 
		@recorrido=true
	else	
		ejecuta_escalera
	end	
	texto_comando
	view.invalidate
end	

def ejecuta_escalera
	borra_auxiliares
	inicioundo(@comando_en_curso)
	if @recorrido
		escalera_recorrido 
	else
		escalera_generada
	end	
	finalundo
	Sketchup.active_model.select_tool nil
end

def escalera_recorrido
	escalera2=Sketchup.active_model.active_entities.add_group
	huellas=@huellas_final
	peld=0
	huellas.each do |face|
		peld+=1
		face.set_attribute "dibac","escalon",peld*@tabica
		face.reverse! if face.normal.z<0
	end
	escalera2=Sketchup.active_model.active_entities.add_group(huellas)
	#@tabica=@@escalera_height/peld if @@escalera_height>0
	escalera2.set_attribute "dibac","escalera2d",peld*@tabica
	#escalera_3d(escalera2,3.20.m)
end

def escalera_generada
	escalera = Sketchup.active_model.active_entities.add_group
	escalera2=Sketchup.active_model.active_entities.add_group
	punto=nil
	peld=0
	#Completamos el ultimo escalon
	@pts_i[@puntos-1]=@pt_final_i
	@pts_d[@puntos-1]=@pt_final_d
	for i in 1 ... @puntos
		temp=[@pts_i[i-1], @pts_i[i], @pts_d[i], @pts_d[i-1]]
		ptos=[temp[0]]
		for j in 1 ... temp.size
			ptos.push(temp[j]) if ptos[ptos.size-1]!=temp[j] #para que no haya repetidos
		end
		face=escalera.entities.add_face ptos
		#borra_coplanarias(face.edges)
		if punto
			edges=face.edges
			edges.each do |e|
				escalera.entities.erase_entities e if e.faces.size==2 && !punto_en_segmento(punto, e.start.position, e.end.position)
			end			
		end		
		ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)
		if ht
			1.step(ht.size-1,2) do |j|
				escalera.entities.add_line ht[j-1],ht[j]
			end	
			punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
		end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]	
		escalera.entities.add_line @pts_i[i-1],@pts_i[i]
		escalera.entities.add_line @pts_d[i-1],@pts_d[i]
		huellas=escalera.entities.grep(Sketchup::Face)
		for j in 0..huellas.size-2
			e=huellas[j]
			vert=[]
			e.vertices.each do |v|
				vert.push v.position
			end	
			peld+=1
			face=escalera2.entities.add_face vert
			face.set_attribute "dibac","escalon",peld*@tabica
			face.reverse! if face.normal.z<0
		end
		e=huellas[huellas.size-1]
		vert=[]
		e.vertices.each do |v|
			vert.push v.position
		end
		Sketchup.active_model.active_entities.erase_entities escalera
		escalera=Sketchup.active_model.active_entities.add_group
		escalera.entities.add_face vert
	end	
	peld+=1
	face=escalera2.entities.add_face vert
	face.set_attribute "dibac","escalon",peld*@tabica
	face.reverse! if face.normal.z<0
	Sketchup.active_model.active_entities.erase_entities escalera
	escalera2.set_attribute "dibac","escalera2d",peld*@tabica
	#escalera_3d(escalera2,3.20.m)
end

def onCancel(flag, view)
	@cancelar=true
	if @puntos==1
		view.lock_inference if( view.inference_locked? )
		reset
	end	
end

def longitud_usuario(value, view) # view por si un dia funciona el posicionar el cursor
	# longitud del muro
	
end

def onUserText(text, view)
	valores = text.split("<")
	if valores[1]
		angulo = valores[1].to_f.degrees
		@@hv = [Math.cos(angulo), Math.sin(angulo)]
		auxiliares(@ptini) if @puntos > 0
		return
	end
	valores=valores[0].split(@@separador_listas)
	if valores[1] #longitud de peldaño
		valores2 = valores[1].split('>')
		if valores2[1]
			l=long_valida(valores2[1]).abs
			@@escalera_huellamin = l if l
		else
			l=long_valida(valores2[0]).abs
			if l
				@@escalera_huella=l
				@@escalera_huellamin=0
			end
		end
		huella_tabica
	end
	valores = valores[0].split'*'
	if valores[1]
		l=valores[1].to_i
		value=@primer_peld+l*@huella+0.000001
	else
		value=long_valida(valores[0])
	end	
	if value
		if value < 0 then
			# ancho de la escalera
			@@escalera_width = value.abs.to_l
			texto_comando
			calcula_puntos
		elsif @puntos > 0 && value>0
			vec = @ptfin - @ptini
			if( vec.length > 0.0 )
				vec.length = value
				@ptfin = @ptini.offset(vec)
				calcula_puntos
				tramo_escalera
				@puntos +=1
			end	
		end
	end
	auxiliares(@ptini)
	texto_comando
	view.invalidate
 end
 
def huella_tabica # @huella para el primer tramo
	return if !@huella
	@huella=0 if @huella.to_s=='NaN'
	if @huella==0
		@huella=@@escalera_huellamin
		@huella=@@escalera_huella if @huella==0
	end
	if @@escalera_tabicamax > 0
		@tabica=1000000.0 
		@tabica=(@@escalera_slope-@huella)/2  if @@escalera_slope>0   #calculamos la tabica en funcion de la huella
		@tabica=@@escalera_tabicamax if @tabica>@@escalera_tabicamax
	else
		@tabica=@@escalera_tabica
	end	
	if @@escalera_height>0
		n=((@@escalera_height/@tabica)).to_i
		@tabica=@@escalera_height/n
		tabicamax=@@escalera_tabicamax
		tabicamax=@@escalera_tabica if tabicamax==0
		while @tabica>tabicamax
			n+=1
			@tabica=@@escalera_height/n
		end	
		@total_peld=n
	end	
	if @@escalera_huellamin>0 #No hace falta comprobar @@escalera_huella porque ya viene hecho
		@huella=@@escalera_slope-(2*@tabica)
		while @huella<@@escalera_huellamin
			n+=1
			@tabica=@@escalera_height/n
			@huella=@@escalera_slope-(2*@tabica)
		end if @@escalera_height > 0	
	end  if @@escalera_slope > 0
end

def huellas_tramo(lineai, linead, punto)
	huellas=[]
	extremos =tramo_comun(lineai, linead) #maximo tramo para peldaños
	return nil if extremos == []
	tramo =(extremos[0]-extremos[1])
	return nil if tramo.length < 0.000001
	peld1 = [extremos[0],extremos[0].project_to_line(linead)] #primer peldaño del tramo
	dist = punto.distance_to_line peld1 if punto
	
	if dist<@huella
		if punto_en_segmento(punto.project_to_line(peld1), peld1[0], peld1[1])
			extremos[0]=punto_a_distancia(extremos[0],extremos[1],@huella-dist)
		end		
	end if dist
	return if !extremos[1] || !extremos[0]
	if(extremos[1]-lineai[0]).length <(extremos[0]-lineai[0]).length 
		@primer_peld=0.0 #Para sumar al numero de peldaños en longitud de usuario
		return
	end	
	tramo =(extremos[0]-extremos[1])
	if @huella==0
		@huella=tramo.length/((tramo.length/@@escalera_huellamin).to_i)
		huella_tabica
	end	
	n=(tramo.length/@huella).to_i
	for i in 0 .. n
		pt1=punto_a_distancia(extremos[0],extremos[1],i*@huella) 
		huellas.push(pt1)
		huellas.push(pt1.project_to_line(linead))
	end
	return huellas
end

def texto_descansillo(view, punto, peld_tramo, peld)
	#view.draw_text(view.screen_coords(punto), peld_tramo.to_s+'/'+peld.to_s+'/'+(peld*@tabica).to_l.to_s) if peld_tramo > 0	
	return if !punto
	view.draw_text(view.screen_coords(punto), peld.to_s+'/'+(peld*@tabica).to_l.to_s) if peld_tramo > 0	
end	

def draw(view)
	return if !@huella
	textoevaluacion(view)
	x=view.corner(0)[0]
	y=view.corner(0)[1]
	#view.draw2d GL_LINE_LOOP, [[x+1,y+20],[x+111,y+20],[x+111,y+110],[x+1,y+110]]
	if !@recorrido
		view.draw_text([x+2,y+24],CambiaIdioma(@comando_en_curso))
		huella_tabica
		view.draw_text([x+2,y+38],CambiaIdioma("Going")+':'+@huella.to_l.to_s)
		view.draw_text([x+2,y+50],CambiaIdioma("Rise")+':'+@tabica.to_l.to_s)
		view.draw_text([x+2,y+62],CambiaIdioma("Slope")+':'+(2*@tabica+@huella).to_l.to_s)
	end	
	# si no hay auxiliares tira para atras
	if @cl1.deleted? && @cancelar
		@cancelar=false if @puntos>1
		@puntos -=1
		@@escalera_cara = @cara_tramo[@puntos]
		@ptini = @pts_cursor[@puntos]
		auxiliares(@ptini)
		calcula_puntos
	elsif @cancelar
		ejecuta_escalera
		return
	end if @cl1
	reset if @cancelar
	# Muestra el punto actual
    @@ip.draw(view) if( @@ip.valid? && @@ip.display? )
	@@ip1.pick(view, view.screen_coords(@ptini).x, view.screen_coords(@ptini).y) if @puntos > 0
	@@ip1.draw(view) if(@puntos>0 && @@ip1.valid? && @@ip1.display? )	
    # previsualiza la escalera
    view.drawing_color = "black"
    inference_locked = view.inference_locked?
	peld=0
	if @recorrido && @puntos>0 #recorrido de usuario
		if @@escalera_height>0
			if @huellas_recorrido
				@tabica=@@escalera_height/@huellas_recorrido.size if @huellas_recorrido.size>0
			end	
		end
		@ultima_huella=nil
		@huellas_recorrido=[]
		if @puntos>1
			view.draw(GL_LINE_STRIP, @pts_cursor[0..@puntos-1])
			view.draw(GL_LINE_STRIP, @pts_cursor[@puntos-1],@ptini)
		end
		if @puntos > 1
			for i in 1...@puntos
				h=escalones([@pts_cursor[i-1],@pts_cursor[i]])
				@huellas_recorrido=@huellas_recorrido+h
				peld_tramo=h.size
				peld +=peld_tramo
				pt_texto=@pts_cursor[i]
				texto_descansillo(view,pt_texto, peld_tramo,peld)
			end 
			h=escalones([@pts_cursor[@puntos-1],@ptini])
			@huellas_recorrido=@huellas_recorrido+h
			peld_tramo=h.size
			peld +=peld_tramo
			pt_texto=@ptini
			texto_descansillo(view,pt_texto, peld_tramo,peld)
		end 
		@huellas_final=@huellas_recorrido
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		h=escalones([@ptini,@ptfin])
		@huellas_recorrido=@huellas_recorrido+h
		peld_tramo=h.size
		peld+=peld_tramo
		pt_texto=@ptfin
		texto_descansillo(view,pt_texto, peld_tramo,peld)
		return
	end
	# escalera generada
	@huella=@@escalera_huella
	@huella=0.0 if @@escalera_huellamin > 0
	punto = nil
	peld_tramo=0
    if @puntos > 1 then
		if @puntos >2
			view.draw(GL_LINE_STRIP, @pts_i[0..@puntos-2])
			view.draw(GL_LINE_STRIP, @pts_d[0..@puntos-2])
			for i in 1..@puntos-2 
				ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)
				if ht
					peld_tramo=ht.size/2
					peld=peld+peld_tramo
					view.draw(GL_LINES, ht)
					punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
					texto_descansillo(view,punto, peld_tramo,peld)
				end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]
			end	
		end
		if @ptini != @ptfin	
			view.draw(GL_LINE_STRIP, @pts_i[@puntos-2], @pt1)
			view.draw(GL_LINE_STRIP, @pts_d[@puntos-2], @pt3)
			ht=huellas_tramo([@pts_i[@puntos-2], @pt1],[@pts_d[@puntos-2], @pt3], punto)
			if ht
				peld_tramo=ht.size/2
				peld=peld+peld_tramo
				punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
				texto_descansillo(view,punto, peld_tramo,peld)
				view.draw(GL_LINES, ht)
			end	
		end
	end	
	# Ultimo tramo
 	view.set_color_from_line(@@ip1, @@ip) if @puntos>0
	ht = huellas_tramo([@pt1, @pt2],[@pt3, @pt4], punto) if (@pt1 != @pt2 && @pt3 != @pt4)
	if ht.size > 0
		pt = @ptini.project_to_line [ht[0],ht[1]]
		@primer_peld=(@ptini-pt).length
		peld_tramo=ht.size/2
		peld=peld+peld_tramo
		pt_texto=punto_medio(ht[ht.size-2],ht[ht.size-1])
	end if ht
	texto_descansillo(view,pt_texto, peld_tramo,peld)
	view.draw(GL_LINES,ht) if ht
	view.line_width = 3 if inference_locked
	if @puntos>0
		view.set_color_from_line(@@ip1, @@ip) 
		view.line_stipple='-.-'
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		view.line_stipple=''
	end	
	view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt1 !=[]  && @pt2 !=[]
    view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt3 !=[]  && @pt3 !=[]
    view.line_width = 1 if inference_locked
	return if !ht
	pt = @ptfin.project_to_line [ht[ht.size-2],ht[ht.size-1]]
	vec=@ptfin-pt
	dist_peld=vec.length
	return if vec.length == 0
	vec.length=0.000001
	@ptescalon=pt.offset(vec) #punto en escalon
	vec=(@ptfin-@ptini)
	value=@huella+0.000001
	return if vec.length == 0
	vec.length = value-dist_peld
	# ultimo peldaño completo
	@pt_rest_i = @pt2.offset(vec)
	@pt_rest_d = @pt4.offset(vec)
	if peld<@total_peld+1
		# Resto de escalera si se ha indicado altura
		resto=@total_peld-peld+1
	else
		resto=1
	end
	value=resto*@huella+0.000001
	return if vec.length == 0
	vec.length = value-dist_peld
	pt_rest_1 = @pt2.offset(vec)
	pt_rest_2 = @pt4.offset(vec)
	ht = huellas_tramo([@pt2, pt_rest_1],[@pt4, pt_rest_2], pt_texto)
	view.drawing_color = "magenta"
	view.draw(GL_LINES,ht)
	view.draw(GL_LINE_STRIP, @pt2, pt_rest_1)
	view.draw(GL_LINE_STRIP, @pt4, pt_rest_2)
end

def getExtents
	bb = Sketchup.active_model.bounds
	bb.add @pt1 if @pt1 && @pt1!=[]
	bb.add @pt2 if @pt2 && @pt2!=[]
	bb.add @pt3 if @pt3 && @pt3!=[]
	bb.add @pt4 if @pt4 && @pt4!=[]
	return bb
end

def tabulador
	return if @recorrido
	if @@escalera_inc then
		@@escalera_cara += 0.5
	elsif
		@@escalera_cara -= 0.5
	end	
	@@escalera_inc = !@@escalera_inc if @@escalera_cara != 0.5
end

def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) ||(key==VK_CONTROL && MAC) then
		tabulador
		calcula_puntos
		auxiliares(@ptini)
		view.invalidate
	elsif key == 119 #F8
		lb = @arfin.line 
		if lb
			@@hv = [lb[1][0],lb[1][1]] #coseno y seno del angulo
			auxiliares(@ptini) if @puntos > 0
		end
	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )
        # Si esta activado desactivarlo
        if( view.inference_locked? )
            view.lock_inference
        elsif !@primer_punto
            view.lock_inference @@ip
        elsif
            view.lock_inference @@ip, @@ip1
		end
	elsif(key == COPY_MODIFIER_KEY)
		@pulsado_control = true
	end	
end

def onKeyUp(key, rpt, flags, view)
	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)
		view.lock_inference
	elsif(key == COPY_MODIFIER_KEY)
		@pulsado_control=false
    end
end

end # de la clase Escalera

class Dibac_Preferencias < Dibac_Base

def texto_comando
	Sketchup::set_status_text(CambiaIdioma("Select language"))
end

def menu
	path=@@current_path+ '/resources'
	lenguajes = []
	Dir.foreach(path) {|f| lenguajes.push(f.to_s) if f.to_s != '.' && f.to_s !='..'}
	
	prompts=[]
	prompts = 	[	CambiaIdioma("Language")+":"
						]
						
	defaults = 	[	CambiaIdioma(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2]))
					]
	lista=""
	lenguajes.each do |l|
		lista=lista+CambiaIdioma(l)+"|"
	end	
	list=[lista]
	input = UI.inputbox prompts, defaults, list,CambiaIdioma("Dibac for Sketchup")+": "+CambiaIdioma("Options")
	if input
		lista=lista.split("|")
		i=0
		i += 1 while lista[i] != input[0]
		Sketchup.write_default("Dibac","Language",lenguajes[i])
		DibacStrings.ParseLangFile
		cambia_idioma_comandos
	end
	Sketchup.active_model.select_tool nil	
end

def cambia_idioma_comandos
	@@murocmd.tooltip = CambiaIdioma("Wall")  
	@@murocmd.status_bar_text = CambiaIdioma("Draw walls from point to point.")
	#Muro paralelo
	@@muropcmd.tooltip = CambiaIdioma("Parallel wall")
	@@muropcmd.status_bar_text = CambiaIdioma("Draw walls parallel to a edge.")
	#Estirar muros
	@@Estiramurocmd.tooltip = CambiaIdioma("Extend wall")
	@@Estiramurocmd.status_bar_text = CambiaIdioma("Extend / shorten walls.")
	#Puertas
	@@puertacmd.tooltip = CambiaIdioma("Door")
	@@puertacmd.status_bar_text = CambiaIdioma("Place doors in walls.")
	#Ventanas
	@@ventanacmd.tooltip = CambiaIdioma("Window")
	@@ventanacmd.status_bar_text = CambiaIdioma("Place windows in walls.")
	#Armarios
	@@armariocmd.tooltip = CambiaIdioma("Wardrobe")
	@@armariocmd.status_bar_text = CambiaIdioma("Place wardrobes in walls.")
	#Escaleras
	@@escaleracmd.tooltip = CambiaIdioma("Stair")
	@@escaleracmd.status_bar_text = CambiaIdioma("Draw stairs from point to point or by path.")
	#Acotado continuo
	@@cotacontinuacmd.tooltip = CambiaIdioma("Continuous dimension")
	@@cotacontinuacmd.status_bar_text = CambiaIdioma("Continuous interior dimensions between two points.")
	# 3D
	@@tresdcmd.tooltip = CambiaIdioma("Convert to 2D/3D")	
	@@tresdcmd.status_bar_text = CambiaIdioma("Transform model between 2D and 3D.")
	#Preferencias
	@@preferenciascmd.tooltip = CambiaIdioma("Options")
	@@preferenciascmd.status_bar_text = CambiaIdioma("Select language")
end
	
end # de la clase preferencias

class Dibac_Cuentagotas < Dibac_Base

def puntos_2d(bloque2d) 
	@puerta2d=bloque2d.definition if bloque2d.is_a?(Sketchup::ComponentInstance)
	@puerta2d=bloque2d if bloque2d.is_a?(Sketchup::ComponentDefinition)
	ptos= saca_puntos([],[],@puerta2d, nil, false, true) 	#el primer bloque no tiene transformacion
	@p_c = ptos[0]   
	@p_t = ptos[1] #puntos para trim
	@p_t=@p_c  if @mobiliario
	@pt1=@pt2=@pt3=@pt4 = nil
	xmax = xmin = @p_t[0][0]
	@p_t.each do |p|
#		puts(p[0].to_f.to_l.to_s+','+p[1].to_f.to_l.to_s+','+p[2].to_f.to_l.to_s)
		xmin=p[0] if xmin > p[0]
		xmax=p[0] if xmax < p[0]
		if p[1].abs <= 0.000001
			@pt1=p if !@pt1
			@pt1=p if p[0] < @pt1[0] 
			@pt3=p if !@pt3
			@pt3=p if p[0] > @pt3[0]
		end
		if p[1]+@mocheta < 0.000001
			@pt2=p if !@pt2
			@pt2=p if p[0] < @pt2[0]
			@pt4=p if !@pt4
			@pt4=p if p[0] > @pt2[0]
		end if !@mobiliario
	end
	@pt1=[xmin,0,0] if !@pt1
	@pt2=[xmin,-@mocheta,0] if !@pt2
	@pt3=[xmax,0,0] if !@pt3
	@pt4=[xmax,-@mocheta,0] if !@pt4
	@ancho=(@pt3[0]-@pt1[0])
#	puts('____PUNTOS_____')
#	puts(@pt1[0].to_f.to_l.to_s+','+@pt1[1].to_f.to_l.to_s+','+@pt1[2].to_f.to_l.to_s)
#	puts(@pt2[0].to_f.to_l.to_s+','+@pt2[1].to_f.to_l.to_s+','+@pt2[2].to_f.to_l.to_s)
#	puts(@pt3[0].to_f.to_l.to_s+','+@pt3[1].to_f.to_l.to_s+','+@pt3[2].to_f.to_l.to_s)
#	puts(@pt4[0].to_f.to_l.to_s+','+@pt4[1].to_f.to_l.to_s+','+@pt4[2].to_f.to_l.to_s)
#	puts(@ancho)
	#Sketchup.undo #Quita la definicion de la puerta para que no se llene
end

def draw(view)
	view.line_width = 3
	view.drawing_color = "magenta"
	if @pm1
		view.draw(GL_LINES, @pm1, @pm3, @pm2, @pm4)
	elsif @carpinteria
		@carp=@carpinteria.definition.get_attribute('dibac','2d')
		@mocheta=@carpinteria.definition.get_attribute('dibac','mocheta').to_f
		@notrim=true
		puntos_2d(@carpinteria)
		ptos=[]
		@p_c.each do |pt|
			ptos.push pt.transform(@carpinteria.transformation)
		end 
		@p_t.each do |pt|
			ptos.push pt.transform(@carpinteria.transformation)
		end if @notrim
		view.draw(GL_LINES, ptos)  if ptos  != []
	end
end

def onLButtonDown(flags, x, y, view)
	if @pm1
		@@cuentagotas=@pm1.distance @pm2
		Sketchup.active_model.select_tool Dibac_Muro.new
	elsif @carpinteria
		@@cuentagotas=@carpinteria
		if @mobiliario
			Sketchup.active_model.select_tool Dibac_Mobiliario.new
		else
			Sketchup.active_model.select_tool Dibac_Elegir.new
		end	
	end
end

def onMouseMove(flags, x, y, view)
    return false if( !@@ip.pick(view, x, y) )
	@pm1=@carpinteria = @mobiliario=nil
	# pone tooltip segun el elemento al que se aproxime
    texto_comando #por si se ha borrado
	view.tooltip = @@ip.tooltip
	cara1 = busca_cara(x, y, view)
	cara2 = otra_cara_perp(cara1,@@ip.position)
	if cara1 && cara2
		ptos = tramo_comun(edge_extremos(cara1,(view.inputpoint x,y).position), edge_extremos(cara2,(view.inputpoint x,y).position))
		@pm1 = ptos[0]
		@pm2 = @pm1.project_to_line(cara2.line)
		@pm3 = ptos[1]
		@pm4 = @pm3.project_to_line(cara2.line)
	end
	if !@pm1
		@carpinteria = busca_instancia(x, y, view) 
		@mobiliario = true if @carpinteria && tipo_bloque(@carpinteria) == 'mobiliario'
	end
	view.refresh
end

def onSetCursor
	UI.set_cursor(@@cuentagotascursor_id)
end

def texto_comando
	texto=CambiaIdioma("Select a wall, joinery or component.")
	Sketchup::set_status_text texto
end
end

class SeccionSolida < Dibac_Inicio

def SeccionSolida::activar(cambio)
	if cambio
		@@solidsection=!@@solidsection
		Sketchup.write_default("Dibac","SolidSection",@@solidsection)
	end
	return(@@solidsection)
end

def SeccionSolida::cambio_seccion(entity)
	for e in Sketchup.active_model.active_entities.grep(Sketchup::SectionPlane)
		seccion=SeccionSolida.buscaseccion(e)
		seccion.hidden=true if seccion
	end	
	UI.start_timer(0.001,false) {
		seccion= SeccionSolida.buscaseccion(entity)
		seccion.hidden=false if seccion
	}	if entity
end

def SeccionSolida::cambio(entity)
	seccion =SeccionSolida.buscaseccion(entity)
	if seccion
		material = seccion.material 
		Sketchup.active_model.start_operation 'nada', false, true, true
		seccion.erase! if seccion
		Sketchup.active_model.commit_operation
		if DibacLicencia.licencia(false)[2] != "" 
			seccion =SeccionSolida.face(nil, entity, false)
			seccion.hidden=!entity.active?
			seccion.material = material
		end
	end
end

def SeccionSolida::borrar(entity)
	seccion = @@secciones[entity]
	Sketchup.active_model.start_operation 'nada', true, false, true
	seccion.erase! if seccion && !seccion.deleted?
	Sketchup.active_model.commit_operation
end	

def SeccionSolida::primera_carpinteria(entities)
	carpinteria=nil
	for e in entities
		if e.is_a?(Sketchup::Group)
			carpinteria = primera_carpinteria(e.entities)
		 elsif e.is_a?(Sketchup::ComponentInstance)	
			return e if SeccionSolida.es_carpinteria(e)
		end if !carpinteria
	end
	return carpinteria
end
	
def SeccionSolida::es_carpinteria(carp)
	# comprobamos que esta dentro de un ComponentInstance y que es una carpinteria
	return false if !carp.definition.name.upcase.index('3D') 
	if carp.definition.name[0,12].upcase == "DIBAC_PUERTA" || carp.definition.name[0,13] .upcase== "DIBAC_VENTANA" || carp.definition.name[0,13].upcase == "DIBAC_ARMARIO"
		return true
	else
		return false
	end
end

def SeccionSolida::fija_gruposeccion(comando, section, dibac)
	seccion = SeccionSolida.buscaseccion(section)
	if seccion && !comando
		Sketchup.active_model.start_operation 'Solid Section', false, false, false
		seccion.erase!
		@@secciones.delete(section)
		Sketchup.active_model.commit_operation
		return nil
	end
	seccion=SeccionSolida.face(comando, section, dibac)
	
if dibac #comprobamos si solo hay una escalera
		if seccion.entities.count == 1
			if seccion.entities[0].get_attribute "dibac", "escalera2d"
				seccion.set_attribute "dibac", "escalera2d", (seccion.entities[0].get_attribute "dibac", "escalera2d")
				seccion.entities[0].explode
			end	
		end
	end
	if seccion && comando
		seccion.name=''
		Sketchup.active_model.selection.clear
		Sketchup.active_model.selection.add seccion
		Sketchup.send_action "selectMoveTool:"
	end
end	

def SeccionSolida::saca_gruposeccion(entities, trans, grupo, material, dibac)
	grupo_faces=@gruposeccion.entities.add_group
	grupo_edges=@gruposeccion.entities.add_group
	for e in entities
		next if e == @gruposeccion || e==grupo#para que no aplique el material
		mat_grupo=e.material
		mat_grupo=material if !mat_grupo
		entidades=nil # aqui van las entidades que no son grupo ni componente
		carpinteria=nil
		escalera=nil
		if e.is_a?(Sketchup::Group)
			if e.get_attribute("dibac","escalera3d") && dibac #es una escalera
				escalera=e 
			else	
				entidades = e.entities if !e.get_attribute("dibac","escalera2d") #no seccionamos la escalera recien creada comprobar en dibac si es escalera2d
			end
		elsif e.is_a?(Sketchup::ComponentInstance) 
			entidades = e.definition.entities
			if dibac
				if SeccionSolida.es_carpinteria(e)
					carpinteria=e
					entidades=nil
				end
			end
		end if e.visible? && e.layer.visible?
		if entidades
			SeccionSolida.saca_gruposeccion(entidades, trans*e.transformation, grupo, mat_grupo, dibac)
		elsif escalera
			grupo_comprueba = @gruposeccion.entities.add_group
			e.entities.intersect_with true, trans*e.transformation, grupo_comprueba, grupo.transformation, false, grupo
			if grupo_comprueba.entities.count>0 #comporbamos que la escalera es seccionada
				grupo_escalera = @gruposeccion.entities.add_instance(e.entities.parent, trans*e.transformation)
				grupo_escalera.name='escalera'
				punto0=Geom::Point3d.new(0,0,0)
				vector = [punto0, Geom::Vector3d.new(0,0,1)]
				punto1 = Geom.intersect_line_plane(vector, @plane)
				masalto=0
				borrar=[]
				for f in grupo_escalera.entities #borramos todas las que no son horizontales primero
					if f.is_a?(Sketchup::Face)
						if f.plane[2].abs != 1
							borrar.push(f)
							for g in f.edges
								horizontal=false
								for h in g.faces
									horizontal=true if h.plane[2].abs == 1
								end	
								borrar.push(g) if !horizontal
							end
						end
					elsif f.is_a?(Sketchup::Edge)
						borrar.push(f) if f.faces.size == 0
					else
						borrar.push(f)
					end 		
				end
				grupo_escalera.entities.erase_entities(borrar)
				for f in grupo_escalera.entities.grep(Sketchup::Face) #solo deben estar las horizontales
					punto2 = Geom.intersect_line_plane(vector, f.plane)
					altura = (punto0-punto2).length
					dist =  (punto1-punto2)
					grupo_escalera.entities.transform_entities((Geom::Transformation.translation dist), f)
					f.set_attribute "dibac", "escalon",  altura
					masalto=altura if masalto<altura
				end
				grupo_escalera.set_attribute "dibac", "escalera2d", masalto
			end
			@gruposeccion.entities.erase_entities(grupo_comprueba)
		elsif carpinteria
			#comprobamos que hay interseccion
			grupo_comprueba=@gruposeccion.entities.add_group
			e.definition.entities.intersect_with true, trans*e.transformation, grupo_comprueba, grupo.transformation, false, grupo
			if grupo_comprueba.entities.count>0	
#=be			
				if e.definition.name[0,12].upcase == "DIBAC_PUERTA"
					hoja2=e.get_attribute("dynamic_attributes", "a01hoja2",e.definition.get_attribute("dynamic_attributes", "a01hoja2", 0))
					if hoja2 != 0
						pathcarpinteria = Sketchup.find_support_file("DIBAC_PUERTA_DOBLE.skp", "Plugins/iscarnet_dibac")
					else
						pathcarpinteria = Sketchup.find_support_file("DIBAC_PUERTA.skp", "Plugins/iscarnet_dibac")
					end	
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					Sketchup.active_model.start_operation DibacStrings.GetString("Create group Dibac Plan") ,false, true, false
					carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
					v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
					carp.set_attribute("dynamic_attributes", "mocheta", v)
					v=e.get_attribute("dynamic_attributes", "a01hoja1",e.definition.get_attribute("dynamic_attributes", "a01hoja1"))
					carp.set_attribute("dynamic_attributes", "a01hoja1", v)
					v=e.get_attribute("dynamic_attributes", "a01hoja2",e.definition.get_attribute("dynamic_attributes", "a01hoja2"))
					carp.set_attribute("dynamic_attributes", "a01hoja2", v)
					v=e.get_attribute("dynamic_attributes", "a02dintel",e.definition.get_attribute("dynamic_attributes", "a02dintel"))
					carp.set_attribute("dynamic_attributes", "a02dintel", v)
					v=e.get_attribute("dynamic_attributes", "a02gruesoh",e.definition.get_attribute("dynamic_attributes", "a02gruesoh"))
					carp.set_attribute("dynamic_attributes", "a02gruesoh", v)
					v=e.get_attribute("dynamic_attributes", "anchomarco",e.definition.get_attribute("dynamic_attributes", "anchomarco"))
					carp.set_attribute("dynamic_attributes", "anchomarco", v)
					v=e.get_attribute("dynamic_attributes", "gruesmarco",e.definition.get_attribute("dynamic_attributes", "gruesmarco"))
					carp.set_attribute("dynamic_attributes", "gruesmarco", v)
					v=e.get_attribute("dynamic_attributes", "a02alineac",e.definition.get_attribute("dynamic_attributes", "a02alineac"))
					carp.set_attribute("dynamic_attributes", "a02alineac", v)
					$dc_observers.get_latest_class.redraw(carp)
				elsif e.definition.name[0,13].upcase == "DIBAC_VENTANA" #and @h>=1.m
					pathcarpinteria = Sketchup.find_support_file("DIBAC_VENTANA.skp", "Plugins/iscarnet_dibac")
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					v=(e.get_attribute "dynamic_attributes", "a03alfeizar", (e.definition.get_attribute "dynamic_attributes", "a03alfeizar")).to_f
					#if @h>=v-0.03.m #Grueso alfeizar
						Sketchup.active_model.start_operation DibacStrings.GetString("Create group Dibac Plan") ,false, true, false
						carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
						carp.set_attribute("dynamic_attributes", "a03alfeizar", v+e.transformation.origin.z) #por si he subido o bajado la ventana
						v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
						carp.set_attribute("dynamic_attributes", "mocheta", v)
						v=e.get_attribute("dynamic_attributes", "a01ancho",e.definition.get_attribute("dynamic_attributes", "a01ancho"))
						carp.set_attribute("dynamic_attributes", "a01ancho", v)
						v=e.get_attribute("dynamic_attributes", "a02alto",e.definition.get_attribute("dynamic_attributes", "a02alto"))
						carp.set_attribute("dynamic_attributes", "a02alto", v)
						v=e.get_attribute("dynamic_attributes", "a02hojas",e.definition.get_attribute("dynamic_attributes", "a02hojas"))
						carp.set_attribute("dynamic_attributes", "a02hojas", v)
						v=e.get_attribute("dynamic_attributes", "frontalalf",e.definition.get_attribute("dynamic_attributes", "frontalalf"))
						carp.set_attribute("dynamic_attributes", "frontalalf", v)
						v=e.get_attribute("dynamic_attributes", "carpancho",e.definition.get_attribute("dynamic_attributes", "carpancho"))
						carp.set_attribute("dynamic_attributes", "carpancho", v)
						v=e.get_attribute("dynamic_attributes", "carpgrueso",e.definition.get_attribute("dynamic_attributes", "carpgrueso"))
						carp.set_attribute("dynamic_attributes", "carpgrueso", v)
						v=e.get_attribute("dynamic_attributes", "a02alineac",e.definition.get_attribute("dynamic_attributes", "a02alineac"))
						carp.set_attribute("dynamic_attributes", "a02alineac", v)
						$dc_observers.get_latest_class.redraw(carp)
					#end	
				elsif e.definition.name[0,13].upcase == "DIBAC_ARMARIO" #and @h >= 0.07.m
					hojas=(e.get_attribute "dynamic_attributes", "a01hojas", (e.definition.get_attribute "dynamic_attributes", "a01hojas")).to_i
					if hojas == 1
						pathcarpinteria = Sketchup.find_support_file("DIBAC_ARMARIO_1.skp", "Plugins/iscarnet_dibac")
					else
						pathcarpinteria = Sketchup.find_support_file("DIBAC_ARMARIO_2.skp", "Plugins/iscarnet_dibac")
					end	
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					v=(e.get_attribute "dynamic_attributes", "a01umbral",(e.definition.get_attribute "dynamic_attributes", "a01umbral")).to_f
					#if @h>=v
						Sketchup.active_model.start_operation DibacStrings.GetString("Create group Dibac Plan") ,false, true, false
						carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
						carp.set_attribute("dynamic_attributes", "a01umbral", v+e.transformation.origin.z) # Por si hemos subido o bajado el armario
						v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
						carp.set_attribute("dynamic_attributes", "mocheta", v)
						v=e.get_attribute("dynamic_attributes", "a01ancho",e.definition.get_attribute("dynamic_attributes", "a01ancho"))
						carp.set_attribute("dynamic_attributes", "a01ancho", v)
						v=e.get_attribute("dynamic_attributes", "a02dintel",e.definition.get_attribute("dynamic_attributes", "a02dintel"))
						carp.set_attribute("dynamic_attributes", "a02dintel", v)
						carp.set_attribute("dynamic_attributes", "a01hojas", hojas)
						$dc_observers.get_latest_class.redraw(carp)
					#end	
				end
#=en			
				# Ahora corregimos altura
				vector = [carp.transformation.origin, Geom::Vector3d.new(0,0,1)]
				punto = Geom.intersect_line_plane(vector, @plane)
				dist =  (punto-carp.transformation.origin)
				carp.transform!(Geom::Transformation.translation(dist))
			end	
			@gruposeccion.entities.erase_entities(grupo_comprueba)
		end
	end
	if entities
		entities.intersect_with(false, trans, grupo_faces, grupo.transformation, false, grupo)
		entities.intersect_with(false, trans, grupo_edges, grupo.transformation, false, grupo)
	end
	grupo_faces.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
	grupo_edges.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
	grupo_faces.entities.each do |e| 
		if e.is_a?(Sketchup::Face)
			e.reverse! if e.normal != [@plane[0], @plane[1], @plane[2]]
		elsif e.is_a?(Sketchup::Edge)
			grupo_faces.entities.erase_entities(e) if e.faces.size == 0
		end	
	end
	SeccionSolida.sacacaras(grupo_faces, material)
	borrar=[]
	grupo_edges.entities.grep(Sketchup::Edge){|e| borrar.push(e) if e.faces.size>0}
	grupo_edges.entities.erase_entities(borrar)
	lineas=grupo_edges.entities.count
	grupo_edges.explode
	if lineas>0
		@gruposeccion.entities.grep(Sketchup::Edge).each {|e| e.find_faces if e.faces.size==0}
		SeccionSolida.sacacaras(@gruposeccion, material)
	end	
end	

def SeccionSolida::sacacaras(grupo, material)	
	faces = grupo.entities.grep(Sketchup::Face)
	faces = faces.uniq
	caras = []
	while faces.size > 0
		cara = faces[0]
		for face in faces
			cara = face if face.area>cara.area
		end	
		caras.push(cara)
		faces = faces-[cara]
	end	
	for cara in caras
		borrar = true
		for edge in cara.edges
			borrar = false if edge.faces.size == 1
		end
		if borrar
			cara.erase! 
		else
			cara.reverse! if cara.normal != [ @plane[0], @plane[1], @plane[2] ]
			cara.back_material=material
		end	
	end 	
	grupo.explode if (grupo != @gruposeccion && grupo.entities.count == 0)
end
  
def SeccionSolida::face(comando, section, dibac)
	seccion = SeccionSolida.buscaseccion(section)
	return nil if seccion && !comando
	#return nil if !seccion && !@@solidsection
	#DibacLicencia.nolicencia(false)  ####
	 
	model = Sketchup.active_model
	if(Sketchup.version.split(".")[0].to_i<5)
		UI.beep
		UI.messagebox("Sorry.  This is Version 5+ program only !")
		return nil
	end
	bounds = model.bounds
	entities = model.active_entities
	ss = model.selection
	view = model.active_view
	@plane = section.get_plane
	bmin  = bounds.min
	bmax  = bounds.max
	c1 = Geom::Point3d.new(bmin.x, bmin.y, bmin.z)
	c2 = Geom::Point3d.new(bmax.x, bmin.y, bmin.z)
	c3 = Geom::Point3d.new(bmin.x, bmin.y, bmax.z)
	c4 = Geom::Point3d.new(bmax.x, bmin.y, bmax.z)
	c5 = Geom::Point3d.new(bmin.x, bmax.y, bmax.z)
	c6 = Geom::Point3d.new(bmax.x, bmax.y, bmax.z)
	c7 = Geom::Point3d.new(bmin.x, bmax.y, bmin.z)
	c8 = Geom::Point3d.new(bmax.x, bmax.y, bmin.z)
	line1 = [c1,(c1-c2)]
	line2 = [c3,(c3-c4)]
	line3 = [c5,(c5-c6)]
	line4 = [c7,(c7-c8)]
	line5 = [c1,(c1-c3)]
	line6 = [c2,(c2-c4)]
	line7 = [c7,(c7-c5)]
	line8 = [c8,(c8-c6)]
	line9 = [c1,(c1-c7)]
	line10 = [c3,(c3-c5)]
	line11 = [c4,(c4-c6)]
	line12 = [c2,(c2-c8)]
	p1 = Geom.intersect_line_plane line1, @plane
	p2 = Geom.intersect_line_plane line2, @plane
	p3 = Geom.intersect_line_plane line3, @plane
	p4 = Geom.intersect_line_plane line4, @plane
	p5 = Geom.intersect_line_plane line5, @plane
	p6 = Geom.intersect_line_plane line6, @plane
	p7 = Geom.intersect_line_plane line7, @plane
	p8 = Geom.intersect_line_plane line8, @plane
	p9 = Geom.intersect_line_plane line9, @plane
	p10 = Geom.intersect_line_plane line10, @plane
	p11 = Geom.intersect_line_plane line11, @plane
	p12 = Geom.intersect_line_plane line12, @plane
	if dibac
		e = SeccionSolida.primera_carpinteria(entities)
		$dc_observers.get_latest_class.redraw_with_undo(e) if e
	end
	if !comando
		model.start_operation DibacStrings.GetString("Solid Section") ,true, true, true 
	else		
		model.start_operation comando ,false, true, false
	end	
	grupo = entities.add_group
	if p1 # No z 
		face = grupo.entities.add_face p1,p2,p3,p4
	elsif  p5 # en z
		face = grupo.entities.add_face p5,p6,p8,p7
	else
		face = grupo.entities.add_face p9,p10,p11,p12,p9
	end
	#	inicioundo("Seccion Solida")	
	@gruposeccion= entities.add_group
	@gruposeccion.name= "SS-"+section.entityID.to_s
	section.set_attribute('SolidSection', 'seccion', @gruposeccion.name) if !comando
	@@secciones[section]=@gruposeccion
# 	ahora recorremos el modelo desde fuera hacia dentro haciendo las intersecciones dentro de los grupos
	SeccionSolida.saca_gruposeccion(entities, grupo.transformation, grupo, nil, dibac)
	#entities.intersect_with true, grupo.transformation, gruposeccion, grupo.transformation, false, grupo
	#for e in @gruposeccion.entities
	#	if e.is_a?(Sketchup::Edge)
	#		e.find_faces
	#	end
	#end 
=begin	
	faces = @gruposeccion.entities.grep(Sketchup::Face)
	faces = faces.uniq
	caras = []
	while faces.size > 0
		cara = faces[0]
		for face in faces
			cara = face if face.area>cara.area
		end	
		caras.push(cara)
		faces = faces-[cara]
	end	
	for cara in caras
		borrar = true
		for edge in cara.edges
			borrar = false if edge.faces.size == 1
		end
		if borrar
			cara.erase! 
		else
			cara.reverse! if cara.normal != [ @plane[0], @plane[1], @plane[2] ]
		end	
	end 
=end	#esto lo pasamos a saca_gruposeccion
	if @gruposeccion.entities.count > 0
		grupo.erase! 
		# 	desplazamos la seccion 1 decima de milimetro
		vector=Geom::Vector3d.new(@plane[0],@plane[1],@plane[2])
		tpoint=ORIGIN.offset(vector,0.1.mm)
		transf = Geom::Transformation.new tpoint
		@gruposeccion.move! transf
	#else
	end
# 	finalundo
	#model.commit_operation
	Sketchup.active_model.start_operation "", false, false, false
	view.invalidate
	 if @gruposeccion.entities.count > 0
		return(@gruposeccion)
	end	
	grupo.name="SS-"+section.entityID.to_s
	@@secciones[section]=grupo
	grupo.visible=false
	return grupo
	return nil
end	

def SeccionSolida::valida
	model = Sketchup.active_model
	ss = model.selection
	return ss[0] if !ss.empty? && ss[0].is_a?(Sketchup::SectionPlane)
end 

def SeccionSolida::iniciosecciones
	#Sketchup.active_model.active_entities.add_observer(SS_ObservadorEntities.new)
	for e in Sketchup.active_model.active_entities.grep(Sketchup::SectionPlane)
		e.add_observer(Dibac_ObservadorSeccion.new)
		seccion = SeccionSolida.buscaseccion(e)
		if seccion
			seccion.name="SS-"+e.entityID.to_s
			e.set_attribute('SolidSection', 'seccion', seccion.name)
			@@secciones[e]=seccion
		end	
	end	
end	

def SeccionSolida::buscaseccion(seccion)
	for e in Sketchup.active_model.active_entities.grep(Sketchup::Group)
		 return e if (e.name == seccion.get_attribute('SolidSection', 'seccion') || e.name == "SS-"+seccion.entityID.abs.to_s)
	end if seccion && !seccion.deleted?
	return nil
end	

end # de la clase SeccionSolida
=begin
class Dibac_Hojacalculo < Dibac_Base

def initialize
	Sketchup.active_model.select_tool(nil)
	p = Axlsx::Package.new
	wb = p.workbook
	blue_cell=nil
	wb.styles{|s| blue_cell =  s.add_style  :bg_color => "DD", :fg_color => "000055", :sz => 12, :alignment => { :horizontal=> :center }}
	styles = wb.styles
	uds = styles.add_style :alignment => {:vertical => :top}, :border => Axlsx::STYLE_THIN_BORDER
	
	wrap_text = styles.add_style ({:alignment => {:horizontal => :left, :vertical => :top, :wrap_text => true}})
	epi_text = styles.add_style ({:alignment => {:horizontal => :justify, :vertical => :top, :wrap_text => true}})
	money = styles.add_style :format_code => '###,###,###,##0.00 €', :border => Axlsx::STYLE_THIN_BORDER
    wb.add_worksheet(:name => "Dibac Report") do |sheet|
		# Aplicamos el estilo a la primera fila
		sheet.add_row ["Uds.", "Descripción", "Propiedades", "Precio", "Importe"], :style => blue_cell
		Sketchup.active_model.definitions.each do |d|
			@carp=d.get_attribute('dibac','2d')
			@carp=d.get_attribute('dibac','3d') if !@carp
			unidades=d.instances.size
			if @carp && unidades>0
				nombre=@carp[0]	
				saca_menumenu(d)
				linea=""
				@carp_attributes.each do |a|
					linea=linea+@carp_prompts[a]+'='+@carp_defaults[a].to_s+"\n"
				end
				epigrafe=Axlsx::RichText.new
				epigrafe.add_run(d.name, :b => true)
				epigrafe.add_run("\n"+@carp_epigrafe) if @carp_epigrafe
				precio=d.name.size*15.28
				sheet.add_row [unidades, epigrafe, linea, precio,unidades*precio], :style => [uds, epi_text, wrap_text, money, money]
			end
		end
		sheet.column_widths 5, 50, 30, 15, 20
    end
	#archivo = UI.savepanel(DibacStrings.GetString("Save xlsx file") , File.dirname(Sketchup.active_model.name) ,"xlsx files|*.xlsx||") 
	archivo=@@current_path+'/prueba.xlsx'
	if archivo
		p.serialize(archivo)
		wd=UI::WebDialog.new(DibacStrings.GetString("Probando")+'...')
		wd.set_url(archivo)
		wd.show
		wd.close
	end
end
end # de la clase Dibac_Hojacalculo
=end

#Sketchup.extensions.each{|e| Iscarnet_Dibac=e if e.name=='Dibac'}
Iscarnet_Dibac=Dibac #La  linea anterior dejo de funcionar en 2016

MAC=Mac.mac
WIN=Mac.win

RITKONSULT=false

DibacStrings = Dibac_Lenguaje.new
DibacLicencia = Dibac_Licencia.new
DibacMac = Mac.address
#Iscarnet_Dibac.description=Iscarnet_Dibac.description+'#'+DibacMac

module_function

#def seccion; @seccion end
#def seccion= v; @seccion = v end
#def borrar; @borrar end
#def borrar= v; @borrar = v end


@paths=[Sketchup.active_model.active_entities]
def paths; @paths end
def paths= v; @paths.push(v) end
def paths! ; @paths=[Sketchup.active_model.active_entities] end

@cambio_view=false
def cambio_view; @cambio_view end
def cambio_view= v; @cambio_view=v end



#Esquema del archivo
def lista(entities, html)
	ol=false
	entities.grep(Sketchup::Group).each do |g|
		html << '<ol>' if !ol
		ol=true
		html << '<li><label for="'+g.entityID.to_s+'">'+DibacStrings.GetString("Group")+':'+g.entityID.to_s+'</label> <input type="checkbox" id="'+g.entityID.to_s+'" />'
		html = lista(g.entities, html)	 #recursivo
		html << "</li>"
	end
	entities.grep(Sketchup::ComponentInstance).each do |g|
		html << '<ol>' if !ol
		ol=true
		html << '<li><label for="'+g.entityID.to_s+'">'+ DibacStrings.GetString("ComponentInstance")+": "+g.entityID.to_s+"("+g.definition.name+")"+'</label> <input type="checkbox" id="'+g.entityID.to_s+'" />'
		html = lista(g.definition.entities, html)	 #recursivo
		html << "</li>"
	end
	html << '</ol>' if ol
	return(html)
end

#Esquema
Sketchup.active_model.name='Untitled' if Sketchup.active_model.name==''
@esquema=UI::WebDialog.new(DibacStrings.GetString ("Model Tree"))
@esquema.set_size(300,400)
@esquema.set_position(600,200)
def esquema!

titulo=Sketchup.active_model.title
titulo=DibacStrings.GetString('Untitled') if titulo==''
css_file=@@current_path+'/html/DHTMLX/dhtmlxtree.css'
js_file=@@current_path+'/html/DHTMLX/dhtmlxtree.js'
img_path='imgs/dhxtree_skyblue/'

main_file=@@current_path+'/html/DHTMLX/inithtml.html'

html=<<-EOS
<!DOCTYPE html>
<html>
<head>
	<title>Initialize from HTML</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>
	<link rel="stylesheet" type="text/css" href="#{css_file}"/>
	<script src="#{js_file}"></script>
</head>
<body>
	<div class="h3">Initialize from list</div>
	<table>
		<tr>
			<td>
				<div id="treeboxbox_tree" setImagePath="#{img_path}" class="dhtmlxTree" style="width:auto; height:auto; background-color:#f5f5f5;border :1px solid Silver; ">
					<ul>
						<li>Root
							<ul>
								<li>Child1
								<ul>
									<li>Child 1-1</li>
								</ul>
								</li>
								<li>Child2</li>
								<li><b>Bold</b> <i>Italic</i></li>
							</ul>
						</li>
					</ul>
				</div>
			</td>
		</tr>
	</table>
</body>
</html>
EOS

#html = lista(Sketchup.active_model.entities, html)


#html = lista(Sketchup.active_model.entities, html)

#@esquema.set_html(html)
end

def esquema; @esquema end


DibacHoraInicio = Time.now

Dibac_Inicio.new

end # del modulo Dibac_Extensions
end # del modulo Iscarnet_Extensions